/*
 * Created on Sep 1, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.curso;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;

import br.unicamp.nied.teleduc.extrator.config.Config;
import br.unicamp.nied.teleduc.extrator.database.ConnectionFactory;
import br.unicamp.nied.teleduc.extrator.database.DBException;
import br.unicamp.nied.teleduc.extrator.ferramentas.acessos.ExtratorAcessos;
import br.unicamp.nied.teleduc.extrator.ferramentas.agenda.ExtratorAgenda;
import br.unicamp.nied.teleduc.extrator.ferramentas.atividades.ExtratorAtividades;
import br.unicamp.nied.teleduc.extrator.ferramentas.avaliacao.ExtratorAvaliacao;
import br.unicamp.nied.teleduc.extrator.ferramentas.batepapo.ExtratorBatePapo;
import br.unicamp.nied.teleduc.extrator.ferramentas.correio.ExtratorCorreio;
import br.unicamp.nied.teleduc.extrator.ferramentas.diario.ExtratorDiario;
import br.unicamp.nied.teleduc.extrator.ferramentas.dinamica.ExtratorDinamica;
import br.unicamp.nied.teleduc.extrator.ferramentas.forum.ExtratorForum;
import br.unicamp.nied.teleduc.extrator.ferramentas.grupos.ExtratorGrupos;
import br.unicamp.nied.teleduc.extrator.ferramentas.leituras.ExtratorLeituras;
import br.unicamp.nied.teleduc.extrator.ferramentas.material.ExtratorMaterial;
import br.unicamp.nied.teleduc.extrator.ferramentas.menu.ExtratorMenu;
import br.unicamp.nied.teleduc.extrator.ferramentas.mural.ExtratorMural;
import br.unicamp.nied.teleduc.extrator.ferramentas.parada.ExtratorParada;
import br.unicamp.nied.teleduc.extrator.ferramentas.perfil.ExtratorPerfil;
import br.unicamp.nied.teleduc.extrator.ferramentas.perguntasfrequentes.ExtratorPerguntas;
import br.unicamp.nied.teleduc.extrator.ferramentas.portfolio.ExtratorPortfolio;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;

/**
 * @author leonel
 *
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class Curso {
    private int     codCurso;
    private String  nomeCurso;
    private String  baseCurso;
    private String  baseGeral;
    private String  caminhoArquivos;
    private boolean exibirCoordenador;

    public Curso() {

    }

    public Curso(int pCodCurso) {
        codCurso = pCodCurso;

        try {
            nomeCurso = buscaNomeCurso();
            baseGeral = getTelEducdb();
            baseCurso = getCursoDb();
            caminhoArquivos = retornaCaminho();
            exibirCoordenador = verificaExibicaoCoordenador();
        } catch (ExtractionException e) {
            e.printStackTrace();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (DBException e) {
            e.printStackTrace();
        }
    }

    /**
     * Verifica se o coordenador deve ser exibido como coordenador do curso ou
     * se deve ser exibido como um simples formador.
     *
     * @return true se o coordenador for exibido como coordenador, false se for
     *         exibido como formador.
     * @throws IOException
     * @throws DBException
     * @throws SQLException
     */
    private boolean verificaExibicaoCoordenador() throws DBException,
            IOException {
        Connection        conn = null;
        PreparedStatement stmt = null;
        ResultSet         rs   = null;
        try {
            conn = ConnectionFactory.getConnectionFactory()
                    .getConnection(this.getBaseCurso());
            stmt = conn.prepareStatement(
                    "select valor from Config where item='status_coordenador'");
            rs   = stmt.executeQuery();
            if (! rs.next()) {
                return true;
            }
            char status = rs.getString("valor").charAt(0);

            /*
             * O status pode assumir os valores:
             * 'C' - O coordenador deve ser exibido como coordenador
             *          retorne true
             * 'F' - O coordenador deve ser exibido como formador
             *          retorne false
             */
            return status == 'C';
        } catch (SQLException sqlex) {
            sqlex.printStackTrace();
            throw new DBException(
                    "Erro ao verificar status do formador no curso", sqlex);
        } finally {
            if (rs != null) {
                try {
                    rs.close();
                } catch (SQLException sqlex) {
                    sqlex.printStackTrace();
                }
            }

            if (stmt != null) {
                try {
                    stmt.close();
                } catch (SQLException sqlex) {
                    sqlex.printStackTrace();
                }
            }
        }
    }

    public int getCodCurso() {
        return codCurso;
    }

    public void setCodCurso(int codCurso) {
        this.codCurso = codCurso;
    }

    /**
     * @return Returns the nomeCurso.
     */
    public String getNomeCurso() {
        return nomeCurso;
    }

    /**
     * @return Returns the bd.
     */
    public String getBaseCurso() {
        return baseCurso;
    }

    /**
     * @return Returns the baseGeral.
     */
    public String getBaseGeral() {
        return baseGeral;
    }

    /**
     * @return Returns the caminhoArquivos.
     */
    public String getCaminhoArquivos() {
        return caminhoArquivos;
    }

    public Collection retornaExtratores(Curso curso, Usuario usuario) throws DBException, IOException, SQLException {
        Collection extratores = new ArrayList();

        if (verificaFerramenta("agenda"))
            extratores.add(new ExtratorAgenda(curso, usuario));

        if (verificaFerramenta("atividades"))
            extratores.add(new ExtratorAtividades(curso, usuario));

        if (verificaFerramenta("avaliacoes"))
            extratores.add(new ExtratorAvaliacao(curso,usuario));

        if (verificaFerramenta("batepapo"))
            extratores.add(new ExtratorBatePapo(curso, usuario));

        if (verificaFerramenta("correio"))
            extratores.add(new ExtratorCorreio(curso, usuario));

        if (verificaFerramenta("diario"))
            extratores.add(new ExtratorDiario(curso, usuario));

        if (verificaFerramenta("dinamica"))
            extratores.add(new ExtratorDinamica(curso, usuario));

        if (verificaFerramenta("forum"))
            extratores.add(new ExtratorForum(curso,usuario));

        if (verificaFerramenta("grupos"))
            extratores.add(new ExtratorGrupos(curso, usuario));

        if (verificaFerramenta("leituras"))
            extratores.add(new ExtratorLeituras(curso,usuario));

        if (verificaFerramenta("material"))
            extratores.add(new ExtratorMaterial(curso, usuario));

        if (verificaFerramenta("mural"))
            extratores.add(new ExtratorMural(curso, usuario));

        if (verificaFerramenta("parada"))
            extratores.add(new ExtratorParada(curso, usuario));

        if (verificaFerramenta("perguntas"))
            extratores.add(new ExtratorPerguntas(curso,usuario));

        if (verificaFerramenta("portfolio"))
            extratores.add(new ExtratorPortfolio(curso, usuario));

        if (verificaFerramenta("acessos"))
            extratores.add(new ExtratorAcessos(curso, usuario));

        if (verificaFerramenta("perfil"))
            extratores.add(new ExtratorPerfil(curso, usuario));

        extratores.add(new ExtratorMenu(curso, usuario));

        return extratores;
    }

    /**
     * consulta o campo extract.baseCurso no arquivo .properties e gera o nome
     * da base do curso que esta sendo extraido no momento.
     *
     * @return String contendo o nome do curso sendo extraido no momento.
     * @throws IOException
     */
    private String getCursoDb() throws IOException {
        Config config = Config.getConfig();
        String CursoDb = (String) config.getProperties().get("extract.baseCurso");
        return (CursoDb + this.codCurso);
    }

    /**
     * Pega o nome da Base do Ambiente no arquivo .properties.
     *
     * @return String contendo o campo extract.BaseAmbiente no arquivo
     *         extrator.properties.
     * @throws IOException
     * @throws FileNotFoundException
     */
    private String getTelEducdb() throws IOException, FileNotFoundException {
        Config config = Config.getConfig();
        String TelEducdb = (String) config.getProperties()
                .get("extract.baseAmbiente");
        return TelEducdb;
    }

    private String retornaCaminho() {
        String caminho = null;

        try {
            String TelEducdb = getBaseGeral();
            ConnectionFactory conFac = ConnectionFactory.getConnectionFactory();
            Connection con = conFac.getConnection(TelEducdb);
            String sql = "select diretorio from Diretorio where item = 'arquivos'";
            PreparedStatement ps = con.prepareStatement(sql);
            ResultSet rs = ps.executeQuery();

            if (rs.next()) {
                caminho = rs.getString("diretorio");
                caminho += "/" + getCodCurso();
            }
        } catch (SQLException e) {
            e.printStackTrace();
        } catch (DBException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return caminho;
    }

    /**
     * Verifica se o coordenador do curso deve ser exibido como coordenador ou
     * se deve aparecer com o ttulo de formador.
     *
     * @return
     */
    public boolean exibirCoordenador() {
        return this.exibirCoordenador;
    }

    /**
     * @param nomeCurso
     *            The nomeCurso to set.
     * @return
     * @throws ExtractionException
     */
    private String buscaNomeCurso() throws ExtractionException {
        PreparedStatement ps = null;
        ResultSet rs = null;
        String nome = null;

        try {
            ConnectionFactory connFac = ConnectionFactory
                    .getConnectionFactory();
            Config config = Config.getConfig();
            String baseAmbiente = (String) config.getProperties()
                    .get("extract.baseAmbiente");
            Connection con = connFac.getConnection(baseAmbiente);

            String sql = "Select nome_curso from Cursos where cod_curso = "
                    + this.codCurso;
            ps = con.prepareStatement(sql);
            rs = ps.executeQuery();
            if (rs.next())
                nome = rs.getString("nome_curso");
            else
                throw new ExtractionException(
                        "Erro ao buscar nome do curso na base");
        } catch (DBException dbex) {
            throw new ExtractionException(
                    "Erro ao buscar nome do curso na base.", dbex);
        } catch (IOException ioex) {
            throw new ExtractionException(
                    "Erro ao buscar nome do curso na base.", ioex);
        } catch (SQLException sqlex) {
            throw new ExtractionException(
                    "Erro ao buscar nome do curso na base.", sqlex);
        } finally {
            if (rs != null) {
                try {
                    rs.close();
                } catch (SQLException sqlex) {
                    sqlex.printStackTrace();
                }
            }
            if (ps != null) {
                try {
                    ps.close();
                } catch (SQLException sqlex) {
                    sqlex.printStackTrace();
                }
            }
        }
        return nome;
    }

    private boolean verificaFerramenta(String ferramenta) throws DBException, IOException, SQLException {

        ConnectionFactory connFac = ConnectionFactory.getConnectionFactory();
        Connection conn = connFac.getConnection(baseGeral);

        String sql = "select " + ferramenta + " from Extracoes_agendadas where extraido=0 order by data limit 1";

        PreparedStatement stmt = conn.prepareStatement(sql);
        ResultSet rs = stmt.executeQuery();

        while (rs.next()) {
            if (rs.getInt(ferramenta) == 1)
                return true;
        }

        return false;
    }

    public int hashCode() {
        return this.codCurso;
    }

    public boolean equals(Object obj) {
        if (obj instanceof Curso) {
            Curso c = (Curso) obj;
            return c.codCurso == this.codCurso;
        }
        return false;
    }
}