/*
 * Created on Sep 1, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.database;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import br.unicamp.nied.teleduc.extrator.config.Config;

/**
 * @author leonel
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ConnectionFactory {
    private static ConnectionFactory instance    = null;
    private static Properties 		 properties  = new Properties();
    private static Map               connections = new HashMap();

    private ConnectionFactory() throws DBException {
        try {
            Class.forName("com.mysql.jdbc.Driver");
        } catch (Exception ex) {
            throw new DBException("Could not load Driver", ex);
        }
    }

    public static ConnectionFactory getConnectionFactory()
        throws DBException, IOException {
        if (ConnectionFactory.instance == null) {
            // Singleton pattern. nica instncia do Factory
            ConnectionFactory.instance = new ConnectionFactory();

            Config config = Config.getConfig();
            // Pegar as propriedades que interessam do properties, e criar
            // um properties somente para a conexao
            String user = (String) config.getProperties().get("bd.user");
            String password = (String) config.getProperties().get("bd.password");
            String server = (String) config.getProperties().get("bd.server");
            String port = (String) config.getProperties().get("bd.port");

            ConnectionFactory.properties.put("user", user);
            ConnectionFactory.properties.put("password", password);
            ConnectionFactory.properties.put("server", server);
            ConnectionFactory.properties.put("port", port);
            config = null;
        }
        return ConnectionFactory.instance;
    }

    public Connection getConnection(String database) throws DBException {
        Connection conn =
            (Connection) ConnectionFactory.connections.get(database);
        if (conn != null) {
            return conn;
        } else {
            try {
                String server   =
                    (String) ConnectionFactory.properties.get("server");
                String port     =
                    (String) ConnectionFactory.properties.get("port");
                /*
                 * String user     =
                 *	(String) ConnectionFactory.properties.get("user");
                 * String password =
                 *	(String) ConnectionFactory.properties.get("password");
                  */

                String url = "jdbc:mysql://" +server+ ":"+ port +"/"+ database;
                conn = DriverManager.getConnection(
                    url, ConnectionFactory.properties.getProperty("user"), ConnectionFactory.properties.getProperty("password"));
                connections.put(database, conn);

//                conn = DriverManager.getConnection(
//                        url, ConnectionFactory.properties);
//                    connections.put(database, conn);

                return conn;
            } catch (SQLException ex) {
                DBException exception = new DBException(
                    "Could not connect do database [" + database + "]",
                    ex);
                throw exception;
            }
        }
    }

    /**
     * Calcula o nmero de linhas retornado do BD dentro um ResultSet.
     * Este mtodo coloca o cursor aps o ltimo registro, verifica o nmero do registro, e devolve
     * o curso para onde estava antes. Assim:
     * <code>
     * rs.afterLast();
     * int tamanho = rs.getRow();
     * rs.absolute(ultimaPosicao);
     * </code>
     *
     * @param rs
     * @return
     * @throws SQLException
     */
    public static int numeroDeLinhas(ResultSet rs) throws SQLException {
        int ultimaPosicao = rs.getRow();
        rs.afterLast();
        rs.previous();
        int tamanho = rs.getRow();
        if (ultimaPosicao > 0) {
            rs.absolute(ultimaPosicao);
        } else {
            rs.beforeFirst();
        }
        return tamanho;
    }
}
