/*
 * Created on Feb 16, 2005
 *
 */
package br.unicamp.nied.teleduc.extrator.ferramentas;

import java.io.IOException;

import br.unicamp.nied.teleduc.extrator.config.Config;
import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;

/**
 * @author leonel
 *
 * Esta classe contm mtodos para gerao de String que sero usadas
 * como nomes de diretrios.
 */
public class ArquivoTool {

    /**
     *
     */
    public ArquivoTool() {
        super();
    }

    /**
     * Este mtodo padroniza o prefixo dos diretrios que sero criados para
     * armazenar os arquivos da extrao do curso. Adicione o sufixo desejado
     * ao retorno. Exemplo:
     * <code>
     * String s = ArquivoTool.montaCaminhoDestino(curso, usuario);
     * s += "html";
     * </code>
     * ou
     * <code>
     * String s = ArquivoTool.montaCaminhoDestino(curso, usuario);
     * s += "arquivos"
     * </code>
     *
     * @param curso Curso que est sendo extrado.
     * @param usuario Usurio que est realizando a extrao.
     * @param String String com o nome da ferramenta da qual copiar os arquivos.
     * @return String com o diretrio de gerao dos arquivos
     * @throws IOException
     */
    public static String montaCaminhoDestino(Curso curso, Usuario usuario)
            throws IOException {
        String caminhoDestino;
        Config config = Config.getConfig();
        caminhoDestino = (String) config.getProperties()
                .get("extract.outputPath");
        caminhoDestino += "/"
                + limpaCharsAcentuados(curso.getNomeCurso()) + "/"
                + limpaCharsAcentuados(usuario.getNome())    + "/";
        return caminhoDestino;
    }

    /**
     *
     * @param s
     * @return
     */
    public static String limpaCharsAcentuados(String s) {
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < s.length(); i++) {
            char c = s.charAt(i);
            switch (c) {
                case '' :        /* falls through */
                case '' :        /* falls through */
                case '' :        /* falls through */
                case '' :        /* falls through */
                case '' :        /* falls through */
                case '' :        /* falls through */
                case '' :        /* falls through */
                case '' :        /* falls through */
                    sb.append('a');
                    break;

                case '' :        /* falls through */
                case '' :        /* falls through */
                case '' :        /* falls through */
                case '' :        /* falls through */
                case '' :        /* falls through */
                case '' :        /* falls through */
                    sb.append('A');
                    break;

                case '' :
                    sb.append('c');
                    break;
                case '' :
                    sb.append('C');
                    break;

                case '' :         /* falls through */
                case '' :         /* falls through */
                case '' :         /* falls through */
                case '' :         /* falls through */
                    sb.append('e');
                    break;

                case '' :         /* falls through */
                case '' :         /* falls through */
                case '' :         /* falls through */
                case '' :         /* falls through */
                    sb.append('e');
                    break;

                case '' :         /* falls through */
                case '' :         /* falls through */
                    sb.append('i');
                    break;

                case '' :         /* falls through */
                case '' :         /* falls through */
                    sb.append('I');
                    break;

                case '' :         /* falls through */
                case '' :         /* falls through */
                case '' :         /* falls through */
                case '' :         /* falls through */
                case '' :         /* falls through */
                    sb.append('o');
                    break;

                case '' :         /* falls through */
                case '' :         /* falls through */
                case '' :         /* falls through */
                case '' :         /* falls through */
                case '' :         /* falls through */
                    sb.append('O');
                    break;

                case '' :         /* falls through */
                    sb.append('B');
                    break;

                case '' :         /* falls through */
                case '' :         /* falls through */
                case '' :         /* falls through */
                case '' :         /* falls through */
                    sb.append('u');
                    break;

                case '' :         /* falls through */
                case '' :         /* falls through */
                case '' :         /* falls through */
                case '' :         /* falls through */
                    sb.append('U');
                    break;

                default:
                    if (Character.isSpaceChar(c) || c == '/') {
                        sb.append('_');
                    } else if ( '0' <= c && c <= '9') {
                        sb.append(c);
                    } else if (c > 255) {
                        sb.append('_');
                    } else {
                        sb.append(c);
                    }
            }
        }
        return sb.toString();
    }
}
