/*
 * Created on Feb 24, 2005
 *
 */
package br.unicamp.nied.teleduc.extrator.ferramentas;

import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

/**
 * @author leonel
 *
 */
public class CalendarTool {
    private GregorianCalendar calendar;
    /**
     *
     */
    public CalendarTool() {
        this.calendar = new GregorianCalendar();
    }

    public boolean isSunday(Date d) {
        if (d == null) {
            throw new IllegalArgumentException("A data no pode ser null");
        }
        this.calendar.setTime(d);
        return this.calendar.get(Calendar.DAY_OF_WEEK) == Calendar.SUNDAY;
    }

    public boolean isSaturday(Date d) {
        if (d == null) {
            throw new IllegalArgumentException("A data no pode ser null");
        }
        this.calendar.setTime(d);
        return this.calendar.get(Calendar.DAY_OF_WEEK) == Calendar.SATURDAY;
    }

    /**
     * Retorna um objeto Date representando a zero-hora do mesmo dia de d
     *
     * @param d
     * @return
     */
    public Date zeroHora(Date d) {
        this.calendar.setTime(d);
        setZeroHora(this.calendar);
        return this.calendar.getTime();
    }

    public void setZeroHora(Calendar calendar) {
        calendar.set(Calendar.HOUR_OF_DAY, 0);
        calendar.set(Calendar.MINUTE, 0);
        calendar.set(Calendar.SECOND, 0);
        calendar.set(Calendar.MILLISECOND, 0);
    }

    public Date hora23(Date d) {
        this.calendar.setTime(d);
        setHora23(calendar);
        return this.calendar.getTime();
    }

    public void setHora23(Calendar calendar) {
        calendar.set(Calendar.HOUR_OF_DAY, 23);
        calendar.set(Calendar.MINUTE, 59);
        calendar.set(Calendar.SECOND, 59);
        calendar.set(Calendar.MILLISECOND, 999);
    }

    public String dayOfMonth(Date d) {
        if (d == null) {
            throw new IllegalArgumentException("A data no pode ser null");
        }
        this.calendar.setTime(d);
        int day = this.calendar.get(Calendar.DAY_OF_MONTH);
        String ret = Integer.toString(day);
        if (day < 10) {
            ret = "0" + ret;
        }
        return ret;
    }
}
