/*
 * Created on Feb 28, 2005
 *
 */
package br.unicamp.nied.teleduc.extrator.ferramentas;

/**
 * @author leonel
 *
 */
public class FerramentaTool {
    public static final byte ENTRADA_NO_AMBIENTE    =  0;
    public static final byte AGENDA                 =  1;
    public static final byte ATIVIDADES             =  3;
    public static final byte MATERIAL               =  4;
    public static final byte LEITURAS               =  5;
    public static final byte PERGUNTAS_FREQUENTES   =  6;
    public static final byte PARADA_OBRIGATORIA     =  7;
    public static final byte MURAL                  =  8;
    public static final byte FORUNS                 =  9;
    public static final byte BATEPAPO               = 10;
    public static final byte CORREIO                = 11;
    public static final byte GRUPOS                 = 12;
    public static final byte PERFIL                 = 13;
    public static final byte DIARIO                 = 14;
    public static final byte PORTFOLIO              = 15;
    public static final byte DINAMICA               = 16;
    public static final byte ESTRUTURA_DO_AMBIENTE  = 17;
    public static final byte ACESSOS                = 18;
    public static final byte INTERMAP               = 19;
    public static final byte AVALIACOES             = 22;
    public static final byte EXERCICIOS             = 23;

    /**
     *
     */
    public FerramentaTool() {
        super();
    }

    public boolean isEntrada(byte ferramenta) {
        return ferramenta == ENTRADA_NO_AMBIENTE;
    }

    public String nomeFerramenta(int ferramenta) {
        switch (ferramenta) {
            case FerramentaTool.ENTRADA_NO_AMBIENTE    : return "Entrada no Ambiente";
            case FerramentaTool.AGENDA                 : return "Agenda";
            case FerramentaTool.ATIVIDADES             : return "Atividades";
            case FerramentaTool.MATERIAL               : return "Material de apoio";
            case FerramentaTool.LEITURAS               : return "Leituras";
            case FerramentaTool.PERGUNTAS_FREQUENTES   : return "Perguntas Freqentes";
            case FerramentaTool.PARADA_OBRIGATORIA     : return "Parada Obrigatria";
            case FerramentaTool.MURAL                  : return "Mural";
            case FerramentaTool.FORUNS                 : return "Fruns de Discusso";
            case FerramentaTool.BATEPAPO               : return "Bate-papo";
            case FerramentaTool.CORREIO                : return "Correio";
            case FerramentaTool.GRUPOS                 : return "Grupos";
            case FerramentaTool.PERFIL                 : return "Perfil";
            case FerramentaTool.DIARIO                 : return "Dirio de bordo";
            case FerramentaTool.PORTFOLIO              : return "Portflio";
            case FerramentaTool.DINAMICA               : return "Dinmica do curso";
            case FerramentaTool.ESTRUTURA_DO_AMBIENTE  : return "Estrutura do Ambiente";
            case FerramentaTool.ACESSOS                : return "Acessos";
            case FerramentaTool.INTERMAP               : return "Intermap";
            case FerramentaTool.AVALIACOES             : return "Avaliaes";
            case FerramentaTool.EXERCICIOS             : return "Exerccios";
            default: throw new IllegalArgumentException("Cdigo de ferramenta invlido");
        }
    }

    public static String diretorioFerramenta(int ferramenta) {
        switch (ferramenta) {
            case FerramentaTool.ENTRADA_NO_AMBIENTE    : return "entrada";
            case FerramentaTool.AGENDA                 : return "agenda";
            case FerramentaTool.ATIVIDADES             : return "atividades";
            case FerramentaTool.MATERIAL               : return "material";
            case FerramentaTool.LEITURAS               : return "leituras";
            case FerramentaTool.PERGUNTAS_FREQUENTES   : return "perguntas";
            //case FerramentaTool.PARADA_OBRIGATORIA     : return "obrigatoria";
            case FerramentaTool.PARADA_OBRIGATORIA     : return "parada";
            case FerramentaTool.MURAL                  : return "mural";
            case FerramentaTool.FORUNS                 : return "forum";
            case FerramentaTool.BATEPAPO               : return "batepapo";
            case FerramentaTool.CORREIO                : return "correio";
            case FerramentaTool.GRUPOS                 : return "grupos";
            case FerramentaTool.PERFIL                 : return "perfil";
            case FerramentaTool.DIARIO                 : return "diario";
            case FerramentaTool.PORTFOLIO              : return "portfolio";
            case FerramentaTool.DINAMICA               : return "dinamica";
            case FerramentaTool.ESTRUTURA_DO_AMBIENTE  : return "estrutura";
            case FerramentaTool.ACESSOS                : return "acessos";
            case FerramentaTool.INTERMAP               : return "intermap";
            //case FerramentaTool.AVALIACOES             : return "avaliacao";
            case FerramentaTool.AVALIACOES             : return "avaliacoes";
            //case FerramentaTool.EXERCICIOS             : return "exerccios";
            case FerramentaTool.EXERCICIOS             : return "exercicios";
            default: throw new IllegalArgumentException("Cdigo de ferramenta invlido");
        }
    }

    public byte[] geraIdFerramentas() {
        byte[] idFerramenta = {
                FerramentaTool.ENTRADA_NO_AMBIENTE,
                FerramentaTool.ESTRUTURA_DO_AMBIENTE,
                FerramentaTool.DINAMICA,
                FerramentaTool.AGENDA,
                FerramentaTool.AVALIACOES,
                FerramentaTool.ATIVIDADES,
                FerramentaTool.MATERIAL,
                FerramentaTool.LEITURAS,
                FerramentaTool.PERGUNTAS_FREQUENTES,
                FerramentaTool.EXERCICIOS,
                FerramentaTool.PARADA_OBRIGATORIA,
                FerramentaTool.MURAL,
                FerramentaTool.FORUNS,
                FerramentaTool.BATEPAPO,
                FerramentaTool.CORREIO,
                FerramentaTool.GRUPOS,
                FerramentaTool.PERFIL,
                FerramentaTool.DIARIO,
                FerramentaTool.PORTFOLIO,
                FerramentaTool.ACESSOS,
                FerramentaTool.INTERMAP
        };
        return idFerramenta;
    }
}
