/*
 * Created on Nov 12, 2004
 *
 */
package br.unicamp.nied.teleduc.extrator.ferramentas;

import java.text.Format;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @author leonel
 * 
 */
public class FormatoData {
	/**
	 * Formata uma data no formato dd/MM/yyyy, usado na lngua portuguesa
	 * 
	 * @param d
	 *            java.util.Date - data a formatar
	 * @return String com a data no formato dd/mm/yyyy
	 */
	public static String formataData(Date d) {
		Format formater = new SimpleDateFormat("dd/MM/yyyy");
		return formater.format(d);
	}

	/**
	 * Formata data no formato dd/MM/yyyy HH:mm, usado na lngua portuguesa
	 * 
	 * @param d
	 *            java.util.Date - data a formatar
	 * @return String com a data no formato dd/mm/yyyy HH:mm
	 */
	public static String formataDataHora(Date d) {
		Format formater = new SimpleDateFormat("dd/MM/yyyy HH:mm");
		return formater.format(d);
	}

	/**
	 * Formata data no formato "invertido" MM/dd/yyyy, com o ms antes do dia,
	 * usado na lngua inglesa.
	 * 
	 * @param d
	 *            java.util.Date - data a formatar
	 * @return String com a data no formato invertido MM/dd/yyyy, com o ms
	 *         antes do dia, usado na lngua inglesa.
	 */
	public static String formataDataInvertida(Date d) {
		Format formater = new SimpleDateFormat("MM/dd/yyyy");
		return formater.format(d);
	}

	/**
	 * Formata data no formato dd/MM/yyyy HH:mm:ss usado na lngua portuguesa
	 * 
	 * @param d
	 *            java.util.Date - data a formatar
	 * @return String com a data no formato dd/MM/yyyy HH:mm:ss, usado na lngua
	 *         portuguesa
	 */
	public static String formataDataHoraSegundos(Date d) {
		Format formater = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
		return formater.format(d);
	}

	/**
	 * Formata data no formato invertido MM/dd/yyyy, com o ms antes do dia,
	 * usado na lngua inglesa
	 * 
	 * @param d
	 *            java.util.Date - data a formatar
	 * @return String no formato invertido MM/dd/yyyy HH:mm:ss, usado na lngua
	 *         inglesa
	 */
	public static String formataDataHoraSegundosInvertida(Date d) {
		Format formater = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss");
		return formater.format(d);
	}

	/**
	 * Formata data no formato invertido MM/dd/yyyy HH:mm, com o ms antes do
	 * dia, usado na lngua inglesa
	 * 
	 * @param d
	 *            java.util.Date - data a formatar
	 * @return String no formato invertido MM/dd/yyyy HH:mm, usado na lngua
	 *         inglesa
	 */
	public static String formataDataHoraInvertida(Date d) {
		Format formater = new SimpleDateFormat("MM/dd/yyyy HH:mm");
		return formater.format(d);
	}
}