/*
 * Created on Mar 10, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.acessos;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.database.ConnectionFactory;
import br.unicamp.nied.teleduc.extrator.database.DBException;
import br.unicamp.nied.teleduc.extrator.ferramentas.CalendarTool;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;

/**
 * @author leonel
 * 
 * Classe auxiliar para retornar os acessos de um usurio
 */
// TODO - trocar acesso para default
public class AcessosUsuario {
    private Curso curso;

    private Usuario usuario;

    private Date dataInicio;

    private Date dataFim;

    /**
     * 
     */
    public AcessosUsuario(Curso curso, Usuario usuario, Date dataInicio,
            Date dataFim) {
        CalendarTool cal = new CalendarTool();
        this.curso = curso;
        this.usuario = usuario;
        this.dataInicio = cal.zeroHora(dataInicio);
        this.dataFim = cal.hora23(dataFim);
    }

    public List getAcessos() throws ExtractionException {
        PreparedStatement stmt = null;
        ResultSet rs = null;
        List ret = new ArrayList();

        try {
            Connection conn;
            conn = ConnectionFactory.getConnectionFactory().getConnection(
                    this.curso.getBaseCurso());
            String sql = "select data, cod_ferramenta" + " from Curso_acessos"
                    + " where cod_usuario=" + this.usuario.getId()
                    + " and data between " + this.dataInicio.getTime() / 1000L
                    + " and " + this.dataFim.getTime() / 1000L
                    + " order by data";

            stmt = conn.prepareStatement(sql);
            rs = stmt.executeQuery();
            ret = new ArrayList(ConnectionFactory.numeroDeLinhas(rs));
            while (rs.next()) {
                Usuario usr = this.usuario;
                Date d = new Date(rs.getLong("data") * 1000L);
                byte ferramenta = rs.getByte("cod_ferramenta");
                Acesso a = new Acesso(usr, d, ferramenta);
                ret.add(a);
            }
        } catch (DBException e) {
            throw new ExtractionException("Erro ao extrair acessos do usurio"
                    + " id = [" + this.usuario.getId() + "]", e);
        } catch (IOException e) {
            throw new ExtractionException("Erro ao extrair acessos do usurio"
                    + " id = [" + this.usuario.getId() + "]", e);
        } catch (SQLException e) {
            throw new ExtractionException("Erro ao extrair acessos do usurio"
                    + " id = [" + this.usuario.getId() + "]", e);
        } finally {
            if (rs != null) {
                try {
                    rs.close();
                } catch (SQLException ex) { /* ignore */
                }
            }
            if (stmt != null) {
                try {
                    stmt.close();
                } catch (SQLException ex) { /* ignore */
                }
            }
        }

        return ret;
    }
}