/*
 * Created on Sep 10, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.agenda;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.curso.Ferramenta;
import br.unicamp.nied.teleduc.extrator.database.ConnectionFactory;
import br.unicamp.nied.teleduc.extrator.database.DBException;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;

/**
 * @author leonel
 *
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class Agenda extends Ferramenta {

    private int id;

    private String texto = null;

    private Date data;

    private boolean isAtivo;

    private String titulo = null;

    /**
     *
     */
    public Agenda() {
    }

    public int getId() {
        return this.id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public Date getData() {
        return this.data;
    }

    public void setData(Date d) {
        this.data = d;
    }

    public boolean isAtivo() {
        return this.isAtivo;
    }

    public void setAtivo(boolean ativo) {
        this.isAtivo = ativo;
    }

    /**
     * @return Returns the titulo.
     */
    public String getTitulo() {
        return titulo;
    }

    /**
     * @param titulo
     *            The titulo to set.
     */
    public void setTitulo(String titulo) {
        this.titulo = titulo;
    }

    public boolean hasTexto() {
        return (this.texto != null && (! this.texto.equals("")));
    }

    public String getTexto() {
        return this.texto;
    }

    public void setTexto(String t) {
        this.texto = t;
    }

    public boolean hasArquivos() {
        return (!this.hasTexto());
    }

    public static List findByUsuario(Curso curso, Usuario usuario)
            throws ExtractionException {
        List ret = new ArrayList();

        try {
            ConnectionFactory fac = ConnectionFactory.getConnectionFactory();
            Connection conn = fac.getConnection(curso.getBaseCurso());

            String sql = geraConsultaItensUsuario(usuario);
            PreparedStatement prep = conn.prepareStatement(sql);

            ResultSet rs = prep.executeQuery();
            while (rs.next()) {
                Agenda ag = new Agenda();

                ag.setId(rs.getInt("cod_item"));
                ag.setTitulo(rs.getString("titulo"));
                ag.setTexto(rs.getString("texto"));
                ag.setData(new Date(rs.getLong("data") * 1000L));

                String situacao = rs.getString("situacao");
                if((situacao != null) && (! situacao.equals(""))){
                    char c = situacao.charAt(0);
                    ag.setAtivo(c == 'A');
                }
                else
                    ag.setAtivo(false);

                ret.add(ag);
            }

        } catch (IOException ioex) {
            throw new ExtractionException("Erro ao extrair Agenda da base",
                    ioex);
        } catch (SQLException sqlex) {
            throw new ExtractionException("Erro ao extrair Agenda da base",
                    sqlex);
        } catch (DBException dbex) {
            throw new ExtractionException("Erro ao extrair Agenda da base",
                    dbex);
        }

        return ret;
    }

    /**
     * @param usuario
     * @return
     */
    private static String geraConsultaItensUsuario(Usuario usuario) {
        // retornar todas as agendas
        return "select cod_item, titulo, texto, data, situacao"
                + " from Agenda_itens";
    }


    /**
     * @param key
     * @return
     */

    public int hashCode() {
        return this.id;
    }

    public boolean equals(Object obj) {
        if (obj instanceof Agenda) {
            Agenda ag = (Agenda) obj;
            return ag.id == this.id;
        }
        return false;
    }

    /*
     * (non-Javadoc)
     *
     * @see br.unicamp.nied.teleduc.extrator.curso.Ferramenta#nomeFerramenta()
     */
    protected String nomeFerramenta() {
        // TODO Auto-generated method stub
        return "agenda";
    }

}