/*
 * Created on Dec 7, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.agenda;

import java.io.IOException;
import java.io.Writer;
import java.util.Iterator;
import java.util.List;

import javax.xml.parsers.ParserConfigurationException;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;

import br.unicamp.nied.teleduc.extrator.config.Config;
import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;
import br.unicamp.nied.teleduc.transformador.Transform;

/**
 * @author rafael
 *
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class TransformAgenda extends Transform {
    private List agendas;

    /**
     * @throws IOException
     * @throws ExtractionException
     * @throws ParserConfigurationException
     *
     */
    public TransformAgenda(Curso curso, Usuario usuario) throws IOException, ExtractionException {
        this(curso, usuario, Agenda.findByUsuario(curso, usuario));
    }



    public TransformAgenda(Curso curso, Usuario usuario, List agendas) throws IOException {
        super(curso, usuario, "agenda");
        this.agendas = agendas;
    }

    public void geraArquivosHTML() throws ResourceNotFoundException,
            ParseErrorException, MethodInvocationException, IOException,
            Exception {
        VelocityEngine ve = new VelocityEngine();
        ve.init(Config.getConfig().getProperties());

        VelocityContext context = createVelocityContext();
        /*
         * Inicia a gerao dos arquivos das agendas
         */

        // Gera lista com todas agendas anteriores
        Template template = ve
                .getTemplate("templates/agenda/listaItensAnteriores.vsl");
        geraListaAgenda(context, template, agendas);

        //Gera paginas de menu e conteudo para todas as agendas
        for (Iterator i = agendas.iterator(); i.hasNext();) {
            Agenda ag = (Agenda) i.next();

            template = ve.getTemplate("templates/agenda/itemMenu.vsl");
            geraMenuItem(context, template, ag);

            if(ag.hasTexto()){
                template = ve.getTemplate("templates/agenda/itemConteudo.vsl");
                geraItemConteudo(context, template, ag);
            }
            template = ve.getTemplate("templates/agenda/itemFrame.vsl");
            geraItemFrame(context, template, ag);
        }

    }

    private void geraListaAgenda(VelocityContext context, Template template,
            List agendas) throws ParseErrorException,
            MethodInvocationException, Exception {

        context.put("agendas", agendas);
        Writer writer = createWriter(this.dirExtracao + "/listaAgendas.html");
        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                /* ignore */
            }
        }
    }

    private void geraMenuItem(VelocityContext context, Template template,
            Agenda agenda) throws ParseErrorException,
            MethodInvocationException, Exception {

        String nome_menu = "";

        context.put("agenda", agenda);

        if (agenda.isAtivo()){
            nome_menu = "/agendaMenuAtual.html";

        } else {
            nome_menu = "/agendaMenu_" + agenda.getId() + ".html";
        }

        Writer writer = createWriter(this.dirExtracao + nome_menu);
        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                /* ignore */
            }
        }
    }

    private void geraItemConteudo(VelocityContext context, Template template,
            Agenda agenda) throws ParseErrorException,
            MethodInvocationException, Exception {

        context.put("agenda", agenda);
        Writer writer = createWriter(this.dirExtracao + "/agendaConteudo_"
                + agenda.getId() + ".html");
        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                /* ignore */
            }
        }
    }

    private void geraItemFrame(VelocityContext context, Template template,
            Agenda agenda) throws ParseErrorException,
            MethodInvocationException, Exception {

        String nome_frame = "";

        context.put("agenda", agenda);

        if (agenda.isAtivo())
            nome_frame = "/index.html";
        else
            nome_frame = "/agendaFrame_" + agenda.getId() + ".html";

        Writer writer = createWriter(this.dirExtracao + nome_frame);
        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                /* ignore */
            }
        }
    }
}