/*
 * Created on Oct 7, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.atividades;

import java.io.IOException;
import java.util.Collection;
import java.util.Iterator;

import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.curso.ExtratorFerramenta;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;

/**
 * @author leonel
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class ExtratorAtividades extends ExtratorFerramenta {
    /**
     * 
     * @param curso
     * @param usr
     */
    public ExtratorAtividades(Curso curso, Usuario usr) {
        super(curso, usr);
    }

    
    
    /**
     * @throws ExtractionException
     * @throws Exception
     * @throws MethodInvocationException
     * @throws ParseErrorException
     * @throws ParseErrorException
     * 
     */
    public void extrair() throws ExtractionException {
        PastaAtividades raiz = Atividade
                .findByUsuario(this.curso, this.usuario);
        /*
         * Iterar dentro da hierarquia de pastas e copiar os arquivos de cada
         * item
         */
        copiaArquivos(raiz);

        /*
         * Gerar arquivos HTML da ferramenta
         */
        try {
            TransformAtividades transf = new TransformAtividades(this.curso,
                    this.usuario, raiz);
            transf.geraArquivosHTML();
        } catch (IOException ioex) {
            ioex.printStackTrace();
            throw new ExtractionException(
                    "Erro ao gerar arquivos HTML da ferramenta", ioex);
        } catch (ResourceNotFoundException e) {
            e.printStackTrace();
            throw new ExtractionException(
                    "Erro ao gerar arquivos HTML da ferramenta", e);
        } catch (ParseErrorException e) {
            e.printStackTrace();
            throw new ExtractionException(
                    "Erro ao gerar arquivos HTML da ferramenta", e);
        } catch (MethodInvocationException e) {
            e.printStackTrace();
            throw new ExtractionException(
                    "Erro ao gerar arquivos HTML da ferramenta", e);
        } catch (Exception e) {
            e.printStackTrace();
            throw new ExtractionException(
                    "Erro ao gerar arquivos HTML da ferramenta", e);
        }
    }

    /**
     * Copia recursivamente os arquivos de cada item desta pasta e das subpastas
     * para a pasta de extrao 
     * 
     * @param pasta Pasta da qual copiar os arquivos.
     * @throws ExtractionException
     */
    private void copiaArquivos(PastaAtividades pasta) throws ExtractionException {
        /*
         * Copiar os arquivos de cada item da pasta
         */
        for (Iterator itr = pasta.getItens().iterator(); itr.hasNext();) {
            Atividade at = (Atividade) itr.next();
            Collection arquivos = this.copiaArquivos(at.getId());
            at.setArquivos(arquivos);
        }
        
        /*
         * Aplicar recursivamente nas sub-pastas
         */
        for (Iterator itr = pasta.getSubPastas().iterator(); itr.hasNext();) {
            PastaAtividades subpasta = (PastaAtividades) itr.next();
            this.copiaArquivos(subpasta);
        }
    }

    /**
     * @see br.unicamp.nied.teleduc.extrator.curso.ExtratorFerramenta#nomeFerramenta()
     */
    public String nomeFerramenta() {
        return "atividades";
    }
}