/*
 * Created on Dec 10, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.atividades;

import java.io.IOException;
import java.io.Writer;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;
import br.unicamp.nied.teleduc.transformador.Transform;

/**
 * @author pablo
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class TransformAtividades extends Transform {
    private PastaAtividades raizAtividades;

    /**
     * @param curso
     * @param usuario
     * @throws IOException
     * @throws ExtractionException
     * 
     */
    public TransformAtividades(Curso curso, Usuario usuario)
            throws IOException, ExtractionException {
        this(curso, usuario, Atividade.findByUsuario(curso, usuario));
    }

    public TransformAtividades(Curso curso, Usuario usuario,
            PastaAtividades raizAtividades) throws IOException,
            ExtractionException {
        super(curso, usuario, "atividades");
        this.raizAtividades = raizAtividades;
    }

    public void geraArquivosHTML() throws ResourceNotFoundException,
            ParseErrorException, MethodInvocationException, IOException,
            Exception {
        VelocityEngine ve = super.createVelocityEngine();
        VelocityContext context = super.createVelocityContext();

        /*
         * Inicia a gerao dos arquivos de pastas de atividades na raiz
         */
        Template template = ve
                .getTemplate("templates/atividades/pastaAtividades.vsl");
        geraPastasAtividades(context, template, raizAtividades);

        /*
         * Faz a gerao dos itens
         */
        template = ve.getTemplate("templates/atividades/itemAtividades.vsl");
        geraItensAtividades(context, template, raizAtividades);
    }

    private void geraPastasAtividades(VelocityContext context,
            Template template, PastaAtividades raiz)
            throws ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, IOException, Exception {
        context.put("raiz", raiz);
        geraPastasAtividadesAux(context, template, raiz, raiz);
    }

    /**
     * @param raiz
     * @param pasta
     * @return
     */
    private List caminho(PastaAtividades raiz, PastaAtividades pasta) {
        LinkedList caminho = new LinkedList();
        caminhoAux(raiz, pasta, caminho);
        return caminho;
    }

    private boolean caminhoAux(PastaAtividades p1, PastaAtividades p2,
            LinkedList l) {
        if (p1 == p2) {
            l.addFirst(p2);
            return true;
        } else {
            for (Iterator itr = p1.getSubPastas().iterator(); itr.hasNext();) {
                PastaAtividades p = (PastaAtividades) itr.next();
                if (caminhoAux(p, p2, l)) {
                    l.addFirst(p1);
                    return true;
                }
            }
            return false;
        }
    }

    /**
     * Gera recursivamente os arquivos HTML das pastas de atividades
     * 
     * @param context
     *            Contexto para criao de arquivos, baseado em template
     * @param template
     *            Template para pastas de atividades
     * @param raiz
     *            Pasta raiz das atividades
     * @param pasta
     *            Pasta da qual gerar o arquivo
     * 
     * @throws ResourceNotFoundException
     * @throws ParseErrorException
     * @throws MethodInvocationException
     * @throws IOException
     * @throws Exception
     */
    private void geraPastasAtividadesAux(VelocityContext context,
            Template template, PastaAtividades raiz, PastaAtividades pasta)
            throws ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, IOException, Exception {
        context.put("pasta", pasta);

        List caminho = caminho(raiz, pasta);
        context.put("caminho", caminho);

        Writer writer = null;
        if (pasta == raiz) {
            writer = createWriter(this.dirExtracao + "/index.html");
        } else {
            writer = createWriter(this.dirExtracao + "/pastaAtividades_"
                    + pasta.getId() + ".html");
        }

        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                /* ignore */
            }
        }

        for (Iterator itr = pasta.getSubPastas().iterator(); itr.hasNext();) {
            PastaAtividades p = (PastaAtividades) itr.next();
            geraPastasAtividadesAux(context, template, raiz, p);
        }
    }

    private void geraItensAtividades(VelocityContext context,
            Template template, PastaAtividades raiz)
            throws ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, IOException, Exception {
        context.put("raiz", raiz);
        geraItensAtividadesAux(context, template, raiz, raiz);
    }

    private void geraItensAtividadesAux(VelocityContext context,
            Template template, PastaAtividades raiz, PastaAtividades pasta)
            throws ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, IOException, Exception {
        /*
         * Gerar HTML para cada item nesta pasta
         */
        context.put("pasta", pasta);
        context.put("caminho", caminho(raiz, pasta));
        for (Iterator itr = pasta.getItens().iterator(); itr.hasNext();) {
            Atividade atividade = (Atividade) itr.next();
            geraItemAtividade(context, template, pasta, atividade);
        }

        /*
         * Aplicar o mtodo recursivamente nas subpastas da pasta
         */
        for (Iterator itr = pasta.getSubPastas().iterator(); itr.hasNext();) {
            PastaAtividades filho = (PastaAtividades) itr.next();
            geraItensAtividadesAux(context, template, raiz, filho);
        }
    }

    private void geraItemAtividade(VelocityContext context, Template template,
            PastaAtividades pasta, Atividade itemAtividade)
            throws ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, IOException, Exception {
        context.put("atividade", itemAtividade);
        Writer writer = createWriter(this.dirExtracao + "/itemAtividades_"
                + itemAtividade.getId() + ".html");
        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                /* ignore */
            }
        }
    }
}