/*
 * Created on Feb 28, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.avaliacao;

import java.io.IOException;
import java.io.Writer;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;
import br.unicamp.nied.teleduc.extrator.usuario.UsuarioFactory;
import br.unicamp.nied.teleduc.transformador.Transform;

/**
 * @author rafael
 *
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class TransformAvaliacao extends Transform {
    private List avaliacoes;

    /**
     * @throws IOException
     *
     */
    public TransformAvaliacao(Curso curso, Usuario usuario, List avaliacoes)
            throws IOException {
        //super(curso, usuario, "avaliacao");
        super(curso, usuario, "avaliacoes");
        this.avaliacoes = avaliacoes;
    }

    /*
     * (non-Javadoc)
     *
     * @see br.unicamp.nied.teleduc.transformador.Transform#geraArquivosHTML()
     */
    public void geraArquivosHTML() throws ResourceNotFoundException,
            ParseErrorException, IOException, Exception {
        // TODO Auto-generated method stub

        final VelocityEngine ve = createVelocityEngine();

        // Vamos gerar as paginas que listam as avaliacoes. (Passadas, Atuais,
        // Futuras)

        Thread t1 = new Thread(new Runnable() {
            public void run() {
                //System.out.println("Startando Thread que gera pagina com a lista de avaliacoes . . .");
                try {
                    geraListaAvaliacoes(ve);
                } catch (Exception e) {
                    e.printStackTrace();
                }

                //System.out.println("Thread que gera pagina com a lista de avaliacoes . . .[OK]");
            }
        });

        Thread t2 = new Thread(new Runnable() {
            public void run() {
                //System.out.println("Startando Thread que gera pagina com os detalhes de cada avaliacao . . .");
                try {
                    geraDetalhesAvaliacao(ve);
                } catch (Exception e) {
                    e.printStackTrace();
                }

                //System.out.println("Thread que gera pagina com os detalhes de cada avaliacao . . .[OK]");

            }
        });

        Thread t3 = new Thread(new Runnable() {
            public void run() {
                //System.out.println("Startando Thread que gera pagina com as notas de cada avaliacao . . .");
                try {
                    geraListaNotas(ve);
                } catch (Exception e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                }
                //System.out.println("Thread que gera pagina com as notas de cada avaliacao . . . [OK]");
            }
        });

        t1.start();
        t2.start();
        t3.start();

        t1.join();
        t2.join();
        t3.join();
    }

    /**
     * @param ve
     * @throws ParseErrorException
     * @throws Exception
     * @throws MethodInvocationException
     * @throws ResourceNotFoundException
     * @throws Exception
     *
     */
    private void geraListaNotas(VelocityEngine ve)
            throws ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, Exception {
        // TODO Auto-generated method stub

        List alunosNotas = UsuarioA.retornaUsuariosNotas(curso, usuario);

        Template template = ve.getTemplate("/templates/avaliacao/notas.vsl");
        VelocityContext context = createVelocityContext();

        //context.put("curso", curso);
        context.put("alunosNotas", alunosNotas);
        context.put("avaliacoes", avaliacoes);

        Writer writer = createWriter(this.dirExtracao + "/notas.html");

        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                //ignorar
            }
        }

        // Geracao dos popups com detalhes de cada avaliacao e participacoes
        // do aluno. Ordem O(avaliacoes.size() x alunosNotas.size())

        VelocityContext context2 = createVelocityContext();
        template = ve
                .getTemplate("/templates/avaliacao/detalheParticipacao.vsl");

        UsuarioFactory usrFac = UsuarioFactory.getInstance(curso);

        for (Iterator iter = avaliacoes.iterator(); iter.hasNext();) {
            Avaliacao a = (Avaliacao) iter.next();

            for (Iterator iterator = alunosNotas.iterator(); iterator.hasNext();) {
                UsuarioA u = (UsuarioA) iterator.next();

                Participacao p = u.getMapPart(a.getId());

                context2.put("aval", a);
                context2.put("parte", p);
                context2.put("usrId", new Integer(u.getId()));
                context2.put("usrNome", u.getNome());
                context2.put("usrFac", usrFac);

                writer = createWriter(this.dirExtracao + "/participacao_"
                        + u.getId() + "_" + a.getId() + ".html");

                try {
                    template.merge(context2, writer);
                } finally {
                    try {
                        writer.flush();
                        writer.close();

                    } catch (IOException ioex) {
                        //ignorar
                    }
                }

                if ((p != null) && (p.temNota()) && (p.getIdItem().size() > 0)) {
                    // Gerando as participacoes do usuario de acordo com a
                    // ferramenta
                    if (a.isForum()) {
                        Template templateAux = ve
                                .getTemplate("/templates/avaliacao/participacaoForum.vsl");
                        writer = createWriter(this.dirExtracao + "/forumPart_"
                                + u.getId() + "_" + a.getId() + ".html");

                        try {
                            templateAux.merge(context2, writer);
                        } finally {
                            try {
                                writer.flush();
                                writer.close();

                            } catch (IOException ioex) {
                                //ignorar
                            }
                        }
                    }

                    if (a.isBatepapo()) {
                        Template templateAux = ve
                        .getTemplate("/templates/avaliacao/sessaoBatepapo.vsl");
                        writer = createWriter(this.dirExtracao
                                + "/batepapoPart_" + u.getId() + "_"
                                + a.getId() + ".html");

                        try {
                            templateAux.merge(context2, writer);
                        } finally {
                            try {
                                writer.flush();
                                writer.close();

                            } catch (IOException ioex) {
                                //ignorar
                            }
                        }

                    }

                    /* Estamos gerando a participao relacionada ao portflio */
                    if (a.isPortfolioIndividual() || a.isPortfolioGrupo()) {
                        Template templateAux = ve
                                .getTemplate("/templates/avaliacao/participacaoPortfolio.vsl");
                        writer = createWriter(this.dirExtracao
                                + "/portfolioPart_" + u.getId() + "_"
                                + a.getId() + ".html");

                        if (a.isPortfolioIndividual()) {
                            context2.put("tipo", "INDIVIDUAL");
                        } else {
                            context2.put("tipo", "GRUPO");
                        }

                        try {
                            templateAux.merge(context2, writer);
                        } finally {
                            try {
                                writer.flush();
                                writer.close();

                            } catch (IOException ioex) {
                                //ignorar
                            }
                        }
                    } // Potfolio

                }// p!= null e temNota() e size > 0

            } // for u

        } // for a

    }

    /**
     * Gera os detalhes de cada avaliacao do curso
     *
     * @throws Exception
     * @throws ParseErrorException
     * @throws ResourceNotFoundException
     *
     */
    private void geraDetalhesAvaliacao(VelocityEngine ve)
            throws ResourceNotFoundException, ParseErrorException, Exception {
        Template template = ve
                .getTemplate("/templates/avaliacao/detalheAvaliacao.vsl");
        VelocityContext context = createVelocityContext();

        Date hoje = new Date();
        //Boolean menu_navegacao;

        for (Iterator iter = avaliacoes.iterator(); iter.hasNext();) {
            Avaliacao a = (Avaliacao) iter.next();

            if (a.getDataTermino().before(hoje)) {
                context.put("ordem", "P");
                //System.out.println("entrei em P !!!");
            } else if ((a.getDataInicio().before(hoje))
                    && (a.getDataTermino().after(hoje))) {
                //System.out.println("entrei em A !!!");
                context.put("ordem", "A");
            } else if (a.getDataInicio().after(hoje)) {
                //System.out.println("entrei em F !!!");
                context.put("ordem", "F");
            }

            context.put("avaliacao", a);

            // Detalhes com o menu de navegacao
            context.put("menu_naveg", "S");

            Writer writer = createWriter(this.dirExtracao + "/avaliacao_"
                    + a.getId() + ".html");
            try {
                template.merge(context, writer);
            } finally {
                try {
                    writer.flush();
                    writer.close();
                } catch (IOException ioex) {
                    //ignore
                }
            }

            // Detalhes sem o menu de navegacao
            context.put("menu_naveg", "N");

            writer = createWriter(this.dirExtracao + "/avaliacaoN_" + a.getId()
                    + ".html");
            try {
                template.merge(context, writer);
            } finally {
                try {
                    writer.flush();
                    writer.close();
                } catch (IOException ioex) {
                    //ignore
                }
            }

        }

    }

    /**
     * @param Velocity
     *            Engine ve
     * @throws ResourceNotFoundException
     * @throws ParseErrorException
     * @throws Exception
     *
     * @throws
     */
    private void geraListaAvaliacoes(VelocityEngine ve)
            throws ResourceNotFoundException, ParseErrorException, Exception {
        // TODO Auto-generated method stub

        Template template = ve
                .getTemplate("/templates/avaliacao/listaAvaliacao.vsl");
        VelocityContext context = createVelocityContext();

        Date hoje = new Date();

        context.put("hoje", hoje);
        //context.put("curso", curso);
        context.put("avaliacoes", this.avaliacoes);

        // Avaliacoes passadas
        context.put("ordem", "P");

        Writer writer = createWriter(this.dirExtracao
                + "/listaAvalPassadas.html");
        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                //ignore
            }
        }

        //      Avaliacoes atuais
        context.put("ordem", "A");

        writer = createWriter(this.dirExtracao + "/index.html");
        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                //ignore
            }
        }

        //      Avaliacoes futuras
        context.put("ordem", "F");

        writer = createWriter(this.dirExtracao + "/listaAvalFuturas.html");
        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                //ignore
            }
        }

    }

}