/*
 * Created on Nov 4, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.avaliacao;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.database.ConnectionFactory;
import br.unicamp.nied.teleduc.extrator.database.DBException;
import br.unicamp.nied.teleduc.extrator.ferramentas.forum.Mensagem;
import br.unicamp.nied.teleduc.extrator.ferramentas.portfolio.ItemPortfolio;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;

/**
 * @author bruno / Rafael
 *
 * OBS: Essa classe de usuario  independente da classe Usuario. Tanto que
 * possui os atributos nome, status que no so obtidos atraves da classe
 * Usuario.
 *
 */
public class UsuarioA {
    private int id;

    private String nome;

    private Map mapPart;

    private char status;

    //private boolean grupo;

    public int HashCode() {
        return this.id;
    }

    /**
     * @return Returns the nome.
     */
    public String getNome() {
        return nome;
    }

    /**
     * @param nome
     *            The nome to set.
     */
    public void setNome(String nome) {
        this.nome = nome;
    }

    /*
     * public void setGrupo(boolean i) { this.grupo = i; }
     *
     * public boolean getGrupo() { return this.grupo; }
     */

    /**
     * @return Todas as participacoes do usuario
     */
    public Collection getParticipacoes() {
        return this.mapPart.values();
    }

    /**
     * @return Returns the nome
     */
    public int getId() {
        return id;
    }

    /**
     * @param id
     *            The id to set
     */
    public void setId(int id) {
        this.id = id;
    }

    /**
     * @return o status do usuario: 'A' = Aluno 'X' = Excluido 'V' = Visitante
     *         'F' = Formador 'C' = Convidado
     */
    public char getStatus() {
        return status;
    }

    public boolean isFormador() {
        return status == 'F';
    }

    public void setStatus(char status) {
        this.status = status;
    }

    public void putMapPart(Participacao par) {
        this.mapPart.put(new Integer(par.getIdAvaliacao()), par);
    }

    public Participacao getMapPart(int cod_aval) {
        return (Participacao) this.mapPart.get(new Integer(cod_aval));
    }

    public UsuarioA() {
        this.mapPart = new HashMap();
    }

    public static List retornaUsuariosNotas(Curso curso, Usuario usuario)
            throws ExtractionException {
        String sqlUsuarios = null;
        String sqlNotas = null;
        String sqlParticipacoes = null;
        PreparedStatement stmt = null;
        ResultSet rs = null;
        Map mapUsuarios = new HashMap();
        //Map mapGrupos = new HashMap();
        List usuarios = new LinkedList();
        try {
            ConnectionFactory fac = ConnectionFactory.getConnectionFactory();
            Connection conn = fac.getConnection(curso.getBaseCurso());
            sqlUsuarios = geraSqlUsuarios();
            stmt = conn.prepareStatement(sqlUsuarios);
            rs = stmt.executeQuery();
            while (rs.next()) {
                UsuarioA usu = new UsuarioA();
                int idUsu = rs.getInt("cod_usuario");
                usu.setNome(rs.getString("nome"));
                usu.setId(idUsu);
                //usu.setGrupo(false);
                usu.setStatus(rs.getString("tipo_usuario").charAt(0));
                mapUsuarios.put(new Integer(idUsu), usu);
                usuarios.add(usu);
            }
            /*
             * sqlUsuarios = geraSqlGrupo(); stmt =
             * conn.prepareStatement(sqlUsuarios); rs = stmt.executeQuery();
             * while (rs.next()) { UsuarioA usu = new UsuarioA(); int idUsu =
             * rs.getInt("cod_grupo"); usu.setId(idUsu); usu.setGrupo(true);
             * mapGrupos.put(new Integer(idUsu), usu); usuarios.add(usu); }
             */

            sqlParticipacoes = geraSqlBatepapoParticipacoes();
            stmt = conn.prepareStatement(sqlParticipacoes);
            rs = stmt.executeQuery();
            while (rs.next()) {
                UsuarioA usua = (UsuarioA) mapUsuarios.get(new Integer(rs
                        .getInt("cod_usuario")));
                if (usua != null) {
                    Participacao par = (Participacao) usua.getMapPart(rs
                            .getInt("cod_avaliacao"));
                    MensagemA mensagem = new MensagemA();
                    mensagem.setAcao(rs.getInt("cod_texto_fala"));
                    mensagem.setData(rs.getLong("data"));
                    mensagem.setIdDestino(rs.getInt("cod_usuario_r"));
                    mensagem.seIdOrigem(rs.getInt("cod_usuario"));
                    mensagem.setMensagens(rs.getString("mensagem"));
                    mensagem.setIdSessao(rs.getInt("cod_sessao"));
                    mensagem.setAssunto(rs.getString("assunto"));
                    if (par == null) {
                        par = new Participacao();
                        par.setIdAvaliacao(rs.getInt("cod_avaliacao"));
                        par.setTipoAvaliacao('B');

                        usua.putMapPart(par);
                    }
                    par.addIdItem(mensagem);
                }
            }

            sqlParticipacoes = geraSqlForumParticipacoes();
            //System.out.println(sqlParticipacoes);
            stmt = conn.prepareStatement(sqlParticipacoes);
            rs = stmt.executeQuery();
            while (rs.next()) {
                UsuarioA usua = (UsuarioA) mapUsuarios.get(new Integer(rs
                        .getInt("cod_usuario")));
                Participacao par = (Participacao) usua.getMapPart(rs
                        .getInt("cod_avaliacao"));
                Mensagem msg = new Mensagem();
                msg.setTitulo(rs.getString("titulo"));
                msg.setMensagem(rs.getString("mensagem"));
                msg.setData(rs.getLong("data"));

                if (par == null) {
                    par = new Participacao();
                    par.setIdAvaliacao(rs.getInt("cod_avaliacao"));
                    par.setTipoAvaliacao('F');

                    usua.putMapPart(par);
                }
                par.addIdItem(msg);
            }
            sqlParticipacoes = geraSqlPortfolioIndividual();
            stmt = conn.prepareStatement(sqlParticipacoes);
            rs = stmt.executeQuery();
            while (rs.next()) {
                UsuarioA usua = (UsuarioA) mapUsuarios.get(new Integer(rs
                        .getInt("cod_usuario")));
                if (usua != null) {
                    Participacao par = (Participacao) usua.getMapPart(rs
                            .getInt("cod_avaliacao"));
                    ItemPortfolio item = new ItemPortfolio();
                    item.setId(rs.getInt("cod_item"));
                    item.setData(rs.getLong("data"));
                    item.setTitulo(rs.getString("titulo"));
                    item.setCompartilhamento(rs.getString(
                            "tipo_compartilhamento").charAt(0));
                    if (par == null) {
                        par = new Participacao();
                        par.setIdAvaliacao(rs.getInt("cod_avaliacao"));
                        par.setTipoAvaliacao('P');
                        usua.putMapPart(par);
                    }
                    //par.addIdItem(rs.getInt("cod_item"));
                    par.addIdItem(item);
                }
            }

            sqlParticipacoes = geraSqlPortfolioGrupo();
            stmt = conn.prepareStatement(sqlParticipacoes);
            rs = stmt.executeQuery();
            while (rs.next()) {
                UsuarioA usua = (UsuarioA) mapUsuarios.get(new Integer(rs
                        .getInt("cod_usuario")));
                /*
                 * UsuarioA grupo = (UsuarioA) mapGrupos.get(new Integer(rs
                 * .getInt("cod_grupo")));
                 */
                if (usua != null) {
                    Participacao par = (Participacao) usua.getMapPart(rs
                            .getInt("cod_avaliacao"));
                    ItemPortfolio item = new ItemPortfolio();
                    item.setId(rs.getInt("cod_item"));
                    item.setData(rs.getLong("data"));
                    item.setTitulo(rs.getString("titulo"));
                    item.setCompartilhamento(rs.getString(
                            "tipo_compartilhamento").charAt(0));
                    /*
                     * Participacao par2 = (Participacao) grupo.getMapPart(rs
                     * .getInt("cod_avaliacao"));
                     */
                    if (par == null) {
                        par = new Participacao();
                        par.setIdAvaliacao(rs.getInt("cod_avaliacao"));
                        par.setTipoAvaliacao('P');

                        usua.putMapPart(par);
                    }
                    /*
                     * if (par2 == null) { par2 = new Participacao();
                     * par2.setIdAvaliacao(rs.getInt("cod_avaliacao"));
                     * par2.setTipoAvaliacao('P'); grupo.putMapPart(par2); }
                     * par2.addIdItem(rs.getInt("cod_item"));
                     */
                    //par.addIdItem(rs.getInt("cod_item"));
                    par.addIdItem(item);
                }
            }

            sqlParticipacoes = geraSqlExercicioIndividual();
            stmt = conn.prepareStatement(sqlParticipacoes);
            rs = stmt.executeQuery();
            while (rs.next()) {
                UsuarioA usua = (UsuarioA) mapUsuarios.get(new Integer(rs
                        .getInt("cod_usuario")));
                if (usua != null) {
                    Participacao par = (Participacao) usua.getMapPart(rs
                            .getInt("cod_avaliacao"));
                    if (par == null) {
                        par = new Participacao();
                        par.setIdAvaliacao(rs.getInt("cod_avaliacao"));
                        par.setTipoAvaliacao('E');
                        //par.setTitulo(rs.getString("titulo"));

                        usua.putMapPart(par);
                    }
                    par.addIdItem(rs.getInt("cod_resolucao"));
                }
            }
            sqlParticipacoes = geraSqlExercicioGrupo();
            stmt = conn.prepareStatement(sqlParticipacoes);
            rs = stmt.executeQuery();
            while (rs.next()) {
                UsuarioA usua = (UsuarioA) mapUsuarios.get(new Integer(rs
                        .getInt("cod_usuario")));
                /*
                 * UsuarioA grupo = (UsuarioA) mapGrupos.get(new Integer(rs
                 * .getInt("cod_grupo")));
                 */
                if (usua != null) {
                    Participacao par = (Participacao) usua.getMapPart(rs
                            .getInt("cod_avaliacao"));
                    /*
                     * Participacao par2 = (Participacao) grupo.getMapPart(rs
                     * .getInt("cod_avaliacao"));
                     */
                    if (par == null) {
                        par = new Participacao();
                        par.setIdAvaliacao(rs.getInt("cod_avaliacao"));
                        par.setTipoAvaliacao('E');
                        //par.setTitulo(rs.getString("titulo"));
                        usua.putMapPart(par);
                    }
                    /*
                     * if (par2 == null) { par2 = new Participacao();
                     * par2.setIdAvaliacao(rs.getInt("cod_avaliacao"));
                     * par2.setTipoAvaliacao('E'); grupo.putMapPart(par2); }
                     *
                     * par2.addIdItem(rs.getInt("cod_resolucao"));
                     */
                    par.addIdItem(rs.getInt("cod_resolucao"));
                }
            }

            sqlNotas = geraSqlNotasIndividuais(usuario);
            //System.out.println(sqlNotas);
            stmt = conn.prepareStatement(sqlNotas);
            rs = stmt.executeQuery();
            while (rs.next()) {
                Nota nota = new Nota();
                nota.setId(rs.getInt("cod_nota"));
                nota.setJustificativa(rs.getString("comentario"));
                nota.setData(new Date(rs.getLong("data") * 1000L));
                nota.setDataAlteracao(new Date(
                        rs.getLong("data_alteracao") * 1000L));
                //nota.setData_en(rs.getString("data_en"));
                //nota.setDataAlteracao_en(rs.getString("data_alteracao_en"));
                nota.setIdAluno(rs.getInt("cod_aluno"));
                nota.setIdFormador(rs.getInt("cod_formador"));
                //System.out.println(rs.getObject("nota"));
                nota.setNota(rs.getFloat("nota"));
                nota.setCompartilhamento(rs.getString("tipo_compartilhamento")
                        .charAt(0));

                UsuarioA usua = (UsuarioA) mapUsuarios.get(new Integer(rs
                        .getInt("cod_aluno")));
                if (usua != null) {
                    Participacao parte = (Participacao) usua.getMapPart(rs
                            .getInt("cod_avaliacao"));
                    if (parte == null) {
                        parte = new Participacao();
                        parte.setIdAvaliacao(rs.getInt("cod_avaliacao"));
                        parte.setTipoAvaliacao(rs.getString("ferramenta")
                                .charAt(0));

                        usua.putMapPart(parte);
                    }
                    /*
                     * assert parte != null : "Como podemos dar nota a uma" + "
                     * participacao inexistente ? --> " +
                     * rs.getInt("cod_avaliacao") + " / " +
                     * rs.getInt("cod_aluno") + " / " + rs.getFloat("nota");
                     */

                    parte.setNota(nota);

                }
            }
            sqlNotas = geraSqlNotasGrupos(usuario);
            //System.out.println(sqlNotas);
            stmt = conn.prepareStatement(sqlNotas);
            rs = stmt.executeQuery();
            while (rs.next()) {
                Nota nota = new Nota();
                nota.setId(rs.getInt("cod_nota"));
                nota.setJustificativa(rs.getString("comentario"));
                nota.setData(new Date(rs.getLong("data") * 1000L));
                nota.setDataAlteracao(new Date(
                        rs.getLong("data_alteracao") * 1000L));
                nota.setIdAluno(rs.getInt("cod_aluno"));
                nota.setIdFormador(rs.getInt("cod_formador"));
                nota.setNota(rs.getFloat("nota"));
                nota.setIdGrupo(rs.getInt("cod_grupo"));
                nota.setCompartilhamento(rs.getString("tipo_compartilhamento")
                        .charAt(0));

                UsuarioA usua = (UsuarioA) mapUsuarios.get(new Integer(rs
                        .getInt("cod_aluno")));
                /*
                 * UsuarioA grupo = (UsuarioA) mapGrupos.get(new Integer(rs
                 * .getInt("cod_grupo")));
                 */

                if (usua != null) {
                    Participacao parte = (Participacao) usua.getMapPart(rs
                            .getInt("cod_avaliacao"));

                    if (parte == null) {
                        parte = new Participacao();
                        parte.setIdAvaliacao(rs.getInt("cod_avaliacao"));
                        parte.setTipoAvaliacao(rs.getString("ferramenta")
                                .charAt(0));
                        usua.putMapPart(parte);

                    }

                    parte.setNota(nota);

                    /*
                     * parte = (Participacao) grupo.getMapPart(rs
                     * .getInt("cod_avaliacao"));
                     *
                     * if ((parte != null) && (parte.temNota()))
                     * parte.setNota(nota);
                     */
                }
            }
        } catch (DBException dbex) {
            throw new ExtractionException("Erro ao extrair Avaliacao", dbex);
        } catch (IOException ioex) {
            throw new ExtractionException("Erro ao extrair Avaliacao da base",
                    ioex);
        } catch (SQLException sqlex) {
            throw new ExtractionException("Erro ao extrair Avaliacao da base",
                    sqlex);
        }
        return usuarios;
    }


    public static String geraSqlExercicioIndividual() {
        String sql = " select E.cod_resolucao, E.cod_usuario, Em.titulo, "
                + "A.cod_avaliacao from Exercicios_resolucao as E, "
                + "Exercicios_modelo as Em, Avaliacao as A where "
                + "A.cod_atividade=E.cod_modelo and A.status='F' and "
                + "A.ferramenta='E' and A.tipo='I' and Em.cod_modelo=E.cod_modelo";
        return sql;
    }

    public static String geraSqlExercicioGrupo() {
        String sql = "select E.cod_resolucao, E.cod_grupo, G.cod_usuario, "
                + "Em.titulo, A.cod_avaliacao from Exercicios_resolucao as E, "
                + "Avaliacao as A, Exercicios_modelo as Em, Grupos_usuario as G "
                + "where  A.cod_atividade=E.cod_modelo and A.status='F' and "
                + "A.ferramenta='E' and A.tipo='G' and G.cod_grupo=E.cod_grupo "
                + "and Em.cod_modelo=E.cod_modelo";
        return sql;
    }

    public static String geraSqlPortfolioIndividual() {
        String sql = "select P.cod_item, P.cod_usuario, A.cod_avaliacao, "
                + "A.cod_nota, P.titulo, P.data, P.tipo_compartilhamento from Portfolio_itens as P, "
                + "Portfolio_itens_avaliacao as A, Avaliacao as Av "
                + "where P.status!='X' and Av.cod_avaliacao=A.cod_avaliacao "
                + "and Av.tipo='I' and Av.status='F' and "
                + "A.cod_item=P.cod_item group by cod_item "
                + "order by cod_avaliacao";
        return sql;

    }

    public static String geraSqlPortfolioGrupo() {
        String sql = "select P.cod_item, P.cod_grupo, P.data, P.titulo, P.tipo_compartilhamento, G.cod_usuario, "
                + "A.cod_avaliacao, A.cod_nota from Portfolio_itens as P, "
                + "Portfolio_itens_avaliacao as A, Avaliacao as Av,"
                + " Grupos_usuario as G, Usuario as U where P.status!='X' and "
                + "G.cod_grupo=P.cod_grupo and U.cod_usuario=G.cod_usuario and "
                + "Av.cod_avaliacao=A.cod_avaliacao and Av.tipo='G' and "
                + "Av.status='F' and A.cod_item=P.cod_item "
                + "group by cod_usuario, cod_item";
        return sql;
    }

    public static String geraSqlForumParticipacoes() {
        String sql = "select F.cod_msg, F.cod_usuario, F.cod_forum, F.mensagem, F.titulo, "
                + "F.data, A.cod_avaliacao from Forum_mensagens as F, "
                + "Avaliacao as A where A.cod_atividade=F.cod_forum "
                + "and A.ferramenta='F' and A.status='F'";
        return sql;
    }

    public static String geraSqlUsuarios() {
        String sql = "select cod_usuario,tipo_usuario, nome from Usuario "
                + "where (binary tipo_usuario='A' or binary tipo_usuario='F') "
                + "and cod_usuario!=-1 ORDER BY tipo_usuario, nome";
        return sql;
    }

    public static String geraSqlGrupo() {
        String sql = "select * from Grupos where status!='X'";
        return sql;
    }

    public static String geraSqlBatepapoParticipacoes() {
        String sql = "select B.*, A.cod_avaliacao, B.data, BA.assunto, "
                + "F.cod_texto_fala from Batepapo_conversa as B, "
                + "Batepapo_fala as F, Batepapo_assuntos as BA, "
                + "Batepapo_sessoes as BS, Avaliacao as A where "
                + "BA.cod_assunto=A.cod_atividade and BA.data_inicio<=B.data "
                + "and BA.data_fim>=B.data and B.cod_sessao=BS.cod_sessao "
                + "and A.ferramenta='B' and A.status='F' and "
                + "F.cod_fala=B.cod_fala and F.cod_texto_fala > 8  order by data";
        return sql;
    }

    public static String geraSqlNotasIndividuais(Usuario usu) {
        String sql = null;
        if (usu.getTipoUsuario() == 'F') {
            sql = "select N.cod_nota, N.cod_aluno, N.cod_grupo, "
                    + "N.cod_avaliacao, N.cod_formador, N.comentario, N.status, A.ferramenta, "
                    + "N.data, N.nota, N.data_alteracao, N.tipo_compartilhamento from Avaliacao_notas as N, "
                    + "Avaliacao as A where "
                    + "N.cod_avaliacao=A.cod_avaliacao and A.status='F'"
                    + " and (N.cod_grupo IS NULL OR N.cod_grupo=0) and N.tipo_compartilhamento!=' '";
        } else {
            sql = "select N.cod_nota, N.cod_aluno, N.cod_grupo, "
                    + "N.cod_avaliacao, N.cod_formador ,N.comentario ,N.status, A.ferramenta, "
                    + "N.data, N.nota, N.data_alteracao, N.tipo_compartilhamento from Avaliacao_notas as N, "
                    + "Avaliacao as A where "
                    + "N.cod_avaliacao=A.cod_avaliacao and A.status='F'"
                    + " and (N.cod_grupo IS NULL OR N.cod_grupo=0) and"
                    + "(N.tipo_compartilhamento='T' or N.cod_aluno="
                    + Integer.toString(usu.getId()) + ") and N.tipo_compartilhamento!=' '";

        }
        return sql;
    }

    public static String geraSqlNotasGrupos(Usuario usu) {
        String sql = null;
        if (usu.getTipoUsuario() == 'F') {
            sql = "select N.cod_nota, N.cod_aluno, N.cod_grupo, "
                    + "N.cod_avaliacao, N.cod_formador ,N.comentario ,N.status, A.ferramenta, "
                    + "N.nota, N.data, N.data_alteracao, "
                    + "N.tipo_compartilhamento from Avaliacao_notas as N, "
                    + "Avaliacao as A where "
                    + "N.cod_avaliacao=A.cod_avaliacao and A.status='F' "
                    + "and (N.cod_grupo IS NOT NULL OR N.cod_grupo!=0) and N.tipo_compartilhamento!=' '";
        } else {
            sql = "select N.cod_nota, N.cod_aluno, N.cod_grupo, "
                    + "N.cod_avaliacao, N.cod_formador ,N.comentario, A.ferramenta, "
                    + "N.status, N.data, N.nota, N.data_alteracao, "
                    + "N.tipo_compartilhamento from Avaliacao_notas as N, Avaliacao as A, "
                    + "Grupos_usuario as G where "
                    + "N.cod_avaliacao=A.cod_avaliacao and A.status='F' "
                    + "and G.cod_grupo=N.cod_grupo and "
                    + "(N.cod_grupo IS NOT NULL OR N.cod_grupo!=0) and "
                    + "(N.tipo_compartilhamento='T' or G.cod_usuario="
                    + Integer.toString(usu.getId()) + ") and N.tipo_compartilhamento!=' '";
        }

        return sql;
    }
}