/*
 * Created on Oct 27, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.correio;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.curso.Ferramenta;
import br.unicamp.nied.teleduc.extrator.database.ConnectionFactory;
import br.unicamp.nied.teleduc.extrator.database.DBException;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;
import br.unicamp.nied.teleduc.extrator.usuario.UsuarioFactory;

/**
 * @author pablo
 *
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class Mensagem extends Ferramenta {
    private Usuario remetente;
    private List    destinatarios = null;
    private String  assunto       = null;
    private String  mensagem      = null;
    private char    status;

    /**
     * @return Returns the status.
     */
    public boolean isEnviada() {
        return status == 'E';
    }

    public boolean isRecebida() {
        return status == 'R';
    }

    public boolean isLixeira() {
        return status == 'L';
    }

    /**
     * Marca esta mensagem como enviada pelo usurio
     */
    public void setEnviada() {
        this.status = 'E';
    }
    /**
     * Marca esta mensagem como recebida pelo usurio
     */
    public void setRecebida() {
        this.status = 'R';
    }
    /**
     * Marca esta mensagem como pertencendo  lixeira
     */
    public void setLixeira() {
        this.status = 'L';
    }

    /**
     * @return Returns the mensagem.
     */
    public String getMensagem() {
        return mensagem;
    }

    /**
     * @param mensagem
     *            The mensagem to set.
     */
    public void setMensagem(String mensagem) {
        this.mensagem = mensagem;
    }

    /**
     * @param destinatarios
     *            The destinatarios to set.
     */
    public void setDestinatarios(List destinatarios) {
        this.destinatarios = destinatarios;
    }

    public Mensagem() {
        this.destinatarios = new ArrayList();
        this.arquivos = new ArrayList();
    }

    public void addDestinatarios(Usuario usuario) {
        this.destinatarios.add(usuario);
    }

    /**
     * TODO Organizar melhor.. quebrar em + metodos!
     *
     * @param curso
     * @param usuario
     * @return
     * @throws ExtractionException
     */
    public static Collection retornaMensagens(Curso curso, Usuario usuario) throws ExtractionException {
        Collection        mensagens    = new ArrayList();
        Mensagem          mensagem     = null;

        ConnectionFactory conFac       = null;
        Connection        con          = null;
        PreparedStatement ps           = null;
        ResultSet         rs           = null;

        Map               mapMensagens = new HashMap();
        UsuarioFactory    usrFactory   = UsuarioFactory.getInstance(curso);

        try {
            conFac = ConnectionFactory.getConnectionFactory();
            con = conFac.getConnection(curso.getBaseCurso());

            /*
             * Pego as mensgens que o usuario enviou.
             */

            String sql = "select * from Correio_mensagens where cod_usuario = "
                    + usuario.getId();
            ps = con.prepareStatement(sql);
            rs = ps.executeQuery();

            while (rs.next()) {
                mensagem = new Mensagem();
                // marcar esta mensagem como enviada
                mensagem.setEnviada();

                mensagem.setId(rs.getInt("cod_msg"));
                mensagem.setRemetente(usrFactory.getUsuario(rs.getInt("cod_usuario")));
                mensagem.setDestinatarios(retornaDestinatarios(curso, mensagem
                        .getId()));
                mensagem.setAssunto(rs.getString("assunto"));
                mensagem.setMensagem(rs.getString("mensagem"));
                mensagem.setData(rs.getLong("data"));

                mensagens.add(mensagem);
                mapMensagens.put(new Integer(mensagem.getId()), mensagem);
            }

            /*
             * Pego as mensagens que foram enviadas para o usuario.
             */
            sql = "select m.cod_msg, "
                    + "m.cod_usuario, "
                    + "m.assunto, "
                    + "m.data, "
                    + "m.mensagem "
                    + "from "
                    + "Correio_mensagens m inner join Correio_destinos d on m.cod_msg=d.cod_msg "
                    + "where d.cod_usuario = " + usuario.getId()
                    + " group by m.cod_msg";
            ps = con.prepareStatement(sql);
            rs = ps.executeQuery();
            while (rs.next()) {
                int id = rs.getInt("cod_msg");
                mensagem = (Mensagem) mapMensagens.get(new Integer(id));

                if (mensagem == null) {
                    mensagem = new Mensagem();
                    // marcar a mensagem como recebida
                    mensagem.setRecebida();
                    mensagem.setId(rs.getInt("cod_msg"));
                    mensagem.setRemetente(usrFactory.getUsuario(rs.getInt("cod_usuario")));
                    mensagem.setDestinatarios(retornaDestinatarios(curso,
                            mensagem.getId()));
                    mensagem.setAssunto(rs.getString("assunto"));
                    mensagem.setMensagem(rs.getString("mensagem"));
                    mensagem.setData(rs.getLong("data"));

                    mensagens.add(mensagem);
                    mapMensagens.put(new Integer(mensagem.getId()), mensagem);
                }
            }

        } catch (DBException dbex) {
            dbex.printStackTrace();
        } catch (IOException ioex) {
            ioex.printStackTrace();
        } catch (SQLException sqlex) {
            sqlex.printStackTrace();
        } finally {
            try {
                rs.close();
            } catch (SQLException e1) {
                e1.printStackTrace();
            }

            try {
                ps.close();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        return mensagens;
    }

    /**
     * @param curso
     * @param messageId
     * @return destinatarios
     * @throws IOException
     * @throws DBException
     * @throws SQLException
     * @throws ExtractionException
     */
    private static List retornaDestinatarios(Curso curso, int messageId)
            throws ExtractionException {
        PreparedStatement stmt = null;
        ResultSet         rs   = null;
        try {
            List destinatarios = new ArrayList();
            ConnectionFactory conFac = ConnectionFactory.getConnectionFactory();
            Connection con = conFac.getConnection(curso.getBaseCurso());
            String sql = "Select cod_usuario from Correio_destinos where cod_msg = "
                    + messageId + " and cod_usuario >= 0";
            stmt = con.prepareStatement(sql);
            rs   = stmt.executeQuery();
            UsuarioFactory usrFactory = UsuarioFactory.getInstance(curso);
            while (rs.next()) {
                Usuario usr = usrFactory.getUsuario(rs.getInt("cod_usuario"));
                destinatarios.add(usr);
            }
            return destinatarios;
        } catch (DBException e) {
            e.printStackTrace();
            throw new ExtractionException("Erro ao retornar usurios", e);
        } catch (IOException e) {
            e.printStackTrace();
            throw new ExtractionException("Erro ao retornar usurios", e);
        } catch (SQLException e) {
            e.printStackTrace();
            throw new ExtractionException("Erro ao retornar usurios", e);
        } finally {
            if (rs != null) {
                try {
                    rs.close();
                } catch (SQLException sqlex) {
                    sqlex.printStackTrace();
                }
            }
            if (stmt != null) {
                try {
                    stmt.close();
                } catch (SQLException sqlex) {
                    sqlex.printStackTrace();
                }
            }
        }
    }

    /**
     * @return Returns the assunto.
     */
    public String getAssunto() {
        return assunto;
    }

    /**
     * @param assunto
     *            The assunto to set.
     */
    public void setAssunto(String assunto) {
        this.assunto = assunto;
    }

    /**
     *
     * @return
     */
    public Usuario getRemetente() {
        return remetente;
    }

    /**
     * @param remetenteId
     *            The remetente to set.
     */
    public void setRemetente(Usuario usr) {
        this.remetente = usr;
    }

    /**
     * @return Returns the destinatarios.
     */
    public List getDestinatarios() {
        return destinatarios;
    }

    /*
     * (non-Javadoc)
     *
     * @see br.unicamp.nied.teleduc.extrator.curso.Ferramenta#nomeFerramenta()
     */
    protected String nomeFerramenta() {
        return "correio";
    }
}