/*
 * Created on Feb 11, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.correio;

import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;
import br.unicamp.nied.teleduc.transformador.Transform;

/**
 * @author leonel
 *
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class TransformCorreio extends Transform {
    private Correio correio;

    /*
     * Estes comparadores so usados para ordenar a lista de mensagens por data,
     * assunto, remetente ou destinatrios. Para cada um destes,  possvel
     * ordenar ascendente (por ex, A - Z) ou em ordem descendente (Z - A)
     */
    private Comparator compDataASC =
        new Comparator() {
            public int compare(Object obj1, Object obj2) {
                 Mensagem m1 = (Mensagem) obj1;
                 Mensagem m2 = (Mensagem) obj2;
                 return m1.getData().compareTo(m2.getData());
            }
        };
    private Comparator compDataDESC =
        new Comparator() {
             public int compare(Object obj1, Object obj2) {
                 Mensagem m1 = (Mensagem) obj1;
                 Mensagem m2 = (Mensagem) obj2;
                 return -1 * m1.getData().compareTo(m2.getData());
             }
        };
    private Comparator compAssuntoASC =
        new Comparator() {
             public int compare(Object o1, Object o2) {
                 Mensagem m1 = (Mensagem) o1;
                 Mensagem m2 = (Mensagem) o2;
                 return m1.getAssunto().compareTo(m2.getAssunto());
             }
        };
    private Comparator compAssuntoDESC =
        new Comparator() {
            public int compare(Object o1, Object o2) {
                Mensagem m1 = (Mensagem) o1;
                Mensagem m2 = (Mensagem) o2;
                return -1* m1.getAssunto().compareTo(m2.getAssunto());
            }
        };
    private Comparator compRemetenteASC =
        new Comparator() {
            public int compare(Object o1, Object o2) {
                Mensagem m1 = (Mensagem) o1;
                Mensagem m2 = (Mensagem) o2;
                return m1.getRemetente().getNome().compareTo(
                    m2.getRemetente().getNome());
            }
        };
    private Comparator compRemetenteDESC =
        new Comparator() {
            public int compare(Object o1, Object o2) {
                Mensagem m1 = (Mensagem) o1;
                Mensagem m2 = (Mensagem) o2;
                return -1 * m1.getRemetente().getNome().compareTo(
                    m2.getRemetente().getNome());
            }
        };

    /*
     * para comparar duas mensagens em relao a seus destinatrios: ordene os
     * destinatrios das mensagens por seus nomes, Em seguida, compare as
     * mensagens pelos nomes nas listas de destinatrios
     */
    private Comparator compDestinatariosASC =
        new Comparator() {
            public int compare(Object obj1, Object obj2) {
                Mensagem m1 = (Mensagem) obj1;
                Mensagem m2 = (Mensagem) obj2;
                Collections.sort(m1.getDestinatarios());
                Collections.sort(m2.getDestinatarios());
                Usuario usr1 = (Usuario) m1.getDestinatarios().get(0);
                Usuario usr2 = (Usuario) m2.getDestinatarios().get(0);
                return usr1.getNome().compareTo(usr2.getNome());
            }
        };
    private Comparator compDestinatariosDESC =
        new Comparator() {
            public int compare(Object obj1, Object obj2) {
                Mensagem m1 = (Mensagem) obj1;
                Mensagem m2 = (Mensagem) obj2;
                Collections.sort(m1.getDestinatarios());
                Collections.sort(m2.getDestinatarios());
                Usuario usr1 = (Usuario) m1.getDestinatarios().get(0);
                Usuario usr2 = (Usuario) m2.getDestinatarios().get(0);
                return -1 * usr1.getNome().compareTo(usr2.getNome());
            }
        };

    /**
     * @param curso
     * @param usuario
     * @param nomeFerramenta
     * @throws IOException
     * @throws IOException
     * @throws ExtractionException
     */
    public TransformCorreio(Curso curso, Usuario usuario) throws IOException,
            ExtractionException {
        this(curso, usuario, new Correio(curso, usuario));
    }

    /**
     * @param curso
     * @param usuario
     * @param correio
     * @throws IOException
     */
    public TransformCorreio(Curso curso, Usuario usuario, Correio correio)
            throws IOException {
        super(curso, usuario, "correio");
        this.correio = correio;
    }

    /**
     *
     */
    public void geraArquivosHTML() throws Exception {
        VelocityEngine ve = super.createVelocityEngine();
        VelocityContext context = super.createVelocityContext();

        /*
         * 1. Gerar arquivo html para cada mensagem
         */
        Template t = ve.getTemplate("templates/correio/mensagem.vsl");
        geraHTMLMensagens(context, t, this.correio);

        /*
         * 2. Gerar arquivo html para cada tela de listagem: - mensagens
         * recebidas - mensagens enviadas - lixeira
         */
        t = ve.getTemplate("templates/correio/listagem.vsl");
        geraListagemRecebidas(context, t, this.correio);
        geraListagemEnviadas(context, t, this.correio);
        geraListagemLixeira(context, t, this.correio);
    }

    /**
     * @param context
     * @param t
     * @param correio2
     * @throws Exception
     * @throws MethodInvocationException
     * @throws ParseErrorException
     * @throws ResourceNotFoundException
     */
    private void geraListagemLixeira(VelocityContext context,
            Template template, Correio correio) throws ResourceNotFoundException,
            ParseErrorException, MethodInvocationException, Exception {
        context.put("listagem", "lixeira");
        /*
         * Passar somente as mensagens enviadas para o template
         */
        List mensagensLixeira = new ArrayList(correio.getMensagens().size());
        for (Iterator itr = correio.getMensagens().iterator(); itr.hasNext();) {
            Mensagem m = (Mensagem) itr.next();
            if (m.isLixeira()) {
                mensagensLixeira.add(m);
            }
        }

        /*
         * As mensagens podem ser ordenadas por assunto, destinatarios, data. Para
         * cada um destes, podemos ordenar descendente ou ascendente. Isto d um
         * total de 6 combinaes possveis para listar as mensagens.
         *
         * Para cada combinao, ordenamos a lista de mensagens e passamos no
         * writer.
         */
        String[] writers = new String[] {
                "/lixeiraDataDESC.html", // data, DESC (novo antes do velho)
                "/lixeiraDataASC.html",  // data, ASC (velho antes do novo)
                "/lixeiraAssuntoDESC.html", // assunto, DESC (alfabetica inversa)
                "/lixeiraAssuntoASC.html",  // assunto, ASC (alfabetica)
                "/lixeiraRemetenteDESC.html", // nome do remetente, DESC (alfabetica inversa)
                "/lixeiraRemetenteASC.html",  // nome do remetente, ASC (alfabetica)
                "/lixeiraDestinatariosDESC.html", // destinatarios
                "/lixeiraDestinatariosASC.html"   // destinatarios
        };

        String[] ords = new String[] {
                "data", "data",
                "assunto", "assunto",
                "remetente", "remetente",
                "destinatarios", "destinatarios"
        };

        Comparator[] comparators = new Comparator[] { compDataDESC,
                compDataASC, compAssuntoDESC, compAssuntoASC,
                compRemetenteDESC, compRemetenteASC,
                compDestinatariosDESC, compDestinatariosASC
        };

        geraHTMLListagem(context, template, mensagensLixeira, writers, ords,
                comparators);
    }

    /**
     * @param context
     * @param t
     * @param correio2
     * @throws Exception
     * @throws MethodInvocationException
     * @throws ParseErrorException
     * @throws ResourceNotFoundException
     */
    private void geraListagemEnviadas(VelocityContext context,
            Template template, Correio correio) throws ResourceNotFoundException,
            ParseErrorException, MethodInvocationException, Exception {
        context.put("listagem", "enviadas");
        /*
         * Passar somente as mensagens enviadas para o template
         */
        List mensagensEnviadas = new ArrayList(correio.getMensagens().size());
        for (Iterator itr = correio.getMensagens().iterator(); itr.hasNext();) {
            Mensagem m = (Mensagem) itr.next();
            if (m.isEnviada()) {
                mensagensEnviadas.add(m);
            }
        }

        /*
         * As mensagens podem ser ordenadas por assunto, destinatarios, data. Para
         * cada um destes, podemos ordenar descendente ou ascendente. Isto d um
         * total de 6 combinaes possveis para listar as mensagens.
         *
         * Para cada combinao, ordenamos a lista de mensagens e passamos no
         * writer.
         */
        String[] writers = new String[] {
                "/enviadasDataDESC.html", // data, DESC (novo antes do velho)
                "/enviadasDataASC.html", // data, ASC (velho antes do novo)
                "/enviadasAssuntoDESC.html", // assunto, DESC (alfabetica inversa)
                "/enviadasAssuntoASC.html", // assunto, ASC (alfabetica)
                "/enviadasDestinatariosDESC.html", // nome do remetente, DESC (alfabetica inversa)
                "/enviadasDestinatariosASC.html" // nome do remetente, ASC (alfabetica)
        };

        String[] ords = new String[] { "data", "data", "assunto", "assunto",
                "destinatarios", "destinatarios" };

        Comparator[] comparators = new Comparator[] { compDataDESC,
                compDataASC, compAssuntoDESC, compAssuntoASC,
                compDestinatariosDESC, compDestinatariosASC };

        geraHTMLListagem(context, template, mensagensEnviadas, writers, ords,
                comparators);

    }

    /**
     * @param context
     * @param template
     * @param correio2
     * @throws Exception
     * @throws MethodInvocationException
     * @throws ParseErrorException
     * @throws ResourceNotFoundException
     */
    private void geraListagemRecebidas(VelocityContext context,
            Template template, Correio correio) throws ResourceNotFoundException,
            ParseErrorException, MethodInvocationException, Exception {
        context.put("listagem", "recebidas");

        /*
         * Passar somente as mensagens recebidas para o template
         */
        List mensagensRecebidas = new ArrayList(correio.getMensagens().size());
        for (Iterator itr = correio.getMensagens().iterator(); itr.hasNext();) {
            Mensagem m = (Mensagem) itr.next();
            if (m.isRecebida()) {
                mensagensRecebidas.add(m);
            }
        }

        /*
         * As mensagens podem ser ordenadas por assunto, remetente, data. Para
         * cada um destes, podemos ordenar descendente ou ascendente. Isto d um
         * total de 6 combinaes possveis para listar as mensagens.
         *
         * Para cada combinao, ordenamos a lista de mensagens e passamos no
         * writer.
         */
        String[] writers = new String[] {
                "/index.html", // data, DESC (novo antes do velho)
                "/recebidasDataASC.html", // data, ASC (velho antes do novo)
                "/recebidasAssuntoDESC.html", // assunto, DESC (alfabetica inversa)
                "/recebidasAssuntoASC.html", // assunto, ASC (alfabetica)
                "/recebidasRemetenteDESC.html", // nome do remetente, DESC (alfabetica inversa)
                "/recebidasRemetenteASC.html" // nome do remetente, ASC (alfabetica)
        };

        String[] ords = new String[] { "data", "data", "assunto", "assunto",
                "remetente", "remetente" };

        Comparator[] comparators = new Comparator[] { compDataDESC,
                compDataASC, compAssuntoDESC, compAssuntoASC,
                compRemetenteDESC, compRemetenteASC };

        geraHTMLListagem(context, template, mensagensRecebidas, writers, ords,
                comparators);
    }

    private void geraHTMLListagem(VelocityContext context, Template template,
            List mensagens, String[] writers, String[] ords,
            Comparator[] comparators) throws ResourceNotFoundException,
            ParseErrorException, MethodInvocationException, Exception {

        context.put("listamensagens", mensagens);
        String[] sentidoOrds = new String[] { "desc", "asc" };

        for (int i = 0; i < writers.length; i++) {
            Collections.sort(mensagens, comparators[i]);
            context.put("ord", ords[i]);
            context.put("sentidoord", sentidoOrds[i % 2]);

            Writer writer = null;
            try {
                writer = super.createWriter(this.dirExtracao + writers[i]);
                template.merge(context, writer);
            } finally {
                if (writer != null) {
                    try {
                        writer.flush();
                        writer.close();
                    } catch (IOException ioex) {
                        ioex.printStackTrace();
                    }
                }
            }
        }
    }

    /**
     * @param context
     * @param t
     * @param correio2
     * @throws Exception
     * @throws MethodInvocationException
     * @throws ParseErrorException
     * @throws ResourceNotFoundException
     */
    private void geraHTMLMensagens(VelocityContext context, Template t,
            Correio correio) throws ResourceNotFoundException,
            ParseErrorException, MethodInvocationException, Exception {
        for (Iterator itr = correio.getMensagens().iterator(); itr.hasNext();) {
            Mensagem m = (Mensagem) itr.next();
            geraHTMLMensagem(context, t, m);
        }
    }

    /**
     * @param context
     * @param t
     * @param m
     * @throws Exception
     * @throws MethodInvocationException
     * @throws ParseErrorException
     * @throws ResourceNotFoundException
     */
    private void geraHTMLMensagem(VelocityContext context, Template t,
            Mensagem m) throws ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, Exception {
        Writer writer = null;
        context.put("mensagem", m);

        try {
            writer = super.createWriter(this.dirExtracao + "/mensagem_"
                    + m.getId() + ".html");
            t.merge(context, writer);
        } finally {
            if (writer != null) {
                try {
                    writer.flush();
                    writer.close();
                } catch (IOException ioex) {
                    ioex.printStackTrace();
                }
            }
        }
    }
}