/*
 * Created on Feb 1, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.diario;

import java.io.File;
import java.io.IOException;
import java.io.Writer;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.exception.ResourceNotFoundException;

import br.unicamp.nied.teleduc.extrator.config.Config;
import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;
import br.unicamp.nied.teleduc.extrator.usuario.UsuarioFactory;
import br.unicamp.nied.teleduc.transformador.Transform;

/**
 * @author andrey
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TransformDiario extends Transform {
    private Collection diarios;

    /**
     * @throws IOException
     */

    public TransformDiario(Curso curso, Usuario usuario) throws IOException {
        super(curso, usuario, "diario");
        File diretorioExtracao = new File(dirExtracao);
        if(!diretorioExtracao.exists()) {
            diretorioExtracao.mkdirs();
        }
    }

    public TransformDiario(Curso curso, Usuario usuario, Collection diarios) throws IOException {
        super(curso, usuario, "diario");
        File diretorioExtracao = new File(dirExtracao);
        this.diarios = diarios;
        if(!diretorioExtracao.exists()) {
            diretorioExtracao.mkdirs();
        }
    }

    /**
     * Funo inicial que chama ao outras para gerar os arquivos HTML referentes  ferramenta dirio
     */
    public void geraArquivosHTML() throws IOException, Exception {
        VelocityEngine ve = new VelocityEngine();
        ve.init(Config.getConfig().getProperties());

        /* Gera a lista dos dirios existentes no curso */
        geraListaDiarios(ve);

        /* Gera as anotaes de cada dirio existente no curso */
        geraAnotacoesDiario(ve);

        /* Gera a lista de anotaes relativas a um determinado dirio */
        geraListaAnotacoesDiario(ve);

        /* Gera todos os comentrios feitos em cada item do dirio */
        geraComentarios(ve);
    }

    /**
     * Gera a lista dos dirios existentes no curso
     *
     * @param ve
     * @throws IOException
     * @throws ExtractionException
     * @throws Exception
     */
    private void geraListaDiarios(VelocityEngine ve) throws IOException, ExtractionException, Exception {
        VelocityContext context = createVelocityContext();
        Writer writer = createWriter(this.dirExtracao + "/listaDiarios.html");

        context.put("diario", diarios);
        context.put("todosUsuarios", UsuarioFactory.getInstance(curso));

        try {
            Template t = ve.getTemplate("templates/diario/listaDiarios.vsl");
            t.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) { /* ignore */ }
        }
    }

    /**
     * Gera a lista de anotaes relativas a um determinado dirio
     *
     * @param ve
     * @throws IOException
     * @throws Exception
     */
    private void geraListaAnotacoesDiario(VelocityEngine ve) throws IOException, Exception {
        VelocityContext context = createVelocityContext();

        for (Iterator itr = diarios.iterator(); itr.hasNext();) {
            Diario diario = (Diario) itr.next();

            Collection itens = diario.getItens();
            Writer writer;

            if (diario.getId() == usuario.getId()) {
                writer = createWriter(this.dirExtracao + "/index.html");
            } else {
                writer = createWriter(this.dirExtracao + "/listaAnotacoesDiario_"+ diario.getId() +".html");
            }

            Usuario usuarioAtual = UsuarioFactory.getInstance(curso).getUsuario(diario.getId());

            context.put("usuarioAtual", usuarioAtual);
            context.put("diario", diario);
            context.put("todosUsuarios", UsuarioFactory.getInstance(curso));

            try {
                Template t = ve.getTemplate("templates/diario/listaAnotacoesDiario.vsl");
                t.merge(context, writer);
            } finally {
                try {
                    writer.flush();
                    writer.close();
                } catch (IOException ioex) { /* ignore */ }
            }

        }
    }

    /**
     * Gera as anotaes de cada dirio existente no curso
     *
     * @param ve
     * @throws IOException
     * @throws ResourceNotFoundException
     * @throws Exception
     */
    private void geraAnotacoesDiario(VelocityEngine ve) throws IOException, ResourceNotFoundException, Exception {
        VelocityContext context = createVelocityContext();

        for (Iterator itr = diarios.iterator(); itr.hasNext();) {
            Diario diario = (Diario) itr.next();

            List itens = diario.getItens();
            for (Iterator itr1 = itens.iterator(); itr1.hasNext();) {
                ItemDiario item = (ItemDiario) itr1.next();

                Writer writer = createWriter(this.dirExtracao + "/anotacoesDiario_"+  item.getId() +".html");

                context.put("item", item);
                context.put("usuarioAtual", UsuarioFactory.getInstance(curso).getUsuario(diario.getId()));
                context.put("todosUsuarios", UsuarioFactory.getInstance(curso));

                try {
                    Template t = ve.getTemplate("templates/diario/anotacoesDiario.vsl");
                    t.merge(context, writer);
                } finally {
                    try {
                        writer.flush();
                        writer.close();
                    } catch (IOException ioex) { /* ignore */ }
                }
            }
        }
    }

    /**
     * Gera todos os comentrios feitos em cada item do dirio
     *
     * @param ve
     * @throws ExtractionException
     * @throws IOException
     * @throws ResourceNotFoundException
     * @throws Exception
     */
    private void geraComentarios(VelocityEngine ve)
    throws ExtractionException, IOException, ResourceNotFoundException, Exception {
        VelocityContext context = createVelocityContext();

        for (Iterator itr = diarios.iterator(); itr.hasNext();) {
            Diario diario = (Diario) itr.next();

            List itens = diario.getItens();
            for (Iterator itr1 = itens.iterator(); itr1.hasNext();) {
                ItemDiario item = (ItemDiario) itr1.next();

                List comentarios = item.getComentarios();

                for (Iterator itr2 = comentarios.iterator(); itr2.hasNext();) {
                    Comentario comentario = (Comentario) itr2.next();

                    Writer writer = createWriter(this.dirExtracao + "/comentario_"+  comentario.getId() +".html");

                    context.put("comentario", comentario);
                    context.put("item", item);
                    context.put("usuarioAtual", UsuarioFactory.getInstance(curso).getUsuario(diario.getId()));
                    context.put("todosUsuarios", UsuarioFactory.getInstance(curso));

                    try {
                        Template t = ve.getTemplate("templates/diario/comentario.vsl");
                        t.merge(context, writer);
                    } finally {
                        try {
                            writer.flush();
                            writer.close();
                        } catch (IOException ioex) { /* ignore */ }
                    }
                }
            }
        }
    }
}
