/*
 * Created on Dec 7, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.dinamica;

import java.io.IOException;
import java.io.Writer;

import javax.xml.parsers.ParserConfigurationException;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;

import br.unicamp.nied.teleduc.extrator.config.Config;
import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;
import br.unicamp.nied.teleduc.transformador.Transform;

/**
 * @author pablo
 *
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class TransformDinamica extends Transform {
    private Dinamica din;

    /**
     * @throws IOException
     * @throws ExtractionException
     * @throws ParserConfigurationException
     *
     */
    public TransformDinamica(Curso curso, Usuario usuario) throws IOException,
            ExtractionException {
        this(curso, usuario, Dinamica.retornaDinamica(curso));
    }

    public TransformDinamica(Curso curso, Usuario usuario, Dinamica dinamica)
            throws IOException {
        super(curso, usuario, "dinamica");
        this.din = dinamica;
    }

    public void geraArquivosHTML() throws ResourceNotFoundException,
            ParseErrorException, MethodInvocationException, IOException,
            Exception {
        VelocityEngine ve = new VelocityEngine();
        ve.init(Config.getConfig().getProperties());

        VelocityContext context = createVelocityContext();
        /*
         * Inicia a gerao dos arquivos da dinamica
         */

        Template template = ve.getTemplate("templates/dinamica/itemMenu.vsl");
        geraItemMenu(context, template, din);

        if (din == null){
            din = new Dinamica();
            din.setTexto("A din&acirc;mica do curso ainda n&atilde;o foi fornecida pelo professor do curso.");
        }
        if (din.hasTexto()) {
            // System.out.println(din.getId() + " Tem texto");
            template = ve.getTemplate("templates/dinamica/itemConteudo.vsl");
            geraItemConteudo(context, template, din);
        } else {
            // System.out.println(din.getId() + " No tem texto");
        }

        template = ve.getTemplate("templates/dinamica/itemFrame.vsl");
        geraItemFrame(context, template, din);
    }

    private void geraItemMenu(VelocityContext context, Template template,
            Dinamica dinamica) throws ParseErrorException,
            MethodInvocationException, Exception {

        context.put("curso", curso);

        Writer writer = createWriter(this.dirExtracao + "/dinamicaMenu.html");
        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                /* ignore */
            }
        }
    }

    private void geraItemConteudo(VelocityContext context, Template template,
            Dinamica dinamica) throws ParseErrorException,
            MethodInvocationException, Exception {

        context.put("dinamica", dinamica);
        Writer writer = createWriter(this.dirExtracao
                + "/dinamicaConteudo.html");
        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                /* ignore */
            }
        }
    }

    private void geraItemFrame(VelocityContext context, Template template,
            Dinamica dinamica) throws ParseErrorException,
            MethodInvocationException, Exception {

        context.put("dinamica", dinamica);

        Writer writer = createWriter(this.dirExtracao + "/index.html");
        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                /* ignore */
            }
        }
    }
}