/*
 * Created on Oct 19, 2004
 *
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.forum;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.curso.Ferramenta;
import br.unicamp.nied.teleduc.extrator.database.ConnectionFactory;
import br.unicamp.nied.teleduc.extrator.database.DBException;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;
import br.unicamp.nied.teleduc.extrator.usuario.UsuarioFactory;

public class Forum extends Ferramenta{
    private String titulo;
    private Collection mensagens;
    private boolean avaliacao;

    public Forum() {
        super();
        this.mensagens = new ArrayList();
    }

    public static Collection retornaForuns(Curso curso, Usuario usuario) throws ExtractionException{
        Map mapForum  = new HashMap();
        Map mapMensagens = new HashMap();
        Collection retorno = new ArrayList();
        try {
            ConnectionFactory fac = ConnectionFactory.getConnectionFactory();
            Connection conn = fac.getConnection(curso.getBaseCurso());

            String sql = geraSQLForuns();
            PreparedStatement prep = conn.prepareStatement(sql);

            ResultSet rs = prep.executeQuery();
            while (rs.next()) {
                Forum forum = new Forum();
                forum.setData(rs.getLong("data"));
                forum.setId(rs.getInt("cod_forum"));
                forum.setTitulo(rs.getString("nome"));
                forum.setAvaliacao(false);

                mapForum.put(new Integer(forum.getId()),forum);
                retorno.add(forum);
            }

            String sqlAvaliacao = geraSQLForunsAvaliacao();
            PreparedStatement prepAvaliacao = conn.prepareStatement(sqlAvaliacao);

            rs = prepAvaliacao.executeQuery();
            while (rs.next()) {
                Forum forum = (Forum)mapForum.get(new Integer(rs.getInt("cod_forum")));
                forum.setAvaliacao(true);
            }

            String sqlMensagens = geraSQLMensagensForum();
            PreparedStatement prepMensagens = conn.prepareStatement(sqlMensagens);

            rs = prepMensagens.executeQuery();
            while (rs.next()) {
                Mensagem pai = null;
                Forum forum = (Forum)mapForum.get(new Integer(rs.getInt("cod_forum")));
                Mensagem mensagem = (Mensagem) mapMensagens.get(new Integer(rs.getInt("cod_msg")));

                if(mensagem == null){
                    mensagem = new Mensagem();
                    mensagem.setId(rs.getInt("cod_msg"));
                }
                mensagem.setData(rs.getLong("data"));
                mensagem.setAutor(UsuarioFactory.getInstance(curso).getUsuario(rs.getInt("cod_usuario")));
                //mensagem.setIdUsuario(rs.getInt("cod_usuario"));
                mensagem.setTitulo(rs.getString("titulo"));
                mensagem.setId(rs.getInt("cod_msg"));
                mensagem.setMensagem(rs.getString("mensagem"));
                mapMensagens.put(new Integer(mensagem.getId()),mensagem);
                forum.addMensagem(mensagem);

                if(rs.getInt("cod_msg_pai")!=0){
                    int cod_pai=rs.getInt("cod_msg_pai");
                    pai = (Mensagem) mapMensagens.get(new Integer(rs.getInt("cod_msg_pai")));
                    mensagem.setPai(pai);
                    if(pai==null){
                        pai.setId(cod_pai);
                        mapMensagens.put(new Integer(cod_pai),pai);
                        mensagem.setPai(pai);
                    }
                    pai.addResposta(mensagem);
                }
            }
        } catch (DBException e) {
            throw new ExtractionException("extracao do forum",e);
        } catch (IOException e) {
            throw new ExtractionException("extracao do forum",e);
        } catch (SQLException e) {
            throw new ExtractionException("extracao do forum",e);
        }


        return retorno;
    }


    /**
     * @param key Chaves dos foruns a extrair
     * @return
     */
    private static String geraSQLMensagensForum() {
        String sql = "select * from Forum_mensagens as M," +
                "Forum as F where F.cod_forum=M.cod_forum " +
                "and F.status='A' and M.status='A'";

        return sql;
    }

    private static String geraSQLForuns() {
        String sql = "select * from Forum where status='A'";
        return sql;
    }
    private static String geraSQLForunsAvaliacao() {
        String sql = "select F.cod_forum from Forum as F,  " +
                "Avaliacao as A where F.status='A' and " +
                "A.ferramenta='F' and A.status!='X' and " +
                "A.cod_atividade=F.cod_forum";
        return sql;
    }


    public Collection getMensagens() {   return mensagens;}

    public void setMensagens(List mensagens) {this.mensagens = mensagens;}

    public void addMensagem(Mensagem m) {   this.mensagens.add(m);}

    public String getTitulo() {    return titulo;}

    public void setTitulo(String titulo) { this.titulo = titulo;}

    public int hashCode() {     return this.id;}

    public boolean isAvaliacao() {	return avaliacao;}

    public void setAvaliacao(boolean avaliacao) {	this.avaliacao = avaliacao;}

    /* (non-Javadoc)
     * @see br.unicamp.nied.teleduc.extrator.curso.Ferramenta#nomeFerramenta()
     */
    protected String nomeFerramenta() {
        // TODO Auto-generated method stub
        return "forum";
    }
}
