/*
 * Created on Feb 14, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.forum;

import java.io.File;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;

import br.unicamp.nied.teleduc.extrator.config.Config;
import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;
import br.unicamp.nied.teleduc.extrator.usuario.UsuarioFactory;
import br.unicamp.nied.teleduc.transformador.Transform;

/**
 * @author andrey
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TransformForum extends Transform {
    private Collection foruns;

    /* Comparadores relativos  lista de fruns */
    private Comparator compForumData = new Comparator() {
        public int compare(Object obj1, Object obj2) {
            Forum forum1 = (Forum) obj1;
            Forum forum2 = (Forum) obj2;
            return forum1.getData().compareTo(forum2.getData());
        }
    };

    private Comparator compForumTitulo = new Comparator() {
        public int compare(Object obj1, Object obj2) {
            Forum forum1 = (Forum) obj1;
            Forum forum2 = (Forum) obj2;
            return forum1.getTitulo().compareToIgnoreCase(forum2.getTitulo());
        }
    };

    /* Comparadores relativos s mensagens dos fruns */
    private Comparator compMensagemTitulo = new Comparator() {
        public int compare(Object obj1, Object obj2) {
            Mensagem m1 = (Mensagem) obj1;
            Mensagem m2 = (Mensagem) obj2;
            return m1.getTitulo().compareToIgnoreCase(m2.getTitulo());
        }
    };

    private Comparator compMensagemData = new Comparator() {
        public int compare(Object obj1, Object obj2) {
            Mensagem m1 = (Mensagem) obj1;
            Mensagem m2 = (Mensagem) obj2;
            return m1.getData().compareTo(m2.getData());
        }
    };

    private Comparator compMensagemDataInvertida = new Comparator() {
        public int compare(Object obj1, Object obj2) {
            Mensagem m1 = (Mensagem) obj1;
            Mensagem m2 = (Mensagem) obj2;
            return -1 * m1.getData().compareTo(m2.getData());
        }
    };

    private Comparator compMensagemAutor = new Comparator() {
        public int compare(Object obj1, Object obj2) {
            Mensagem m1 = (Mensagem) obj1;
            Mensagem m2 = (Mensagem) obj2;

            Usuario u1 = m1.getAutor();
            Usuario u2 = m2.getAutor();

            return u1.getNome().compareToIgnoreCase(u2.getNome());
        }
    };

    public TransformForum(Curso curso, Usuario usuario) throws IOException {
        super(curso, usuario, "forum");
        File diretorioExtracao = new File(dirExtracao);
        if(!diretorioExtracao.exists()) {
            diretorioExtracao.mkdirs();
        }
    }

    public TransformForum(Curso curso, Usuario usuario, Collection foruns) throws IOException {
        super(curso, usuario, "forum");
        File diretorioExtracao = new File(dirExtracao);
        this.foruns = foruns;
        if(!diretorioExtracao.exists()) {
            diretorioExtracao.mkdirs();
        }
    }

    /**
     * Mtodo inicial que chama as funes auxiliares para gerar os arquivos html referentes ao portfolio.
     */
    public void geraArquivosHTML() throws IOException, Exception {
        VelocityEngine ve = new VelocityEngine();
        ve.init(Config.getConfig().getProperties());

        /* Gera a lista dos foruns de discusso de um determinado curso */
        geraListaForuns(ve);

        /* Gera a lista de mensagens de um determinado frum de discusso */
        geraListaMensagens(ve);
    }

    /**
     * Responsvel por dar base para o mtodo geraHTMLForum()
     *
     * @param ve
     * @throws IOException
     * @throws ExtractionException
     * @throws Exception
     */
    private void geraListaForuns(VelocityEngine ve) throws IOException, ExtractionException, Exception {
        VelocityContext context = createVelocityContext();
        Template t = ve.getTemplate("templates/forum/listaForuns.vsl");

        String[] writers = new String[] {
                "/index.html",
                "/listaForunsTitulo.html"
        };

        String[] ords = new String[] {
                "data", "titulo"
        };

        Comparator[] comparators = new Comparator[] {
                compForumData, compForumTitulo
        };

        geraHTMLForum(context, t, writers, ords, comparators);
    }

    /**
     * Gera o html referentes  lista de fruns
     *
     * @param context
     * @param t
     * @param writers
     * @param ords
     * @param comparators
     * @throws ExtractionException
     */
    private void geraHTMLForum(VelocityContext context, Template t, String[] writers, String[] ords, Comparator[] comparators)
        throws ExtractionException, Exception {

        context.put("foruns", foruns);
        List listaForuns = (List) foruns;

        for (int i = 0; i < writers.length; i++) {
            Collections.sort(listaForuns, comparators[i]);
            context.put("ord", ords[i]);

            Writer writer = null;

            try {
                writer = super.createWriter(this.dirExtracao + writers[i]);
                t.merge(context, writer);
            } finally {
                if (writer != null) {
                    try {
                        writer.flush();
                        writer.close();
                    } catch (IOException ioex) {
                        ioex.printStackTrace();
                    }
                }
            }
        }
    }

    /**
     * Responsvel por dar base para o mtodo geraHTMLMensagens()
     *
     * @param ve
     * @throws IOException
     * @throws ExtractionException
     * @throws Exception
     */
    private void geraListaMensagens(VelocityEngine ve) throws IOException, ExtractionException, Exception {
        VelocityContext context = createVelocityContext();

        Template t = ve.getTemplate("templates/forum/listaMensagens.vsl");

        for (Iterator itr = foruns.iterator(); itr.hasNext();) {
            Forum forum = (Forum) itr.next();

            String[] writers = new String[] {
                    "/listaMensagensAutor_"+ forum.getId() +".html",
                    "/listaMensagensData_"+ forum.getId() +".html",
                    "/listaMensagensTitulo_"+ forum.getId() +".html"
            };

            String[] ords = new String[] {
                    "autor", "data", "titulo"
            };

            Comparator[] comparators = new Comparator[] {
                    compMensagemAutor, compMensagemData, compMensagemTitulo
            };

            geraHTMLMensagens(ve, context, forum, t, writers, ords, comparators);
        }
    }

    /**
     * Gera o html referentes  lista de de mensagens
     *
     * @param ve
     * @param context
     * @param forum
     * @param t
     * @param writers
     * @param ords
     * @param comparators
     * @throws ExtractionException
     * @throws IOException
     * @throws ResourceNotFoundException
     * @throws Exception
     */
    private void geraHTMLMensagens
        (VelocityEngine ve, VelocityContext context, Forum forum, Template t, String[] writers, String[] ords, Comparator[] comparators)
        throws ExtractionException, IOException, ResourceNotFoundException, Exception {

        List mensagens = new ArrayList();
        Map espacos = new HashMap();
        List listaMensagensArvore = (List)forum.getMensagens();

        //Collections.sort(listaMensagensArvore, compMensagemDataInvertida);

        /* Organiza a lista de mensagens de um frum para a ordenao do tipo "arvore" */
        geraListaMensagensAux(listaMensagensArvore, mensagens, espacos);

        /* Organiza a lista de mensagens de um frum para as ordenaes dos tipos "autor", "titulo" e "data" */
        geraListaMensagensOrdenadas(t, writers, ords, comparators, forum);

        /* Organiza a lista de todas as mensagens de um forum */
        geraTodasMensagensOrdenadas(ve, ords, comparators, forum);

        /* Gera cada mensagem de frum pertencente a um curso */
        geraMensagem(ve, forum, mensagens);

        Writer writer = createWriter(this.dirExtracao + "/listaMensagensArvore_"+ forum.getId() +".html");
        context.put("ord", "arvore");
        context.put("forum", forum);
        context.put("mensagens", mensagens);
        context.put("espacos", espacos);

        /* Gera todas as mensagens de um forum com ordenao do tipo arvore */
        geraTodasMensagensOrdenadasArvore(ve, context, forum);

        try {
            t.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) { /* ignore */ }
        }
        mensagens.clear();
    }

    /**
     * Gera um html para cada ordenao de uma lista de mensagens
     *
     * @throws ExtractionException
     * @throws IOException
     */
    private void geraListaMensagensOrdenadas(Template t, String[] writers, String[] ords, Comparator[] comparators, Forum forum)
        throws ExtractionException, IOException, ResourceNotFoundException, Exception {
        VelocityContext context = createVelocityContext();

        List listaMensagens = (List) forum.getMensagens();

        for (int i = 0; i < writers.length; i++) {
            Collections.sort(listaMensagens, comparators[i]);

            context.put("ord", ords[i]);
            context.put("forum", forum);
            context.put("mensagens", listaMensagens);

            Writer writer = null;

            try {
                writer = super.createWriter(this.dirExtracao + writers[i]);
                t.merge(context, writer);
            } finally {
                if (writer != null) {
                    try {
                        writer.flush();
                        writer.close();
                    } catch (IOException ioex) {
                        ioex.printStackTrace();
                    }
                }
            }
        }
    }

    /**
     * Mtodo que inicialmente pega as mensagens raiz de um frum e chama geraListaMensagensAux2()
     * para gerar seus descendentes
     *
     * @param mensagens Collection com as mensagens do forum
     * @param mensagensRaiz List que armazenar as mensagens do forum ordenadas
     * @param espacos Map que indexar pelo cdigo da mensagem o nmero de antecedentes a ele
     */
    private void geraListaMensagensAux(Collection mensagens, List mensagensRaiz, Map espacos) {
        for (Iterator itr = mensagens.iterator(); itr.hasNext();) {
            Mensagem msg = (Mensagem) itr.next();
            if (msg.getPai() == null) {
                mensagensRaiz.add(msg);
                espacos.put(new Integer(msg.getId()), new Integer(0));
                geraListaMensagensAux2(msg, mensagensRaiz, espacos, 0);
            }
        }
    }

    /**
     * Auxiliar para gerar os descendentes dos tpicos raiz do frum
     *
     * @param msg Mensagem na qual vamos comear a recurso
     * @param espacos Map que associa a cada mensagem um Integer com o nivel do mesmo
     * @param nivel O nivel de msg, sendo a raiz nivel 1
     */
    private void geraListaMensagensAux2(Mensagem msg, List mensagensRaiz, Map espacos, int nivel) {
        int index, i;

        espacos.put(new Integer(msg.getId()), new Integer(nivel));

        for (Iterator itr = msg.getRespostas().iterator(); itr.hasNext();) {
            Mensagem resposta = (Mensagem) itr.next();

            if (resposta.getPai().getId() == msg.getId()) {
                index = mensagensRaiz.indexOf(msg);

                i = 1;
                if (index < mensagensRaiz.size() - 1) {
                    Mensagem tmpMsg = (Mensagem) mensagensRaiz.get(index + i);

                    while(tmpMsg.getPai().getId() == msg.getId()) {
                        i = i + 1;
                        if (index + i >= mensagensRaiz.size())
                            break;
                        tmpMsg = (Mensagem) mensagensRaiz.get(index + i);
                    }
                }

                mensagensRaiz.add(index + i, resposta);
                geraListaMensagensAux2(resposta, mensagensRaiz, espacos, nivel + 1);
            }
        }
    }

    /**
     * Mtodo que gera cada mensagem de frum relativa a um curso
     *
     * @param ve
     * @param forum
     * @param mensagens
     * @throws ExtractionException
     * @throws IOException
     * @throws ResourceNotFoundException
     * @throws Exception
     */
    private void geraMensagem(VelocityEngine ve, Forum forum, List mensagens)
        throws ExtractionException, IOException, ResourceNotFoundException, Exception {
        VelocityContext context = createVelocityContext();

        for (int i = 0; i < mensagens.size(); i++) {
            Mensagem msg = (Mensagem) mensagens.get(i);

            Writer writer = createWriter(this.dirExtracao + "/mensagem_"+ msg.getId() +".html");
            context.put("forum", forum);

            Mensagem proximaMensagem = null;
            Mensagem mensagemAnterior = null;

            if (i == mensagens.size() - 1) {
                /* Ultima mensagem */
                proximaMensagem = null;
            } else {
                proximaMensagem = (Mensagem) mensagens.get(i + 1);
            }

            if (i > 0) {
                mensagemAnterior = (Mensagem) mensagens.get(i - 1);
            } else {
                /* Primeira mensagem */
                mensagemAnterior = null;
            }

            if (mensagemAnterior != null) {
                context.put("mensagemAnterior", mensagemAnterior);
            } else {
                context.put("mensagemAnterior", new Boolean(false));
            }
            if (proximaMensagem != null) {
                context.put("proximaMensagem", proximaMensagem);
            } else {
                context.put("proximaMensagem", new Boolean(false));
            }

            context.put("mensagem", msg);
            context.put("todosUsuarios", UsuarioFactory.getInstance(curso));

            try {
                Template t = ve.getTemplate("templates/forum/mensagem.vsl");
                t.merge(context, writer);
            } finally {
                try {
                    writer.flush();
                    writer.close();
                } catch (IOException ioex) { /* ignore */ }
            }
        }
    }

    /**
     * Mtodo que gera a exibio de todas as mensagens de um determinado frum ordenado
     *
     * @param ve
     * @throws ExtractionException
     * @throws IOException
     * @throws Exception
     */
    private void geraTodasMensagensOrdenadas(VelocityEngine ve, String[] ords, Comparator[] comparators, Forum forum)
        throws ResourceNotFoundException, ParseErrorException, Exception {
        Template t = ve.getTemplate("templates/forum/todasMensagens.vsl");

        VelocityContext context = createVelocityContext();

        List listaMensagens = (List) forum.getMensagens();

        String[] writers = new String[] {
                "/todasMensagensAutor_"+ forum.getId() +".html",
                "/todasMensagensData_"+ forum.getId() +".html",
                "/todasMensagensTitulo_"+ forum.getId() +".html"
        };

        for (int i = 0; i < writers.length; i++) {
            Collections.sort(listaMensagens, comparators[i]);

            context.put("ord", ords[i]);
            context.put("forum", forum);
            context.put("mensagens", listaMensagens);

            Writer writer = null;

            try {
                writer = super.createWriter(this.dirExtracao + writers[i]);
                t.merge(context, writer);
            } finally {
                if (writer != null) {
                    try {
                        writer.flush();
                        writer.close();
                    } catch (IOException ioex) {
                        ioex.printStackTrace();
                    }
                }
            }
        }
    }

    /**
     * Separamos a ordenacao por arvore ja que esta nao segue nenhum padrao determinado
     *
     * @param ve
     * @param context
     * @param forum
     * @throws IOException
     * @throws ParseErrorException
     * @throws Exception
     */
    private void geraTodasMensagensOrdenadasArvore(VelocityEngine ve, VelocityContext context, Forum forum)
        throws IOException, ParseErrorException, Exception {
        Template t = ve.getTemplate("templates/forum/todasMensagens.vsl");
        Writer writer = createWriter(this.dirExtracao + "/todasMensagensArvore_"+ forum.getId() +".html");

        try {
            t.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) { /* ignore */ }
        }
    }
}