/*
 * Created on Nov 3, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.grupos;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.curso.Ferramenta;
import br.unicamp.nied.teleduc.extrator.database.ConnectionFactory;
import br.unicamp.nied.teleduc.extrator.database.DBException;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;
import br.unicamp.nied.teleduc.extrator.usuario.UsuarioFactory;

/**
 * @author pablo
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Grupo extends Ferramenta {
    private String nome = null;
    private List usuarios = null;
    private char status;

    public Grupo() {
        this.usuarios = new ArrayList();
    }

    /**
     *
     * @param usr
     * @return
     */
    public boolean contemUsuario(Usuario usr) {
        return this.usuarios.contains(usr);
    }

    /**
     *
     * @param idUsr
     * @return
     * @throws ExtractionException
     */
    public boolean contemUsuario(int idUsr, Curso curso) throws ExtractionException {
        //Usuario usr = new Usuario();
        //usr.setId(idUsr);
        Usuario usr = UsuarioFactory.getInstance(curso).getUsuario(idUsr);
        return this.contemUsuario(usr);
    }

    protected String nomeFerramenta() {
        return "grupos";
    }

    public static List todosGrupos(Curso curso) throws ExtractionException {
        return retornaGrupos(curso, true);
    }

    public static List gruposAtivos(Curso curso) throws ExtractionException {
        return retornaGrupos(curso, false);
    }

    private static List retornaGrupos(Curso curso, boolean retornarApagados) throws ExtractionException {
        List grupos = new ArrayList();
        PreparedStatement stmt = null;
        ResultSet         rs   = null;

        try {
            ConnectionFactory conFac = ConnectionFactory.getConnectionFactory();
            Connection con = conFac.getConnection(curso.getBaseCurso());
            String sql = null;
            if (retornarApagados) {
                sql = sqlTodosGrupos();
            } else {
                sql = sqlGruposAtivos();
            }

            // String sql = "select cod_grupo, nome from Grupos where status in ('A','T')";
            stmt = con.prepareStatement(sql);
            rs   = stmt.executeQuery();
            char status = 'A';
            while(rs.next()) {
                Grupo grupo = new Grupo();
                grupo.setId(rs.getInt("cod_grupo"));
                grupo.setNome(rs.getString("nome"));
                // Se ocorrer uma inconsistncia na base, e o status for NULL,
                // colocamos status = A
                String s = rs.getString("status");
                status = 'A';
                if (s != null) {
                    status = s.charAt(0);
                    grupo.setId(rs.getInt("cod_grupo"));
                }
                grupo.setStatus(status);
                grupo.setUsuarios(retornaUsuarios(curso, grupo.getId()));
                grupos.add(grupo);
            }
            /*
             * Colocamos os usurios sem grupo em um grupo a parte, falso.
             */
            sql = sqlUsuariosSemGrupo();
            stmt = con.prepareStatement(sql);
            rs   = stmt.executeQuery();
            if(rs.next()){
                List usu = new ArrayList();
                usu.add(new Usuario(curso, rs.getInt("cod_usuario")));
                while(rs.next()) {
                    usu.add(new Usuario(curso, rs.getInt("cod_usuario")));
                }
                /*
                 * Este grupo  falso, e rene os usurios sem grupo.
                 */
                Grupo grupo = new Grupo();
                grupo.setId(-1);
                grupo.setNome("");
                grupo.setStatus(status);
                grupo.setUsuarios(usu);
                grupos.add(grupo);
            }
        } catch (DBException e) {
            e.printStackTrace();
            throw new ExtractionException("Erro ao extrair grupos", e);
        } catch (IOException e) {
            e.printStackTrace();
            throw new ExtractionException("Erro ao extrair grupos", e);
        } catch (SQLException e) {
            e.printStackTrace();
            throw new ExtractionException("Erro ao extrair grupos", e);
        } finally {
            if (rs != null) {
                try { rs.close(); } catch (SQLException ex) { /* ignore */ }
            }
            if (stmt != null) {
                try { stmt.close(); } catch (SQLException ex) { /* ignore */ }
            }
        }

        return grupos;
    }

    /**
     * @param curso
     * @param idGrupo
     * @return usuarios collection contendo todos os ids de usuarios pertencendo ao grupo de id= idGrupo.
     * @throws IOException
     * @throws DBException
     * @throws SQLException
     */
    private static List retornaUsuarios(Curso curso, int idGrupo) throws ExtractionException {
        List usuarios = new ArrayList();
        PreparedStatement stmt = null;
        ResultSet         rs   = null;
        try {
            ConnectionFactory conFac = ConnectionFactory.getConnectionFactory();
            Connection con = conFac.getConnection(curso.getBaseCurso());
            String sql = "select * from Grupos_usuario as G, Usuario as U where  U.cod_usuario=G.cod_usuario and cod_grupo = " + idGrupo;
            stmt = con.prepareStatement(sql);
            rs   = stmt.executeQuery();

            while(rs.next()) {
                usuarios.add(new Usuario(curso, rs.getInt("cod_usuario")));
            }

        } catch (DBException dbex) {
            dbex.printStackTrace();
            throw new ExtractionException(
                "Erro ao buscar usuarios do grupo " + idGrupo,
                dbex);
        } catch (IOException ioex) {
            ioex.printStackTrace();
            throw new ExtractionException(
                "Erro ao buscar usuarios do grupo " + idGrupo,
                ioex);
        } catch (SQLException sqlex) {
            sqlex.printStackTrace();
            throw new ExtractionException(
                "Erro ao buscar usuarios do grupo " + idGrupo,
                sqlex);
        } finally {
            if (rs != null) {
                try { rs.close(); } catch (SQLException ex) { /* ignore */ }
            }
            if (stmt != null) {
                try { stmt.close(); } catch (SQLException ex) { /* ignore */ }
            }
        }

        return usuarios;
    }

    /**
     * Dado um usurio, retorna os grupos que contm aquele usurio.
     * So retornados objetos da classe Grupo.
     * Se quiser somente os ids dos Grupos, veja o mtodo idGruposDoUsuario(Curso, int)
     *
     * @see idGruposDoUsuario
     *
     * @param curso
     * @param id
     * @return Grupos que contm este usurio
     * @throws ExtractionException
     */
    public static Collection gruposDoUsuario(Curso curso, int id) throws ExtractionException {
        List usuarios = new ArrayList();
        ConnectionFactory conFac;
        PreparedStatement stmt = null;
        ResultSet         rs   = null;
        try {
            conFac = ConnectionFactory.getConnectionFactory();

            Connection con = conFac.getConnection(curso.getBaseCurso());
            String sql = "select cod_grupo from Grupos_usuario where cod_usuario = " + id;
            stmt = con.prepareStatement(sql);
            rs = stmt.executeQuery();
            while(rs.next()) {
                usuarios.add(new Integer(rs.getInt("cod_grupo")));
            }
        } catch (DBException dbex) {
            dbex.printStackTrace();
            throw new ExtractionException(
                "Erro ao buscar grupos do usuario " + id,
                dbex);
        } catch (IOException ioex) {
            ioex.printStackTrace();
            throw new ExtractionException(
                "Erro ao buscar grupos do usuario " + id,
                ioex);
        } catch (SQLException sqlex) {
            sqlex.printStackTrace();
            throw new ExtractionException(
                "Erro ao buscar grupos do usuario " + id,
                sqlex);
        } finally {
            if (rs != null) {
                try { rs.close(); } catch (SQLException ex) { /* ignore */ }
            }
            if (stmt != null) {
                try { stmt.close(); } catch (SQLException ex) { /* ignore */ }
            }
        }

        return usuarios;
    }

    /**
     * Retorna int[] com os id's dos grupos que contm este usurio.
     *
     * @see gruposDoUsuario
     *
     * @param curso
     * @param id
     * @return id's dos grupos que contm este usurio
     * @throws Exception
     */
    public static int[] idGruposDoUsuario(Curso curso, int id) throws ExtractionException {
        int[] usuarios = null;
        ConnectionFactory conFac;
        Connection con;
        PreparedStatement stmt = null;
        ResultSet         rs   = null;
        try {
            conFac = ConnectionFactory.getConnectionFactory();

            con = conFac.getConnection(curso.getBaseCurso());
            String sql = "select cod_grupo from Grupos_usuario where cod_usuario=" + id;
            stmt = con.prepareStatement(sql);
            rs = stmt.executeQuery();

            int count = ConnectionFactory.numeroDeLinhas(rs);
            if (count == 0) {
                return null;
            }

            usuarios = new int[count];
            int i=0;
            while(rs.next()) {
                usuarios[i] = rs.getInt("cod_grupo");
                i++;
            }

        } catch (DBException dbex) {
            dbex.printStackTrace();
            throw new ExtractionException(
                "Erro ao buscar grupos do usuario " + id,
                dbex);
        } catch (IOException ioex) {
            ioex.printStackTrace();
            throw new ExtractionException(
                "Erro ao buscar grupos do usuario " + id,
                ioex);
        } catch (SQLException sqlex) {
            sqlex.printStackTrace();
            throw new ExtractionException(
                "Erro ao buscar grupos do usuario " + id,
                sqlex);
        } finally {
            if (rs != null) {
                try { rs.close(); } catch (SQLException ex) { /* ignore */ }
            }
            if (stmt != null) {
                try { stmt.close(); } catch (SQLException ex) { /* ignore */ }
            }
        }

        return usuarios;
    }

    /**
     * @return Returns the usuarios.
     */
    public List getUsuarios() {
        return usuarios;
    }
    /**
     * @param usuarios The usuarios to set.
     */
    public void setUsuarios(List usuarios) {
        this.usuarios = usuarios;
    }
    /**
     *
     */
    public void addUsuario(Usuario usr) {
        this.usuarios.add(usr);
    }

    /**
     * @return Returns the nome.
     */
    public String getNome() {
        return nome;
    }
    /**
     * @param nome The nome to set.
     */
    public void setNome(String nome) {
        this.nome = nome;
    }

    /**
     * @return Returns the status.
     */
    public char getStatus() {
        return status;
    }
    /**
     * @param status The status to set.
     */
    public void setStatus(char status) {
        this.status = status;
    }
    /**
     *
     * @return
     */
    public boolean isApagado() {
        return this.status == 'X';
    }

    public int hashCode() {
        return this.id;
    }

    public boolean equals(Object obj) {
        if (obj instanceof Grupo) {
            Grupo g = (Grupo) obj;
            return g.id == this.id;
        }
        return false;
    }

    // ------------------------------------------------------------------------

    /**
     * SQL para buscar os grupos ativos. No retorna grupos apagados.
     *
     * @return SQL com as colunas na tabela Grupos
     * <ul>
     * <li><b>cod_grupo</b> - id do grupo</li>
     * <li><b>nome</b> - nome do grupo</li>
     * </ul>
     */
    private static String sqlGruposAtivos() {
        return "select cod_grupo, nome, status from Grupos where status in ('A','T')";
    }

    /**
     * SQL para buscar todos os grupos, inclusive grupos apagados.
     *
     * @return SQL com as colunas da tabela Grupos
     * <ul>
     * <li><b>cod_grupo</b> - id do grupo</li>
     * <li><b>nome</b> - nome do grupo</li>
     * <li><b>status</b> - status do grupo (A ou T, se ativo, X se apagado)
     * </ul>
     */
    private static String sqlTodosGrupos() {
        return "select cod_grupo, nome, status from Grupos";
    }

    /**
     * SQL para buscar usuarios sem grupo.
     *
     * @return SQL com a a coluna de cod_usuarios sem grupo
     * <ul>
     * <li><b>cod_usuario</b> - id do usuario</li>
     * </ul>
     */
    private static String sqlUsuariosSemGrupo(){
        return "select U.cod_usuario from Grupos_usuario as" +
                " Gu right join Usuario as U on" +
                " Gu.cod_usuario=U.cod_usuario left join " +
                "Grupos as G on Gu.cod_grupo=G.cod_grupo " +
                "where (G.status!='X' or G.status is null)" +
                " and Gu.cod_grupo is null and " +
                "U.cod_usuario>0 and " +
                "(binary U.tipo_usuario = 'A' or binary" +
                " U.tipo_usuario = 'F')";
    }
}
