/*
 * Created on Oct 20, 2004
 *
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.leituras;

import java.io.IOException;
import java.util.Collection;
import java.util.Iterator;

import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.curso.ExtratorFerramenta;
import br.unicamp.nied.teleduc.extrator.curso.Pasta;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;

/**
 * @author bruno
 *
 */
public class ExtratorLeituras extends ExtratorFerramenta {
    public ExtratorLeituras(Curso curso, Usuario usuario) {
        super(curso, usuario);
    }

    public void extrair() throws ExtractionException {
        /*
         * Copiar os arquivos dos itens
         */
        Pasta raiz = Leitura.retornaEstrutura(this.curso, this.usuario);
        copiaArquivos(raiz);

        /*
         * Gerar arquivos HTML para os itens da ferramenta
         */
        try {
            TransformLeituras trans = new TransformLeituras(this.curso,
                    this.usuario, raiz);
            trans.geraArquivosHTML();
        } catch (IOException e) {
            e.printStackTrace();
            throw new ExtractionException(
                    "Erro ao gerar arquivos HTML para a ferramenta Leituras", e);
        } catch (ResourceNotFoundException e) {
            e.printStackTrace();
            throw new ExtractionException(
                    "Erro ao gerar arquivos HTML para a ferramenta Leituras", e);
        } catch (ParseErrorException e) {
            e.printStackTrace();
            throw new ExtractionException(
                    "Erro ao gerar arquivos HTML para a ferramenta Leituras", e);
        } catch (Exception e) {
            e.printStackTrace();
            throw new ExtractionException(
                    "Erro ao gerar arquivos HTML para a ferramenta Leituras", e);
        }
    }

    /**
     * @param pasta
     * @throws ExtractionException
     */
    private void copiaArquivos(Pasta pasta) throws ExtractionException {
        /*
         * Copiar os arquivos dos itens
         */
        for (Iterator itr = pasta.getItens().iterator(); itr.hasNext();) {
            Leitura leitura = (Leitura) itr.next();
            Collection arquivos = copiaArquivos(leitura.getId());
            leitura.setArquivos(arquivos);
        }

        /*
         * Copiar recursivamente os arquivos nos itens das subpastas
         */
        for (Iterator itr = pasta.getSubPastas().iterator(); itr.hasNext();) {
            Pasta p = (Pasta) itr.next();
            copiaArquivos(p);
        }

    }

    public String nomeFerramenta() {
        return "leituras";
    }
}