/*
 * Created on Oct 20, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.leituras;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.curso.Ferramenta;
import br.unicamp.nied.teleduc.extrator.curso.Pasta;
import br.unicamp.nied.teleduc.extrator.database.ConnectionFactory;
import br.unicamp.nied.teleduc.extrator.database.DBException;
import br.unicamp.nied.teleduc.extrator.ferramentas.EnderecoWeb;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;

/**
 * @author bruno
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Leitura extends Ferramenta {
    private String titulo = null;
    private String texto = null;
    private char tipoCompartilhamento;

    protected String nomeFerramenta() { return "leituras"; }

public char getTipoCompartilhamento() {	return tipoCompartilhamento;}

public void setTipoCompartilhamento(char tipoCompartilhamento) {	this.tipoCompartilhamento = tipoCompartilhamento;}

public String getTexto() {	return texto;}

public void setTexto(String comentario) {	this.texto = comentario;}

public String getTitulo() {	return titulo;}

public void setTitulo(String titulo) {	this.titulo = titulo;}

public Leitura(){
    super();
    this.enderecosWeb = new ArrayList();
    this.arquivos = new ArrayList();
}

public static Pasta retornaEstrutura(Curso curso, Usuario usuario) throws ExtractionException{
    StringBuffer sqlPastas       = null;
    PreparedStatement stmtPastas = null;
    ResultSet rsPastas           = null;

    StringBuffer      sqlItens  = null;
    PreparedStatement stmtItens = null;
    ResultSet         rsItens   = null;
    ConnectionFactory fac;
    Pasta raiz      = new Pasta();

    Map mapPastas   = new HashMap();

    try {
        fac = ConnectionFactory.getConnectionFactory();
        Connection conn = fac.getConnection(curso.getBaseCurso());
        //pastas
        sqlPastas = geraSqlPastas(usuario);
        stmtPastas = conn.prepareStatement(sqlPastas.toString());
        rsPastas = stmtPastas.executeQuery();
        raiz.setNome("Raiz");
        raiz.setId(1);
        mapPastas.put(new Integer(1), raiz);
        while (rsPastas.next()) {
            int id    = rsPastas.getInt("cod_topico");
            Pasta pasta = (Pasta) mapPastas.get(new Integer(id));
            if(pasta != null){
                   pasta.setId(id);
                   pasta.setNome(rsPastas.getString("topico"));
                   pasta.setData(rsPastas.getLong("data"));
            }
            else {
                  pasta = new Pasta();
                  pasta.setId(id);
                  pasta.setNome(rsPastas.getString("topico"));
                  pasta.setData(rsPastas.getLong("data"));
                  mapPastas.put(new Integer(id), pasta);
            }
            int idPai = rsPastas.getInt("cod_topico_pai");
            Pasta pai = (Pasta) mapPastas.get(new Integer(idPai));
            if (pai == null) {
                pai = new Pasta();
                   pai.setId(idPai);
                  mapPastas.put(new Integer(idPai), pai);
            }
                    pai.addSubPasta(pasta);
        }
           //leituras
        Map mapLeituras   = new HashMap();
        sqlItens = geraSQLItens(usuario);
        stmtItens = conn.prepareStatement(sqlItens.toString());
        rsItens = stmtItens.executeQuery();
        while (rsItens.next()) {
            Leitura leitura = new Leitura();
            leitura.setTexto(rsItens.getString("texto"));
            leitura.setTitulo(rsItens.getString("titulo"));
            leitura.setId(rsItens.getInt("cod_item"));
            leitura.setData(rsItens.getLong("data"));
            leitura.setTipoCompartilhamento(rsItens.getString("tipo_compartilhamento").charAt(0));

            mapLeituras.put(new Integer(leitura.getId()) , leitura);
            Pasta pai = (Pasta) mapPastas.get(new Integer(rsItens.getInt("cod_topico")));
            pai.addItem((Ferramenta)leitura);
        }
        // 2. endere�os web de cada leitura
        StringBuffer sqlEnderecos = geraSQLEnderecos();
        PreparedStatement stmtEnderecos = conn.prepareStatement(sqlEnderecos.toString());
        ResultSet rsEnderecos = stmtEnderecos.executeQuery();

        while (rsEnderecos.next()) {
             EnderecoWeb ende = new EnderecoWeb();
             ende.setTitulo(rsEnderecos.getString("nome"));
             ende.setUrl(rsEnderecos.getString("endereco"));

             int codItem = rsEnderecos.getInt("cod_item");
             Leitura leitura = (Leitura) mapLeituras.get(new Integer(codItem));
             if(leitura!=null)
                leitura.addEnderecoWeb(ende);
           }
        return raiz;

    } catch (DBException dbex) {
          throw new ExtractionException(
                "Erro ao extrair Pergunta da base",
                dbex);
    } catch (IOException ioex) {
        throw new ExtractionException(
                "Erro ao extrair Leitura da base",
                ioex);
    } catch (SQLException sqlex) {
        throw new ExtractionException(
                "Erro ao extrair Pergunta da base",
                sqlex);
    }
    finally{
            if(rsPastas != null){
                try{
                    rsPastas.close();
                }catch(SQLException sqlex){}
            }
            if(stmtPastas != null){
                try{
                    stmtPastas.close();
                } catch(SQLException sqlex){}
            }
            if(rsItens != null){
                try{
                    rsItens.close();
                }catch(SQLException sqlex){}
            }
            if(stmtItens != null){
                try{
                stmtItens.close();
                }catch(SQLException sqlex) {}
            }
    }
}

/**
 * @param key
 * @return
 */
private static StringBuffer geraSQLItens(Usuario usuario) {
    StringBuffer sqlItens=null;
    if(usuario.getTipoUsuario()=='F')
    {
       sqlItens = new StringBuffer(
          "select * from Leitura_itens where status='L' and cod_topico!=2 and cod_topico!=0");
    }
    else{
       sqlItens = new StringBuffer(
          "select * from Leitura_itens as I, " +
          "Leitura_topicos as T where I.status='L' and " +
          "I.tipo_compartilhamento='T' and I.cod_topico!=2 " +
          "and I.cod_topico!=0 and T.tipo_compartilhamento='T'");
    }
    return sqlItens;
}

private static StringBuffer geraSQLEnderecos(){
    StringBuffer sqlEnderecos = new StringBuffer(
            "select cod_endereco, cod_item, nome, endereco" +
            " from Leitura_itens_enderecos order by cod_item");
    return sqlEnderecos;
}

/**
 * @return
 */
private static StringBuffer geraSqlPastas(Usuario usuario) {
    StringBuffer sqlPastas = null;
    if(usuario.getTipoUsuario()=='F')
    {
        sqlPastas = new StringBuffer(
            "select * from Leitura_topicos where cod_topico!=2 " +
            "and cod_topico_pai!=2 order by cod_topico");
    }
    else
    {
        sqlPastas = new StringBuffer(
        "select * from Leitura_topicos as T, Leitura_itens I where " +
        "T.cod_topico=I.cod_topico and I.status='L' and " +
        "I.tipo_compartilhamento='T' and T.cod_topico_pai!=2 " +
        "order by T.cod_topico");
    }
        return sqlPastas;
}

}
