/*
 * Created on Oct 21, 2004
 *
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.material;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.Ferramenta;
import br.unicamp.nied.teleduc.extrator.curso.Pasta;
import br.unicamp.nied.teleduc.extrator.database.ConnectionFactory;
import br.unicamp.nied.teleduc.extrator.database.DBException;
import br.unicamp.nied.teleduc.extrator.ferramentas.EnderecoWeb;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;

/**
 * @author pablo
 *
 */
public class Material extends Ferramenta {

    private int idAutor;

    private String titulo;

    private String comentario;

    protected String nomeFerramenta() {
        return "apoio";
    }

    public Material() {}

    public static Pasta retornaMateriais(Curso curso, Usuario usuario) {
        ConnectionFactory conFac = null;
        Connection con = null;
        PreparedStatement ps = null;
        ResultSet rs = null;
        Material material = null;
        Pasta pastaRaiz = new Pasta();
        Map mapPastas = new HashMap();

        try {
            conFac = ConnectionFactory.getConnectionFactory();
            con = conFac.getConnection(curso.getBaseCurso());
            ps = con.prepareStatement(geraSqlPastas(usuario));
            rs = ps.executeQuery();

            pastaRaiz.setNome("Raiz");
            pastaRaiz.setId(1);
            mapPastas.put(new Integer(1), pastaRaiz);

            while (rs.next()) {
                material = new Material();
                int id = rs.getInt("cod_topico");
                Pasta pasta = (Pasta) mapPastas.get(new Integer(id));
                if (pasta != null) {
                    pasta.setId(id);
                    pasta.setNome(rs.getString("topico"));
                    pasta.setData(rs.getLong("data"));
                    //mapPastas.put(new Integer(id), pasta);
                } else {
                    pasta = new Pasta();
                    pasta.setId(id);
                    pasta.setNome(rs.getString("topico"));
                    pasta.setData(rs.getLong("data"));
                    mapPastas.put(new Integer(id), pasta);
                }

                int idPai = rs.getInt("cod_topico_pai");
                Pasta pai = (Pasta) mapPastas.get(new Integer(idPai));
                if (pai == null) {
                    pai = new Pasta();
                    pai.setId(idPai);
                    mapPastas.put(new Integer(idPai), pai);
                }
                pai.addSubPasta(pasta);
            }

            ps = null;
            rs = null;
            //materiais
            Map mapMateriais = new HashMap();
            ps = con.prepareStatement(geraSqlMaterial(usuario));
            rs = ps.executeQuery();
            while (rs.next()) {
                material = new Material();
                material.setId(rs.getInt("cod_item"));
                material.setIdAutor(rs.getInt("cod_usuario"));
                material.setTitulo(rs.getString("titulo"));
                material.setComentario(rs.getString("texto"));
                material.setData(rs.getLong("data"));

                // material.setArquivos(material.retornaArquivos(curso));

                mapMateriais.put(new Integer(material.getId()), material);
                Pasta pai = (Pasta) mapPastas.get(new Integer(rs
                        .getInt("cod_topico")));
                pai.addItem((Ferramenta) material);
            }

            //2. endereos web de cada material
            String sql = geraSQLEnderecos();
            ps = con.prepareStatement(sql);
            rs = ps.executeQuery();

            while (rs.next()) {
                EnderecoWeb ende = new EnderecoWeb();
                ende.setTitulo(rs.getString("nome"));
                ende.setUrl(rs.getString("endereco"));

                int codItem = rs.getInt("cod_item");
                material = (Material) mapMateriais.get(new Integer(codItem));
                if (material != null)
                    material.addEnderecoWeb(ende);
            }

            return pastaRaiz;

        } catch (DBException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }

        return null;
    }

    private static String geraSqlPastas(Usuario usuario) {
        String sqlPastas = null;
        if (usuario.isFormador()) {
            sqlPastas = new String(
                    "select * from Apoio_topicos where cod_topico not in (0,2)"
                            + "and cod_topico_pai not in (0,2) order by cod_topico");
        } else {
            sqlPastas = new String(
                    "select * from Apoio_topicos as T, Apoio_itens I where "
                            + "T.cod_topico=I.cod_topico and I.status='L' and "
                            + "I.tipo_compartilhamento='T' and T.cod_topico_pai!=2 "
                            + "order by T.cod_topico");
        }
        return sqlPastas;
    }

    /**
     * @param usuario
     * @param codTopico
     * @return
     */
    private static String geraSqlMaterial(Usuario usuario) {
        //TODO verificar se Status='L' realmente pega td q precisamos... nao
        // temos documentacao
        //sobre os status
        String sql = null;
        if (usuario.isFormador()) {
            sql = "select cod_item, cod_usuario, titulo, texto, data, posicao_item, cod_topico "
                  + "from Apoio_itens where status = 'L' and cod_topico not in (0,2)";
        } else {
            sql = "select cod_item, cod_usuario, titulo, texto, data, posicao_item, cod_topico "
                    + "from Apoio_itens where status = 'L' and cod_topico != 0 and cod_topico != 2 and (tipo_compartilhamento = 'T' "
                    + "or cod_usuario = " + usuario.getId() + ")";
        }
        return sql;
    }

    private static String geraSQLEnderecos() {
        String sqlEnderecos = new String(
                "select cod_endereco, cod_item, nome, endereco"
                        + " from Apoio_itens_enderecos order by cod_item");
        return sqlEnderecos;
    }

    /**
     * @return Returns the comentario.
     */
    public String getComentario() {
        return comentario;
    }

    /**
     * @param comentario
     *            The comentario to set.
     */
    public void setComentario(String comentario) {
        this.comentario = comentario;
    }

    /**
     * @return Returns the id.
     */
    public int getId() {
        return id;
    }

    /**
     * @param id
     *            The id to set.
     */
    public void setId(int id) {
        this.id = id;
    }

    /**
     * @return Returns the idAutor.
     */
    public int getIdAutor() {
        return idAutor;
    }

    /**
     * @param idAutor
     *            The idAutor to set.
     */
    public void setIdAutor(int idAutor) {
        this.idAutor = idAutor;
    }

    /**
     * @return Returns the titulo.
     */
    public String getTitulo() {
        return titulo;
    }

    /**
     * @param titulo
     *            The titulo to set.
     */
    public void setTitulo(String titulo) {
        this.titulo = titulo;
    }

    // --------------------------------------------------------------

    public int hashCode() {
        return this.id;
    }

    public boolean equals(Object obj) {
        if (obj instanceof Material) {
            Material mat = (Material) obj;
            return this.id == mat.id;
        }
        return false;
    }
}