/*
 * Created on Jan 24, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.material;

import java.io.IOException;
import java.io.Writer;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;

import br.unicamp.nied.teleduc.extrator.config.Config;
import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.Pasta;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;
import br.unicamp.nied.teleduc.transformador.Transform;

/**
 * @author leonel
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class TransformMaterial extends Transform {
    private Pasta raizMateriais;

    /**
     * @param curso
     * @param usuario
     * @param nomeFerramenta
     * @throws IOException
     */
    public TransformMaterial(Curso curso, Usuario usuario) throws IOException {
        this(curso, usuario, Material.retornaMateriais(curso, usuario));
    }

    /**
     * @param curso
     * @param usuario
     * @param raiz
     * @throws IOException
     */
    public TransformMaterial(Curso curso, Usuario usuario, Pasta raiz)
            throws IOException {
        super(curso, usuario, "material");
        this.raizMateriais = raiz;
    }

    /*
     * (non-Javadoc)
     * 
     * @see br.unicamp.nied.teleduc.transformador.Transform#geraArquivosHTML()
     */
    public void geraArquivosHTML() throws Exception {
        VelocityEngine ve = new VelocityEngine();
        ve.init(Config.getConfig().getProperties());

        VelocityContext context = createVelocityContext();

        /*
         * Inicia a gerao de arquivos HTML da ferramenta Material de Apoio
         */
        Template template = ve
                .getTemplate("templates/material/pastaMaterial.vsl");
        geraHTMLPastaMaterial(context, template, this.raizMateriais);

        template = ve.getTemplate("templates/material/itemMaterial.vsl");
        geraHTMLItensMaterial(context, template, this.raizMateriais);
    }

    /**
     * @param context
     * @param template
     * @param raizMaterial
     * @throws Exception
     * @throws IOException
     * @throws MethodInvocationException
     * @throws ParseErrorException
     * @throws ResourceNotFoundException
     */
    private void geraHTMLPastaMaterial(VelocityContext context,
            Template template, Pasta raizMaterial)
            throws ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, IOException, Exception {
        context.put("raiz", raizMaterial);
        geraPastaMaterialAux(context, template, raizMaterial, raizMaterial);
    }

    /**
     * @param context
     * @param template
     * @param raizMaterial
     * @throws IOException
     * @throws MethodInvocationException
     * @throws ParseErrorException
     * @throws ResourceNotFoundException
     */
    private void geraPastaMaterialAux(VelocityContext context,
            Template template, Pasta raiz, Pasta pasta)
            throws ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, IOException, Exception {
        Writer writer = null;
        if (pasta == raiz) {
            writer = createWriter(this.dirExtracao + "/index.html");
        } else {
            writer = createWriter(this.dirExtracao + "/pastaMaterial_"
                    + pasta.getId() + ".html");
        }
        context.put("pasta", pasta);
        context.put("caminho", caminho(raiz, pasta));
        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                /* ignore */
            }
        }
        /*
         * Aplicar recursivamente para cada subpasta
         */
        for (Iterator itr = pasta.getSubPastas().iterator(); itr.hasNext();) {
            Pasta p = (Pasta) itr.next();
            geraPastaMaterialAux(context, template, raiz, p);
        }
    }

    /**
     * @param raiz
     * @param pasta
     * @return
     */
    private List caminho(Pasta raiz, Pasta pasta) {
        LinkedList caminho = new LinkedList();
        caminhoAux(raiz, pasta, caminho);
        return caminho;
    }

    private boolean caminhoAux(Pasta p1, Pasta p2, LinkedList l) {
        if (p1 == p2) {
            l.addFirst(p2);
            return true;
        } else {
            for (Iterator itr = p1.getSubPastas().iterator(); itr.hasNext();) {
                Pasta p = (Pasta) itr.next();
                if (caminhoAux(p, p2, l)) {
                    l.addFirst(p1);
                    return true;
                }
            }
            return false;
        }
    }

    /**
     * @param context
     * @param template
     * @param raizMaterial
     * @throws Exception
     * @throws MethodInvocationException
     * @throws ParseErrorException
     * @throws ResourceNotFoundException
     */
    private void geraHTMLItensMaterial(VelocityContext context,
            Template template, Pasta raizMaterial)
            throws ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, Exception {
        context.put("raiz", raizMaterial);
        geraItemMaterialAux(context, template, raizMaterial, raizMaterial);
    }

    private void geraItemMaterialAux(VelocityContext context,
            Template template, Pasta raiz, Pasta pasta)
            throws ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, Exception {
        /*
         * Gerar HTML para os itens desta pasta
         */
        context.put("pasta", pasta);
        context.put("caminho", caminho(raiz, pasta));
        for (Iterator itr = pasta.getItens().iterator(); itr.hasNext();) {
            Material item = (Material) itr.next();
            geraItem(context, template, raiz, pasta, item);
        }

        /*
         * Gerar recursivamente HTML para os itens das sub-pastas
         */
        for (Iterator itr = pasta.getSubPastas().iterator(); itr.hasNext();) {
            Pasta p = (Pasta) itr.next();
            geraItemMaterialAux(context, template, raiz, p);
        }
    }

    /**
     * @param context
     * @param template
     * @param raiz
     * @param pasta
     * @param item
     * @throws IOException
     * @throws ResourceNotFoundException
     * @throws ParseErrorException
     * @throws MethodInvocationException
     * @throws Exception
     */
    private void geraItem(VelocityContext context, Template template,
            Pasta raiz, Pasta pasta, Material item) throws IOException,
            ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, Exception {
        context.put("material", item);
        Writer writer = createWriter(this.dirExtracao + "/itemMaterial_"
                + item.getId() + ".html");
        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                /* ignore */
            }
        }
    }
}