/*
 * Created on Dec 1, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.menu;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.ferramentas.FerramentaTool;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.database.ConnectionFactory;
import br.unicamp.nied.teleduc.extrator.database.DBException;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;

/**
 * @author leonel
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Ferramenta {
    private int id;
    private boolean visivel;
    private int posicao;

    /**
     *
     */
    public Ferramenta() {
        super();
        // TODO Auto-generated constructor stub
    }

    /**
     * @return Returns the id.
     */
    public int getId() {
        return id;
    }
    /**
     * @param id The id to set.
     */
    public void setId(int id) {
        this.id = id;
    }
    /**
     * @return Returns the visivel.
     */
    public boolean isVisivel() {
        return visivel;
    }
    /**
     * @param visivel The visivel to set.
     */
    public void setVisivel(boolean visivel) {
        this.visivel = visivel;
    }

    /**
     * @return Returns the posicao.
     */
    public int getPosicao() {
        return posicao;
    }
    /**
     * @param posicao The posicao to set.
     */
    public void setPosicao(int posicao) {
        this.posicao = posicao;
    }

    public String getDiretorio() {
        return FerramentaTool.diretorioFerramenta(this.id);
    }

    public String getNome() {
        final FerramentaTool ferramentaTool = new FerramentaTool();
        return ferramentaTool.nomeFerramenta(this.id);
    }

    // ------------------------------------------------------------------------

    public static List todasFerramentas(Curso curso, Usuario usr)
        throws ExtractionException {

        String            sql  = sqlTodasFerramentas(usr);
        PreparedStatement stmt = null;
        ResultSet         rs   = null;

        List ret = new ArrayList();
        try {
            Connection conn = ConnectionFactory.getConnectionFactory().getConnection(curso.getBaseCurso());
            stmt = conn.prepareStatement(sql);
            rs   = stmt.executeQuery();
            while (rs.next()) {

                Ferramenta ferr = new Ferramenta();
                ferr.setId(rs.getInt("cod_ferramenta"));

                String s = rs.getString("status");
                if (s != null) {
                    ferr.setVisivel(s.charAt(0) == 'A');
                }

                /* Ordem na qual as ferramentas aparecem no menu */
                Connection connOrdem = ConnectionFactory.getConnectionFactory().getConnection(curso.getBaseGeral());
                String sqlOrdem = sqlPosicaoFerramentas();
                PreparedStatement stmtOrdem = connOrdem.prepareStatement(sqlOrdem);
                ResultSet rsOrdem = stmtOrdem.executeQuery();

                while (rsOrdem.next()) {
                    if (ferr.getId() == rsOrdem.getInt("cod_ferramenta")) {
                        ferr.setPosicao(rsOrdem.getInt("posicao"));
                    }
                }

                ret.add(ferr);
            }
        } catch (DBException dbex) {
            throw new ExtractionException("Erro ao extrair menu", dbex);
        } catch (IOException ioex) {
            throw new ExtractionException("Erro ao extrair menu", ioex);
        } catch (SQLException sqlex) {
            throw new ExtractionException("Erro ao extrair menu", sqlex);
        } finally {
            if (rs != null) {
                try { rs.close(); } catch (SQLException sqlex) { /* ignore */ }
            }
            if (stmt != null) {
                try { stmt.close(); } catch (SQLException sqlex) { /* ignore */ }
            }
        }
        return ret;
    }

    // ------------------------------------------------------------------------

    private static String sqlTodasFerramentas(Usuario usr) {
        return "select cod_ferramenta, status from Curso_ferramentas where cod_ferramenta <= 23";
    }

    private static String sqlPosicaoFerramentas() {
        return "select cod_ferramenta, posicao from Menu";
    }

}
