/*
 * Created on Mar 02, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.menu;

import java.io.File;
import java.io.IOException;
import java.io.Writer;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;

import br.unicamp.nied.teleduc.extrator.config.Config;
import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;
import br.unicamp.nied.teleduc.transformador.Transform;

/**
 * @author andrey
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TransformMenu extends Transform {
    private Collection ferramentas;

    private Comparator compPosicao = new Comparator() {
        public int compare(Object obj1, Object obj2) {
            Ferramenta f1 = (Ferramenta) obj1;
            Ferramenta f2 = (Ferramenta) obj2;

            Integer i1 = new Integer(f1.getPosicao());
            Integer i2 = new Integer(f2.getPosicao());

            return i1.compareTo(i2);
        }
    };

    public TransformMenu(Curso curso, Usuario usuario) throws IOException, ExtractionException {
        super(curso, usuario, "menu");
        File diretorioExtracao = new File(dirExtracao);
        if(!diretorioExtracao.exists()) {
            diretorioExtracao.mkdirs();
        }
    }

    public TransformMenu(Curso curso, Usuario usuario, Collection ferramentas) throws IOException, ExtractionException {
        super(curso, usuario, "menu");
        File diretorioExtracao = new File(dirExtracao);
        this.ferramentas = ferramentas;
        if(!diretorioExtracao.exists()) {
            diretorioExtracao.mkdirs();
        }
    }

    public void geraArquivosHTML() throws Exception {
        VelocityEngine ve = new VelocityEngine();
        ve.init(Config.getConfig().getProperties());

        /* Gera index.html do menu (frames) */
        geraIndex(ve);

        /* Responsavel pela gerao do menu do TelEduc */
        geraMenu(ve);
    }

    /**
     * Gera index de frames do TelEduc
     *
     * @throws IOException, Exception
     */
    private void geraIndex(VelocityEngine ve) throws IOException, Exception  {

        Writer writer = createWriter(this.dirExtracao + "/index.html");
        VelocityContext context = createVelocityContext();
        Template t = ve.getTemplate("templates/menu/index.vsl");

        try {
            t.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) { /* ignore */ }
        }
    }

    /**
     * Gera a lista de ferramentas (menu) do TelEduc
     *
     * @param ve
     * @throws IOException
     * @throws ExtractionException
     * @throws Exception
     */
    private void geraMenu(VelocityEngine ve) throws IOException, ExtractionException, Exception {

        Writer writer = createWriter(this.dirExtracao + "/menu.html");
        VelocityContext context = createVelocityContext();
        Template t = ve.getTemplate("templates/menu/menu.vsl");

        List listaFerramentas = (List) ferramentas;

        Collections.sort(listaFerramentas, compPosicao);

        context.put("ferramentas", listaFerramentas);

        try {
            t.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) { /* ignore */ }
        }
    }
}