/*
 * Created on Feb 1, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.mural;

import java.io.File;
import java.io.IOException;
import java.io.Writer;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.exception.ResourceNotFoundException;

import br.unicamp.nied.teleduc.extrator.config.Config;
import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;
import br.unicamp.nied.teleduc.extrator.usuario.UsuarioFactory;
import br.unicamp.nied.teleduc.transformador.Transform;

/**
 * @author andrey
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TransformMural extends Transform {
    private Collection murais;

    private Comparator compData = new Comparator() {
        public int compare(Object obj1, Object obj2) {
            Mural m1 = (Mural) obj1;
            Mural m2 = (Mural) obj2;
            return -1 * m1.getData().compareTo(m2.getData());
        }
    };

    /**
     * @param curso
     * @param usuario
     * @throws IOException
     * @throws ExtractionException
     */
    public TransformMural(Curso curso, Usuario usuario) throws IOException, ExtractionException {
        super(curso, usuario, "mural");
        File diretorioExtracao = new File(dirExtracao);
        if(!diretorioExtracao.exists()) {
            diretorioExtracao.mkdirs();
        }
    }

    public TransformMural(Curso curso, Usuario usuario, Collection murais) throws IOException, ExtractionException {
        super(curso, usuario, "mural");
        File diretorioExtracao = new File(dirExtracao);
        this.murais = murais;
        if(!diretorioExtracao.exists()) {
            diretorioExtracao.mkdirs();
        }
    }

    /**
     * Mtodo inicial que chama as funes auxiliares para gerar os arquivos html referentes ao mural.
     */
    public void geraArquivosHTML() throws Exception {
        VelocityEngine ve = new VelocityEngine();
        ve.init(Config.getConfig().getProperties());

        /* Gera a lista de todas as mensagens do mural */
        geraListaMural(ve);

        /* Gera cada mensagem pertencente ao mural */
        geraMensagensMural(ve);

    }

    /**
     * Responsvel por gerar a lista de murais de um determinado curso.
     *
     * @param ve Engine do Velocity passada pelo mtodo geraArquivosHTML()
     * @throws IOException
     * @throws ExtractionException
     * @throws Exception
     */
    private void geraListaMural(VelocityEngine ve) throws IOException, ExtractionException, Exception {
        VelocityContext context = createVelocityContext();
        Writer writer = createWriter(this.dirExtracao + "/index.html");

        List listaMurais = (List) murais;
        /* Ordenar a lista de murais para que os mais recentes fiquem antes */
        Collections.sort(listaMurais, compData);

        context.put("mural", listaMurais);
        context.put("todosUsuarios", UsuarioFactory.getInstance(curso));

        try {
            Template t = ve.getTemplate("templates/mural/listaMural.vsl");
            t.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) { /* ignore */ }
        }
    }

    /**
     * Responsvel por gerar cada mensagem referente a cada item da lista de murais
     *
     * @param ve Engine do Velocity passada pelo mtodo geraArquivosHTML()
     * @throws IOException
     * @throws ExtractionException
     * @throws ResourceNotFoundException
     * @throws Exception
     */
    private void geraMensagensMural(VelocityEngine ve)
        throws IOException, ExtractionException, ResourceNotFoundException, Exception {

        VelocityContext context = createVelocityContext();

        context.put("todosUsuarios", UsuarioFactory.getInstance(curso));

        for (Iterator itr = murais.iterator(); itr.hasNext();) {
            Mural mural = (Mural) itr.next();
            Writer writer = createWriter(this.dirExtracao + "/mensagemMural_"+ mural.getId() +".html");
            context.put("mensagem", mural);

            try {
                Template t = ve.getTemplate("templates/mural/mensagemMural.vsl");
                t.merge(context, writer);
            } finally {
                try {
                    writer.flush();
                    writer.close();
                } catch (IOException ioex) { /* ignore */ }
            }
        }
    }
}