/*
 * Created on Oct 26, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.parada;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.curso.Ferramenta;
import br.unicamp.nied.teleduc.extrator.curso.Pasta;
import br.unicamp.nied.teleduc.extrator.database.ConnectionFactory;
import br.unicamp.nied.teleduc.extrator.database.DBException;
import br.unicamp.nied.teleduc.extrator.ferramentas.EnderecoWeb;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;

/**
 * @author bruno
 *
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class Parada extends Ferramenta {
    private String titulo = null;
    private String texto  = null;

    protected String nomeFerramenta() {
        return "obrigatoria";
    }

    /**
     * @return Returns the texto.
     */
    public String getTexto() {
        return texto;
    }

    /**
     * @param texto
     *            The texto to set.
     */
    public void setTexto(String texto) {
        this.texto = texto;
    }

    /**
     * @return Returns the titulo.
     */
    public String getTitulo() {
        return titulo;
    }

    /**
     * @param titulo
     *            The titulo to set.
     */
    public void setTitulo(String titulo) {
        this.titulo = titulo;
    }

    public Parada() {
        super();
    }

    /**
     *
     * @param curso
     * @param usuario
     * @return
     * @throws ExtractionException
     */
    public static Pasta retornaEstrutura(Curso curso, Usuario usuario)
            throws ExtractionException {
        String sqlPastas = null;
        PreparedStatement stmtPastas = null;
        ResultSet rsPastas = null;

        String sqlItens = null;
        PreparedStatement stmtItens = null;
        ResultSet rsItens = null;
        ConnectionFactory fac;
        Pasta raiz = new Pasta();

        Map mapPastas = new HashMap();

        try {
            fac = ConnectionFactory.getConnectionFactory();
            Connection conn = fac.getConnection(curso.getBaseCurso());
            //pastas
            sqlPastas = geraSqlPastas(usuario);
            stmtPastas = conn.prepareStatement(sqlPastas.toString());
            rsPastas = stmtPastas.executeQuery();
            raiz.setNome("Raiz");
            raiz.setId(1);
            mapPastas.put(new Integer(1), raiz);
            while (rsPastas.next()) {
                int id = rsPastas.getInt("cod_topico");
                Pasta pasta = (Pasta) mapPastas.get(new Integer(id));
                if (pasta != null) {
                    pasta.setId(id);
                    pasta.setNome(rsPastas.getString("topico"));
                    pasta.setData(rsPastas.getLong("data"));
                } else {
                    pasta = new Pasta();
                    pasta.setId(id);
                    pasta.setNome(rsPastas.getString("topico"));
                    pasta.setData(rsPastas.getLong("data"));
                    mapPastas.put(new Integer(id), pasta);
                }
                int idPai = rsPastas.getInt("cod_topico_pai");
                Pasta pai = (Pasta) mapPastas.get(new Integer(idPai));
                if (pai == null) {
                    pai = new Pasta();
                    pai.setId(idPai);
                    mapPastas.put(new Integer(idPai), pai);
                }
                pai.addSubPasta(pasta);
            }
            //paradas
            Map mapParadas = new HashMap();
            sqlItens = geraSQLItens(usuario);
            stmtItens = conn.prepareStatement(sqlItens.toString());
            rsItens = stmtItens.executeQuery();
            while (rsItens.next()) {
                Parada parada = new Parada();
                parada.setTexto(rsItens.getString("texto"));
                parada.setTitulo(rsItens.getString("titulo"));
                parada.setId(rsItens.getInt("cod_item"));
                parada.setData(rsItens.getLong("data"));

                mapParadas.put(new Integer(parada.getId()), parada);
                Pasta pai = (Pasta) mapPastas.get(new Integer(rsItens
                        .getInt("cod_topico")));
                pai.addItem(parada);
            }
            // 2. endereos web de cada leitura
            String sqlEnderecos = geraSQLEnderecos();
            PreparedStatement stmtEnderecos = conn
                    .prepareStatement(sqlEnderecos.toString());
            ResultSet rsEnderecos = stmtEnderecos.executeQuery();

            while (rsEnderecos.next()) {
                EnderecoWeb ende = new EnderecoWeb();
                ende.setTitulo(rsEnderecos.getString("nome"));
                ende.setUrl(rsEnderecos.getString("endereco"));

                int codItem = rsEnderecos.getInt("cod_item");
                Parada parada = (Parada) mapParadas.get(new Integer(codItem));
                if (parada != null)
                    parada.addEnderecoWeb(ende);
            }
            return raiz;

        } catch (DBException dbex) {
            throw new ExtractionException("Erro ao extrair Pergunta da base",
                    dbex);
        } catch (IOException ioex) {
            throw new ExtractionException("Erro ao extrair Leitura da base",
                    ioex);
        } catch (SQLException sqlex) {
            throw new ExtractionException("Erro ao extrair Pergunta da base",
                    sqlex);
        } finally {
            if (rsPastas != null) {
                try {
                    rsPastas.close();
                } catch (SQLException sqlex) {
                    // ignore
                }
            }
            if (stmtPastas != null) {
                try {
                    stmtPastas.close();
                } catch (SQLException sqlex) {
                    // ignore
                }
            }
            if (rsItens != null) {
                try {
                    rsItens.close();
                } catch (SQLException sqlex) {
                    // ignore
                }
            }
            if (stmtItens != null) {
                try {
                    stmtItens.close();
                } catch (SQLException sqlex) {
                    // ignore
                }
            }
        }
    }

    private static String geraSQLItens(Usuario usuario) {
        String sqlItens = null;
        if (usuario.getTipoUsuario() == 'F') {
            sqlItens = "select * from Obrigatoria_itens where status='L' and cod_topico!=2 and cod_topico!=0";
        } else {
            sqlItens = "select * from Obrigatoria_itens where status='L'"
                    + " and tipo_compartilhamento='T' and cod_topico!=2 and cod_topico!=0";
        }
        return sqlItens;
    }

    private static String geraSQLEnderecos() {
        String sqlEnderecos = "select cod_endereco, cod_item, nome, endereco"
                + " from Obrigatoria_itens_enderecos order by cod_item";
        return sqlEnderecos;
    }

    /**
     * @return
     */
    private static String geraSqlPastas(Usuario usuario) {
        String sqlPastas = null;
        if (usuario.getTipoUsuario() == 'F') {
            sqlPastas = "select * from Obrigatoria_topicos where cod_topico!=2 "
                    + "and cod_topico_pai!=2 order by cod_topico";
        } else {
            //            sqlPastas = "select * from Obrigatoria_topicos as T, Leitura_itens I"
            //                    + " where T.cod_topico=I.cod_topico and I.status='L' and "
            //                    + "I.tipo_compartilhamento='T' and T.cod_topico_pai!=2 "
            //                    + "order by T.cod_topico";
            sqlPastas = "select * from Obrigatoria_topicos as T, Obrigatoria_itens I"
                + " where T.cod_topico=I.cod_topico and I.status='L' and "
                + "I.tipo_compartilhamento='T' and T.cod_topico_pai!=2 "
                + "order by T.cod_topico";
        }
        return sqlPastas;
    }

}