/*
 * Created on Feb 1, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.parada;

import java.io.IOException;
import java.io.Writer;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.curso.Pasta;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;
import br.unicamp.nied.teleduc.transformador.Transform;

/**
 * @author leonel
 *
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class TransformParada extends Transform {
    private Pasta raizParada;

    /**
     * @param curso
     * @param usuario
     * @param nomeFerramenta
     * @throws ExtractionException
     * @throws IOException
     */
    public TransformParada(Curso curso, Usuario usuario, String nomeFerramenta)
            throws IOException, ExtractionException {
        this(curso, usuario, Parada.retornaEstrutura(curso, usuario));
    }

    /**
     * @param curso
     * @param usuario
     * @param raiz
     * @throws IOException
     */
    public TransformParada(Curso curso, Usuario usuario, Pasta raiz)
            throws IOException {
        //super(curso, usuario, "obrigatoria");
        super(curso, usuario, "parada");
        this.raizParada = raiz;
    }

    public void geraArquivosHTML() throws IOException,
            ResourceNotFoundException, ParseErrorException, Exception {
        VelocityEngine ve = super.createVelocityEngine();
        VelocityContext context = super.createVelocityContext();

        /*
         * Inicia a gerao dos arquivos HTML para pastas na raiz
         */
        Template t = ve.getTemplate("templates/obrigatoria/pastaObrigatoria.vsl");
        geraHTMLPastas(context, t, this.raizParada);

        /*
         * Gera recursivamente os arquivos HTML para itens
         */
        t = ve.getTemplate("templates/obrigatoria/itemObrigatoria.vsl");
        geraHTMLItens(context, t, this.raizParada);
    }

    /**
     * @param context
     * @param t
     * @param pasta
     * @throws Exception
     * @throws IOException
     * @throws MethodInvocationException
     * @throws ParseErrorException
     * @throws ResourceNotFoundException
     */
    private void geraHTMLItens(VelocityContext context, Template template,
            Pasta raiz) throws ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, IOException, Exception {
        context.put("raiz", raiz);
        geraHTMLItensAux(context, template, raiz, raiz);
    }

    /**
     * @param context
     * @param template
     * @param raiz
     * @throws Exception
     * @throws IOException
     * @throws MethodInvocationException
     * @throws ParseErrorException
     * @throws ResourceNotFoundException
     */
    private void geraHTMLItensAux(VelocityContext context, Template template,
            Pasta raiz, Pasta pasta) throws ResourceNotFoundException,
            ParseErrorException, MethodInvocationException, IOException,
            Exception {
        /*
         * Gerar arquivos HTML para os itens desta pasta
         */
        context.put("pasta", pasta);
        context.put("caminho", caminho(raiz, pasta));
        for (Iterator itr = pasta.getItens().iterator(); itr.hasNext();) {
            Parada parada = (Parada) itr.next();
            geraItem(context, template, parada);
        }

        /*
         * Gerar recursivamente arquivos HTML para os itens das subpastas
         */
        for (Iterator itr = pasta.getSubPastas().iterator(); itr.hasNext();) {
            Pasta p = (Pasta) itr.next();
            geraHTMLItensAux(context, template, raiz, p);
        }
    }

    /**
     * @param context
     * @param template
     * @param parada
     * @throws Exception
     * @throws MethodInvocationException
     * @throws ParseErrorException
     * @throws IOException
     * @throws ResourceNotFoundException
     */
    private void geraItem(VelocityContext context, Template template,
            Parada parada) throws IOException, ResourceNotFoundException,
            ParseErrorException, MethodInvocationException, Exception {
        context.put("parada", parada);
        Writer writer = createWriter(this.dirExtracao + "/itemObrigatoria_"
                + parada.getId() + ".html");
        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                /* ignore */
            }
        }
    }

    /**
     * @param context
     * @param t
     * @param pasta
     * @throws Exception
     * @throws IOException
     * @throws MethodInvocationException
     * @throws ParseErrorException
     * @throws ResourceNotFoundException
     */
    private void geraHTMLPastas(VelocityContext context, Template t, Pasta raiz)
            throws ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, IOException, Exception {
        context.put("raiz", raiz);
        geraHTMLPastasAux(context, t, raiz, raiz);
    }

    private void geraHTMLPastasAux(VelocityContext context, Template template,
            Pasta raiz, Pasta pasta) throws IOException,
            ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, Exception {
        /*
         * Gerar HTML para a pasta
         */
        Writer writer = null;
        if (pasta == raiz) {
            writer = createWriter(this.dirExtracao + "/index.html");
        } else {
            writer = createWriter(this.dirExtracao + "/pastaObrigatoria_"
                    + pasta.getId() + ".html");
        }
        context.put("pasta", pasta);
        context.put("caminho", caminho(raiz, pasta));
        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                /* ignore */
            }
        }
        /*
         * Aplicar recursivamente para cada subpasta
         */
        for (Iterator itr = pasta.getSubPastas().iterator(); itr.hasNext();) {
            Pasta p = (Pasta) itr.next();
            geraHTMLPastasAux(context, template, raiz, p);
        }
    }

    /**
     * @param raiz
     * @param pasta
     * @return
     */
    private List caminho(Pasta raiz, Pasta pasta) {
        LinkedList caminho = new LinkedList();
        caminhoAux(raiz, pasta, caminho);
        return caminho;
    }

    private boolean caminhoAux(Pasta p1, Pasta p2, LinkedList l) {
        if (p1 == p2) {
            l.addFirst(p2);
            return true;
        } else {
            for (Iterator itr = p1.getSubPastas().iterator(); itr.hasNext();) {
                Pasta p = (Pasta) itr.next();
                if (caminhoAux(p, p2, l)) {
                    l.addFirst(p1);
                    return true;
                }
            }
            return false;
        }
    }
}