/*
 * Created on Oct 13, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.perguntasfrequentes;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.curso.Ferramenta;
import br.unicamp.nied.teleduc.extrator.database.ConnectionFactory;
import br.unicamp.nied.teleduc.extrator.database.DBException;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;

/**
 * @author leonel
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Pergunta extends Ferramenta{
    private String pergunta;
    private String resposta;

    public Pergunta() {
        super();
    }

    public String getPergunta() {    return pergunta;}

    public void setPergunta(String pergunta) {   this.pergunta = pergunta;}

    public String getResposta() {   return resposta;}

    public void setResposta(String resposta) {    this.resposta = resposta;}

    /**
     * Retorna o assunto raiz das perguntas frequentes.
     *
     * Retorna o assunto raiz das perguntas frequentes.
     * Este assunto  a raiz de uma rvore de assuntos.
     *
     * @param db
     * @param key
     * @return
     * @throws ExtractionException
     */
    public static Assunto retornaPerguntas(Curso curso, Usuario usuario) throws ExtractionException {
        // O assunto raiz retornado
        // serve apenas para manter os assuntos e a lixeira.
        Assunto raiz      = new Assunto();

        Map mapAssuntos   = new HashMap();
        //List listAssuntos = new ArrayList();
        ConnectionFactory fac;
        String sqlAssuntos       = null;
        PreparedStatement stmtAssuntos = null;
        ResultSet rsAssuntos           = null;

        String      sqlItens  = null;
        PreparedStatement stmtItens = null;
        ResultSet         rsItens   = null;
        try {
            fac = ConnectionFactory.getConnectionFactory();
            Connection conn = fac.getConnection(curso.getBaseCurso());
            raiz.setId(1);
            raiz.setNome("raiz");
            mapAssuntos.put(new Integer(1),raiz);
            // retorna todos os assuntos. No entanto, nem todos sero incluidos
            // no retorno, somente aqueles que estiverem na arvore que contem
            // itens selecionados.

            // 1. buscar as pastas e organizar a hierarquia

            sqlAssuntos  = geraSQLAssuntos();
            stmtAssuntos = conn.prepareStatement(sqlAssuntos);
            rsAssuntos   = stmtAssuntos.executeQuery();
            while (rsAssuntos.next()) {
                int id    = rsAssuntos.getInt("cod_assunto");
                int idPai = rsAssuntos.getInt("cod_assunto_pai");
                Assunto assunto = (Assunto) mapAssuntos.get(new Integer(id));

                if(assunto==null){
                    assunto = new Assunto();
                    assunto.setId(id);
                }
                assunto.setNome(rsAssuntos.getString("nome"));
                assunto.setDescricao(rsAssuntos.getString("descricao"));
                assunto.setData(rsAssuntos.getLong("data"));

                mapAssuntos.put(new Integer(id), assunto);
                Assunto pai = (Assunto) mapAssuntos.get(new Integer(idPai));
                if(pai==null){
                    pai = new Assunto();
                    pai.setId(idPai);
                    mapAssuntos.put(new Integer(idPai),pai);
                }
                pai.addSubAssunto(assunto);
            }
            // 2. Buscar as perguntas e anexa-las aos assuntos pais correspondentes
            sqlItens = geraSQLItens();
            stmtItens = conn.prepareStatement(sqlItens.toString());
            rsItens   = stmtItens.executeQuery();

            while (rsItens.next()) {
                Pergunta p = new Pergunta();
                p.setId(rsItens.getInt("cod_pergunta"));
                p.setData(rsItens.getLong("data"));
                p.setPergunta(rsItens.getString("pergunta"));
                p.setResposta(rsItens.getString("resposta"));

                Assunto assunto = (Assunto) mapAssuntos.get(new Integer(rsItens.getInt("cod_assunto")));
                assunto.addPergunta(p);
            }
            return raiz;
        } catch (IOException ioex) {
            throw new ExtractionException(
                "Erro ao extrair Pergunta da base",
                ioex);
        } catch (SQLException sqlex) {
            throw new ExtractionException(
                "Erro ao extrair Pergunta da base",
                sqlex);
        } catch (DBException dbex) {
            throw new ExtractionException(
                "Erro ao extrair Pergunta da base",
                dbex);
        } finally {
            // fechar recursos da sql de assuntos
            if (rsAssuntos != null) {
                try {
                    rsAssuntos.close();
                } catch (SQLException sqlex) { /* ignore */ }
            }

            if (stmtAssuntos != null) {
                try {
                    stmtAssuntos.close();
                } catch (SQLException sqlex) { /* ignore */ }
            }

            // fechar recursos da sql de itens
            if (rsItens != null) {
                try {
                    stmtItens.close();
                } catch (SQLException sqlex) { /* ignore */ }
            }

            if (stmtItens != null) {
                try {
                    stmtItens.close();
                } catch (SQLException sqlex) { /* ignore */ }
            }

        }
    }

    /**
     * @param key
     * @return
     */
    private static String geraSQLItens() {
        String sql = "select * from Pergunta_itens where cod_assunto!=2";
        return sql;
    }

    private static String geraSQLAssuntos() {
        String sql =
            "select cod_assunto, cod_assunto_pai, nome, " +
            "descricao, data from Pergunta_assuntos where " +
            "cod_assunto!=1 and cod_assunto!=2";
        return sql;
    }

    public int hashCode() {
        return this.id;
    }

    /* (non-Javadoc)
     * @see br.unicamp.nied.teleduc.extrator.curso.Ferramenta#nomeFerramenta()
     */
    protected String nomeFerramenta() {
        // TODO Auto-generated method stub
        return "perguntasfrequentes";
    }
}
