/*
 * Created on Feb 14, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.perguntasfrequentes;

import java.io.IOException;
import java.io.Writer;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;
import br.unicamp.nied.teleduc.transformador.Transform;

/**
 * @author rafael
 *
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class TransformPerguntas extends Transform {

    private Assunto raiz;

    public TransformPerguntas(Curso curso, Usuario usuario, Assunto assuntoRaiz)
            throws IOException {
        super(curso, usuario, "perguntas");
        this.raiz = assuntoRaiz;
    }

    public TransformPerguntas(Curso curso, Usuario usuario) throws IOException,
            ExtractionException {
        this(curso, usuario, Pergunta.retornaPerguntas(curso, usuario));
    }

    public void geraArquivosHTML() throws ResourceNotFoundException,
            ParseErrorException, MethodInvocationException, Exception {

        VelocityEngine ve = createVelocityEngine();

        // 1. Gerar lista dos assuntos
        geraListaAssuntos(ve);

        // 2. gerar lista de todas as perguntas
        geraListaPerguntas(ve);

        // 3. Gerar paginas das perguntas
        geraPaginaPerguntas(ve);
    }

    /**
     * @param ve
     * @throws ResourceNotFoundException
     * @throws ParseErrorException
     * @throws Exception
     */
    private void geraPaginaPerguntas(VelocityEngine ve)
            throws ResourceNotFoundException, ParseErrorException, Exception {
        // TODO Auto-generated method stub

        VelocityContext context = createVelocityContext();
        Template template = ve
                .getTemplate("/templates/perguntas/paginaPergunta.vsl");

        context.put("curso", curso);
        List caminho = new LinkedList();

        caminho.add(this.raiz);

        geraPaginaPerguntasAux(this.raiz, context, template, caminho);
    }

    /**
     * @param assunto
     * @param context
     * @param template
     * @param caminho
     * @throws Exception
     * @throws MethodInvocationException
     * @throws ParseErrorException
     */
    private void geraPaginaPerguntasAux(Assunto assunto,
            VelocityContext context, Template template, List caminho)
            throws ParseErrorException, MethodInvocationException, Exception {
        // TODO Auto-generated method stub

        for (Iterator iter = assunto.getPerguntas().iterator(); iter.hasNext();) {
            Pergunta p = (Pergunta) iter.next();

            context.put("pergunta", p);
            context.put("caminho", caminho);

            Writer writer = createWriter(this.dirExtracao + "/pergunta_"
                    + p.getId() + ".html");

            try {
                template.merge(context, writer);
            } finally {
                try {
                    writer.flush();
                    writer.close();
                } catch (IOException ioex) {
                    // igonorar
                }
            }

        }

        for (Iterator iter = assunto.getSubAssuntos().iterator(); iter
                .hasNext();) {
            Assunto a = (Assunto) iter.next();
            caminho.add(a);
            geraPaginaPerguntasAux(a, context, template, caminho);
            caminho.remove(a);
        }

    }

    /**
     * @param ve
     * @throws ResourceNotFoundException
     * @throws ParseErrorException
     * @throws MethodInvocationException
     * @throws Exception
     */
    private void geraListaPerguntas(VelocityEngine ve)
            throws ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, Exception {
        // TODO Auto-generated method stub

        VelocityContext context = createVelocityContext();
        Template template = ve
                .getTemplate("templates/perguntas/listaPerguntas.vsl");

        context.put("curso", curso);
        context.put("raiz", raiz);

        List caminho = new LinkedList();
        caminho.add(this.raiz);

        geraListaPerguntasAux(raiz, template, context, caminho);

    }

    /**
     * @throws Exception
     * @throws MethodInvocationException
     * @throws ParseErrorException
     * @throws ResourceNotFoundException
     *
     */
    private void geraListaPerguntasAux(Assunto assunto, Template template,
            VelocityContext context, List caminho)
            throws ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, Exception {
        // TODO Auto-generated method stub

        String arqHTML = "/listaPerguntas_" + assunto.getId() + ".html";

        List todasPerguntas = new LinkedList();
        List todosCaminhos = new LinkedList();

        // vamos preencher as duas listas recursivamente
        geraPerguntasCaminhos(assunto, todasPerguntas, todosCaminhos, caminho);

        context.put("assunto", assunto);
        context.put("caminho", caminho);
        context.put("todasPerguntas", todasPerguntas);
        context.put("todosCaminhos", todosCaminhos);

        Writer writer = createWriter(this.dirExtracao + arqHTML);

        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                // igonorar
            }
        }

        for (Iterator iter = assunto.getSubAssuntos().iterator(); iter
                .hasNext();) {
            Assunto a = (Assunto) iter.next();
            caminho.add(a);
            geraListaPerguntasAux(a, template, context, caminho);
            caminho.remove(a);
        }

    }

    /**
     * @param assunto
     * @param todasPerguntas
     * @param todosCaminhos
     */
    private void geraPerguntasCaminhos(Assunto assunto, List todasPerguntas,
            List todosCaminhos, List caminho) {
        // TODO Auto-generated method stub

        List caminhoAux = new LinkedList();
        caminhoAux.addAll(caminho);

        for (Iterator iter = assunto.getPerguntas().iterator(); iter.hasNext();) {
            Pergunta p = (Pergunta) iter.next();
            todasPerguntas.add(p);
            todosCaminhos.add(caminhoAux);

        }
        for (Iterator iter = assunto.getSubAssuntos().iterator(); iter
                .hasNext();) {
            Assunto a = (Assunto) iter.next();
            caminho.add(a);
            geraPerguntasCaminhos(a, todasPerguntas, todosCaminhos, caminho);
            caminho.remove(a);

        }

    }

    /**
     * @param ve
     * @throws ResourceNotFoundException
     * @throws ParseErrorException
     * @throws Exception
     * @throws MethodInvocationException
     */
    private void geraListaAssuntos(VelocityEngine ve)
            throws ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, Exception {
        // TODO Auto-generated method stub
        List caminho = new LinkedList();

        VelocityContext context = createVelocityContext();
        Template template = ve
                .getTemplate("templates/perguntas/listaAssuntos.vsl");

        context.put("curso", curso);
        context.put("raiz", raiz);

        caminho.add(this.raiz);

        geraListaAssuntosAux(context, template, this.raiz, caminho);

    }

    /**
     * @param context
     * @param template
     * @param assunto
     * @throws Exception
     * @throws MethodInvocationException
     * @throws ParseErrorException
     * @throws ResourceNotFoundException
     */
    private void geraListaAssuntosAux(VelocityContext context,
            Template template, Assunto assunto, List caminho)
            throws ResourceNotFoundException, ParseErrorException,
            MethodInvocationException, Exception {
        // TODO Auto-generated method stub

        String arqHTML = null;

        if (assunto.getId() == 1) {
            arqHTML = "/index.html";
        } else {
            arqHTML = "/listaAssunto_" + assunto.getId() + ".html";
        }

        context.put("caminho", caminho);
        context.put("assunto", assunto);

        Writer writer = createWriter(this.dirExtracao + arqHTML);

        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                // igonorar
            }
        }

        for (Iterator iter = assunto.getSubAssuntos().iterator(); iter
                .hasNext();) {
            Assunto a = (Assunto) iter.next();
            caminho.add(a);
            geraListaAssuntosAux(context, template, a, caminho);
            caminho.remove(a);
        }

    }

}