/*
 * Created on Oct 26, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.portfolio;

import java.io.IOException;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.curso.ExtratorFerramenta;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;

/**
 * @author leonel
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ExtratorPortfolio extends ExtratorFerramenta {

    /**
     * @param curso
     * @param usr
     */
    public ExtratorPortfolio(Curso curso, Usuario usr) {
        super(curso, usr);
    }

    public void extrair () throws ExtractionException {

        List portfoliosIndividuais = ItemPortfolio.findPortfoliosIndividuaisByUsuario(curso, usuario);
        extrairArquivos(portfoliosIndividuais);

        List portfoliosGrupo = ItemPortfolio.findPortfoliosGrupoByUsuario(curso, usuario);
        extrairArquivos(portfoliosGrupo);

        /*
         * Gerar arquivos HTML da ferramenta
         */
        try {
            TransformPortfolio transf = new TransformPortfolio(this.curso,
                    this.usuario, portfoliosIndividuais, portfoliosGrupo);
            transf.geraArquivosHTML();
        } catch (IOException ioex) {
            ioex.printStackTrace();
            throw new ExtractionException(
                    "Erro ao gerar arquivos HTML da ferramenta", ioex);
        } catch (ResourceNotFoundException e) {
            e.printStackTrace();
            throw new ExtractionException(
                    "Erro ao gerar arquivos HTML da ferramenta", e);
        } catch (ParseErrorException e) {
            e.printStackTrace();
            throw new ExtractionException(
                    "Erro ao gerar arquivos HTML da ferramenta", e);
        } catch (MethodInvocationException e) {
            e.printStackTrace();
            throw new ExtractionException(
                    "Erro ao gerar arquivos HTML da ferramenta", e);
        } catch (Exception e) {
            e.printStackTrace();
            throw new ExtractionException(
                    "Erro ao gerar arquivos HTML da ferramenta", e);
        }

    }

    public void extrairArquivos(List portfolios) throws ExtractionException {
        for (Iterator itr = portfolios.iterator(); itr.hasNext();) {
            Portfolio portfolio = (Portfolio) itr.next();
            extrairArquivosAux(portfolio);
        }
    }

    public void extrairArquivosAux(PastaPortfolio pasta) throws ExtractionException {
        /*
         * Copiar os arquivos de cada item da pasta
         */
        for (Iterator itr = pasta.getItens().iterator(); itr.hasNext();) {
            ItemPortfolio item = (ItemPortfolio) itr.next();

            Collection arquivos = copiaArquivos(item.getId(), item.nomeFerramenta());
            item.setArquivos(arquivos);

            /*
             * E de cada comentarios de um item
             */
            for (Iterator itr1 = item.getComentarios().iterator(); itr1.hasNext();) {
                Comentario comentario = (Comentario) itr1.next();

                Collection arquivos2 = copiaArquivos(comentario.getId(), comentario.nomeFerramenta());
                comentario.setArquivos(arquivos2);
            }
        }

        /*
         * Aplicar recursivamente nas sub-pastas
         */
        for (Iterator itr = pasta.getSubPastas().iterator(); itr.hasNext();) {
            PastaPortfolio subpasta = (PastaPortfolio) itr.next();
            extrairArquivosAux(subpasta);
        }
    }

    /* (non-Javadoc)
     * @see br.unicamp.nied.teleduc.extrator.curso.ExtratorFerramenta#nomeFerramenta()
     */
    public String nomeFerramenta() {
        return "portfolio";
    }

}
