/*
 * Created on Oct 26, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.ferramentas.portfolio;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.curso.Ferramenta;
import br.unicamp.nied.teleduc.extrator.database.ConnectionFactory;
import br.unicamp.nied.teleduc.extrator.database.DBException;
import br.unicamp.nied.teleduc.extrator.ferramentas.EnderecoWeb;
import br.unicamp.nied.teleduc.extrator.ferramentas.avaliacao.Avaliacao;
import br.unicamp.nied.teleduc.extrator.ferramentas.grupos.Grupo;
import br.unicamp.nied.teleduc.extrator.ferramentas.grupos.GrupoFactory;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;

/**
 * @author leonel
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ItemPortfolio extends Ferramenta {
    private int posicao;

    private String titulo;
    private String texto;
    private char compartilhamento;
    private Avaliacao avaliacao;

    private List comentarios;
    private static final byte PORTFOLIO_GRUPO = 0;
    private static final byte PORTFOLIO_INDIVIDUAL = 1;

    /**
     * Esta String  usada para encontrar o diretrio em que esto os arquivos da ferramenta.
     * Por exemplo, os arquivos da ferramenta Agenda esto no diretrio <code>agenda</code>,
     * os da ferramenta Material de Apoio esto no diretrio <code>apoio</code>.
     * Os da ferramenta Portflio esto no subdiretrio <code>portfolio/item</code>
     * Por este motivo a varivel ItemPortfolio.nomeFerramenta == "portfolio/item".
     * De maneira similar, os arquivos anexos aos comentrios esto no subdiretrio <code>portfolio/comentario</code>
     * A classe Comentario extende Ferramenta para facilitar a extrao dos arquivos dos comentrios.
     *
     * @see Comentario
     */
    // protected static String nomeFerramenta = "portfolio/item";
    protected String nomeFerramenta() {
        return "/item";
    }

    /**
     *
     */
    public ItemPortfolio() {
        super();
        this.comentarios  = new ArrayList();
    }

    /**
     * @return Returns the posicao.
     */
    public int getPosicao() {
        return posicao;
    }
    /**
     * @param posicao The posicao to set.
     */
    public void setPosicao(int posicao) {
        this.posicao = posicao;
    }

    /**
     * @return Returns the comentarios.
     */
    public List getComentarios() {
        return comentarios;
    }
    /**
     * @param comentarios The comentarios to set.
     */
    public void setComentarios(List comentarios) {
        this.comentarios = comentarios;
    }
    /**
     * @param c
     */
    public void addComentario(Comentario c) {
        this.comentarios.add(c);
    }

    /**
     * @return Returns the texto.
     */
    public String getTexto() {
        return texto;
    }
    /**
     * @param texto The texto to set.
     */
    public void setTexto(String texto) {
        this.texto = texto;
    }
    /**
     * @return Returns the titulo.
     */
    public String getTitulo() {
        return titulo;
    }
    /**
     * @param titulo The titulo to set.
     */
    public void setTitulo(String titulo) {
        this.titulo = titulo;
    }

    /**
     * @return Returns the avaliacao.
     */
    public Avaliacao getAvaliacao() {
        return avaliacao;
    }
    /**
     * @param avaliacao The avaliacao to set.
     */
    public void setAvaliacao(Avaliacao avaliacao) {
        this.avaliacao = avaliacao;
    }

    /**
     * @return Returns the compartilhamento.
     */
    public char getCompartilhamento() {
        return compartilhamento;
    }
    /**
     * @param compartilhamento The compartilhamento to set.
     */
    public void setCompartilhamento(char compartilhamento) {
        this.compartilhamento = compartilhamento;
    }

    /**
     * @return Retorna se o item  totalmente compartilhado
     */
    public boolean isTotalmenteCompartilhado() {
        if (compartilhamento == 'T') {
            return true;
        } else {
            return false;
        }
    }

    /**
     * @return Retorna se o item  compartilhado somente por formadores
     */
    public boolean isCompartilhadoPorFormadores() {
        if (compartilhamento == 'F') {
            return true;
        } else {
            return false;
        }
    }

    /**
     * @return Retorna se o item no  compartilhado
     */
    public boolean isNaoCompartilhado() {
        if (compartilhamento == 'P') {
            return true;
        } else {
            return false;
        }
    }

    /**
     *
     */
    public int hashCode() {
        return this.id;
    }

    /**
     * Considere que dois itens de portflio so iguais se tiverem o mesmo id.
     */
    public boolean equals(Object obj) {
        if (obj instanceof ItemPortfolio) {
            return this.id == ((ItemPortfolio) obj).id;
        }
        return false;
    }

    // ------------------------------------------------------------------------------

    /**
     * Retorna lista com os portfolios dos grupos que este usuario enxerga
     *
     * @param curso
     * @param usuario
     * @return
     */
    public static List findPortfoliosGrupoByUsuario(Curso curso, Usuario usuario)
        throws ExtractionException {

        return findPortfoliosByUsuario(curso, usuario, PORTFOLIO_GRUPO);
    }

    /**
     * Retorna lista com os portfolios individuais que este usuario enxerga
     *
     * @param curso
     * @param usuario
     * @return
     */
    public static List findPortfoliosIndividuaisByUsuario(Curso curso, Usuario usuario)
        throws ExtractionException {

        return findPortfoliosByUsuario(curso, usuario, PORTFOLIO_INDIVIDUAL);
    }

    /**
     *
     * @param curso
     * @param usuario
     * @param individualOuGrupo
     * @return
     * @throws ExtractionException
     */
    private static List findPortfoliosByUsuario(Curso curso, Usuario usuario, byte individualOuGrupo)
        throws ExtractionException {
        List ret = null;

        /*
         * Relaciona cada usuario com uma pasta de portfolio que ser a raiz
         * do portfolio daquele usuario
         * O mtodo pastasPortfoliosIndividuais vai preencher este map, logo
         * precisamos instanci-lo aqui.
         */
        Map raizes  = new HashMap();

        Map pastas = null;
        Map itens  = null;

        try  {
            ConnectionFactory f = ConnectionFactory.getConnectionFactory();
            Connection conn = f.getConnection(curso.getBaseCurso());

            if (individualOuGrupo == PORTFOLIO_INDIVIDUAL) {
                // 1. Buscar os portfolios de cada usuario
                // Estes portflios  que sero retornados
                ret    = portfoliosIndividuais(conn, curso, usuario, raizes);

                // 2. Buscar as pastas dentro de cada portfolio
                pastas = pastasPortfoliosIndividuais(conn, usuario, raizes);

                // 3. Buscar os itens dos portflios individuais
                itens = itensPortfoliosIndividuais(conn, curso, usuario, raizes, pastas);

            } else if (individualOuGrupo == PORTFOLIO_GRUPO) {
                // 1. Buscar as raizes dos portfolios de cada grupo
                // Estes portflios  que sero retornados
                ret    = portfoliosDeGrupo(conn, curso, usuario, raizes);

                // 2. Buscar as pastas dos portfolios de grupo dentro de cada portfolio
                pastas = pastasPortfoliosDeGrupo(conn, usuario, raizes);

                // 3. Buscar os itens
                itens = itensPortfoliosGrupo(conn, curso, usuario, raizes, pastas);
            } else {
                assert false : "Tipo invlido de portfolio";
            }

            // 4. Pendurar os comentarios nos itens
            comentariosPortfolios(conn, curso, usuario, itens);
        } catch (DBException dbex) {
            dbex.printStackTrace();
            throw new ExtractionException(
                "Erro ao extrair portfolios", dbex);
        } catch (SQLException sqlex) {
            sqlex.printStackTrace();
            throw new ExtractionException(
                "Erro ao extrair portfolios", sqlex);
        } catch (IOException ioex) {
            ioex.printStackTrace();
            throw new ExtractionException(
                "Erro ao extrair portfolios", ioex);
        }

        return ret;
    }

    /**
     * @param conn
     * @param usuario
     * @param itens
     * @throws SQLException
     */
    private static void comentariosPortfolios(Connection conn, Curso curso, Usuario usuario, Map itens)
        throws SQLException {
        String sql;
        PreparedStatement stmt = null;
        ResultSet rs = null;

        try {
            // 4. Buscar comentarios dos itens
            sql  = geraSQLComentarios(usuario);
            stmt = conn.prepareStatement(sql);
            rs   = stmt.executeQuery();
            while (rs.next()) {
                /*
                 * O SQL busca todos os comentrios sem verificar se o usuario tem acesso a eles.
                 * Por exemplo, o usuario pode ver os itens 1, 3 e 7. O SQL acima no verifica isso,
                 * e pode retornar os comentrios dos itens 1, 2, 3, 4, 5, 6 e 7.
                 * Ento precisamos verificar se o usurio pode ver o item que contm este comentrio.
                 */
                int idItem = rs.getInt("cod_item");
                ItemPortfolio item = (ItemPortfolio) itens.get(new Integer(idItem));
                if (item == null) {
                    // O usurio no pode ver este comentrio porque no pode ver o item associado.
                    // Descartamos este comentrio
                    continue;
                }

                Comentario c = new Comentario();
                c.setId(rs.getInt("cod_comentario"));
                c.setData(rs.getLong("data"));
                c.setIdAutor(rs.getInt("cod_comentarista"));
                c.setTexto(rs.getString("comentario"));

                // arquivos
//                Collection arquivos = item.retornaArquivos(curso);
//                if (arquivos != null) {
//                    item.setArquivos(arquivos);
//                }

                item.addComentario(c);

            }
        } finally {
            try {
                rs.close();
                stmt.close();
            } catch (SQLException sqlex) { /* ignore */ }
        }
    }

    /**
     *
     * @param conn
     * @param usuario
     * @param portfolios
     * @param pastas
     * @return
     * @throws SQLException
     */
    private static Map itensPortfoliosIndividuais(Connection conn, Curso curso, Usuario usuario, Map portfolios, Map pastas)
        throws ExtractionException {
        return itensPortfolios(conn, curso, usuario, portfolios, pastas, PORTFOLIO_INDIVIDUAL);
    }

    /**
     *
     * @param conn
     * @param usuario
     * @param portfolios
     * @param pastas
     * @return
     * @throws SQLException
     */
    private static Map itensPortfoliosGrupo(Connection conn, Curso curso, Usuario usuario, Map portfolios, Map pastas)
        throws ExtractionException {
        return itensPortfolios(conn, curso, usuario, portfolios, pastas, PORTFOLIO_GRUPO);
    }


    /**
     * Retorna mapeamento sobre os itens de portfolios individuais.
     *
     * @param conn Conexo sql, para no ter de criar uma nova conexo dentro do mtodo.
     * @param usuario Usuario para o qual estamos realizando a extrao
     * @param portfolios Mapeamento sobre os portfolios. Como os portfolios tambm so encarados como pastas de portflios, podemos anexar itens neles.
     * @param pastas Mapeamento sobre as pastas de itens. Sero anexados itens neles.
     *
     * @return Mapeamento sobre os itens
     *
     * @throws SQLException
     */
    private static Map itensPortfolios(
                Connection conn,
                Curso curso,
                Usuario usuario,
                Map portfolios,
                Map pastas,
                byte individualOuGrupo)
        throws ExtractionException {
        Map itens = new HashMap();

        String sql = null;
        PreparedStatement stmt = null;
        ResultSet rs = null;

        try {
            // 3. buscar os itens dos portfolios
            if (individualOuGrupo == PORTFOLIO_INDIVIDUAL) {
                sql  = geraSQLItensPortfoliosIndividuais(usuario);
            } else if (individualOuGrupo == PORTFOLIO_GRUPO) {

                int idGrupo[] = Grupo.idGruposDoUsuario(curso, usuario.getId());
                if (idGrupo == null) {
                    // No h grupos no curso, logo no h portflios de grupo.
                    //return itens;
                    sql = geraSQLItensPortfoliosOutrosGrupo(usuario);
                } else {
                    sql  = geraSQLItensPortfoliosGrupo(idGrupo, usuario);
                }
            } else {
                assert false : "Tipo invlido de portfolio";
            }

            stmt = conn.prepareStatement(sql);
            rs   = stmt.executeQuery();
            while (rs.next()) {
                ItemPortfolio item = new ItemPortfolio();

                int id;
                item.setId(id = rs.getInt("cod_item"));
                item.setTitulo(rs.getString("titulo"));
                item.setTexto(rs.getString("texto"));
                item.setData(rs.getLong("data"));
                item.setPosicao(rs.getInt("posicao_item"));
                item.setCompartilhamento(rs.getString("tipo_compartilhamento").charAt(0));

                /* Estamos verificando se o item possui enderecos web correspondentes */
                String sqlEnderecosWeb = geraSQLEnderecosWeb(item.getId());
                PreparedStatement stmtEnderecosWeb = conn.prepareStatement(sqlEnderecosWeb);
                ResultSet rsEnderecosWeb = stmtEnderecosWeb.executeQuery();

                while (rsEnderecosWeb.next()) {
                    EnderecoWeb end = new EnderecoWeb();
                    end.setTitulo(rsEnderecosWeb.getString("nome"));
                    end.setUrl(rsEnderecosWeb.getString("endereco"));
                    item.addEnderecoWeb(end);
                }

                /* Estamos verificando se o item possui avaliacao correspondente */
                String sqlAvaliacao = geraSQLAvaliacao(item.getId());
                PreparedStatement stmtAvaliacao = conn.prepareStatement(sqlAvaliacao);
                ResultSet rsAvaliacao = stmtAvaliacao.executeQuery();

                if(rsAvaliacao.next()) {
                    Avaliacao aval = new Avaliacao();
                    aval.setTitulo(rsAvaliacao.getString("titulo"));
                    aval.setId(rsAvaliacao.getInt("cod_avaliacao"));
                    aval.setIdAtividade(rsAvaliacao.getInt("cod_atividade"));
                    item.setAvaliacao(aval);
                }

                // este item pode ser filho da raiz ou de uma outra pasta
                int idPasta = rs.getInt("cod_topico");
                Integer iPasta = new Integer(idPasta);
                PastaPortfolio p = (PastaPortfolio) pastas.get(iPasta);
                if (p == null) {
                    p = (PastaPortfolio) portfolios.get(iPasta);
                }

                // arquivos
                //Collection arquivos = item.getArquivos();
//                if (arquivos != null) {
//                    item.setArquivos(arquivos);
//                }

                p.addItem(item);

                itens.put(new Integer(id), item);
            }
        } catch (SQLException sqlex) {
            throw new ExtractionException(
                "Erro ao extrair itens de portfolio",
                sqlex);
        } finally {
            if (rs != null) {
                try { rs.close(); } catch (SQLException ex) { /* ignore */ }
            }
            if (stmt != null) {
                try { stmt.close(); } catch (SQLException ex) { /* ignore */ }
            }
        }

        return itens;
    }

    /**
     *
     * @param conn
     * @param usuario
     * @param portfolios
     * @param individualOuGrupo
     * @return
     * @throws SQLException
     */
    private static Map pastasPortfolios(Connection conn, Usuario usuario, Map portfolios, byte individualOuGrupo)
        throws SQLException {

        Map pastas = new HashMap();
        String sql;
        if (individualOuGrupo == PORTFOLIO_INDIVIDUAL) {
            sql = geraSQLPastasPortfoliosIndividuais(usuario);
        } else {
            sql = geraSQLPastasPortfoliosGrupo(usuario);
        }
        PreparedStatement stmt = conn.prepareStatement(sql);
        ResultSet rs   = stmt.executeQuery();

        try {
            while (rs.next()) {
                int idPai = rs.getInt("cod_topico_pai");
                Integer iPai = new Integer(idPai);

                // verifica se esta pasta eh filho direto da raiz dos portfolios
                // deste usuario
                PastaPortfolio pai = (PastaPortfolio) portfolios.get(iPai);
                if (pai == null) {
                    // Nao , ento deve ser filho de outra pasta.
                    // Verifica se a pasta pai desta j foi buscada
                    pai = (PastaPortfolio) pastas.get(iPai);
                    if (pai == null) {
                        // A pasta pai ainda nao foi buscada. Forjamos um pai.
                        // Depois quando o pai verdadeiro aparecer, substituimos
                        pai = new PastaPortfolio();
                        pai.setId(idPai);
                        pastas.put(iPai, pai);
                    }
                }

                int id = rs.getInt("cod_topico");
                Integer i = new Integer(id);
                PastaPortfolio p = (PastaPortfolio) pastas.get(i);
                if (p == null) {
                    p = new PastaPortfolio();
                    p.setId(id);

                    pastas.put(i, p);
                }
                p.setTitulo(rs.getString("topico"));
                p.setData(rs.getLong("data"));
                p.setPosicao(rs.getInt("posicao_topico"));
                pai.addSubPasta(p);
            }
        } finally {
            if (rs != null) {
                try { rs.close(); } catch (SQLException ex) { /* ignore */ }
            }
            if (stmt != null) {
                try { stmt.close(); } catch (SQLException ex) { /* ignore */ }
            }
        }

        return pastas;
    }


    /**
     * Retorna as pastas criados por usurios dentro dos portfolios de grupos.
     * No retorna as raizes.
     *
     * @see pastasPortfolios
     *
     * @param conn Conexo com BD.
     * @param usuario Usurio para o qual estamos realizando a extrao.
     * @param portfolios Mapeamento sobre os portflios. As pastas retornadas sero anexadas aos portflios, de acordo com a hierarquia;
     * @return Mapeamento sobre as pastas.
     */
    private static Map pastasPortfoliosDeGrupo(Connection conn, Usuario usuario, Map portfolios)
        throws SQLException {

        return pastasPortfolios(conn, usuario, portfolios, PORTFOLIO_GRUPO);
    }

    /**
     * Retorna as pastas criados por usurios dentro dos portfolios individuais.
     * No retorna as raizes.
     *
     * @see pastasPortfolios
     *
     * @param conn Conexo com BD.
     * @param usuario Usurio para o qual estamos realizando a extrao.
     * @param portfolios Mapeamento sobre os portflios. As pastas retornadas sero anexadas aos portflios, de acordo com a hierarquia;
     * @return Mapeamento sobre as pastas.
     */
    private static Map pastasPortfoliosIndividuais(Connection conn, Usuario usuario, Map portfolios)
        throws SQLException {
        return pastasPortfolios(conn, usuario, portfolios, PORTFOLIO_INDIVIDUAL);
    }


    /**
     * @param conn
     * @param usuario
     * @param raizes
     * @return
     */
    private static List portfoliosDeGrupo(Connection conn, Curso curso, Usuario usuario, Map raizes)
        throws ExtractionException, SQLException {
        List retorno = new ArrayList();
        List gruposUsuario  = new ArrayList();
        List outrosGrupos   = new ArrayList();
        List gruposApagados = new ArrayList();
        Map numItens = new HashMap();
        Map numComentados = new HashMap();
        Map numAvaliados = new HashMap();
        /*
         * TODO - acertar para verificar se pertence ao grupo
         */
        PreparedStatement stmt = null;
        ResultSet         rs   = null;

        try {
            // 1. Buscar as raizes dos portfolios de cada usuario
            String sql = geraSQLPortfoliosGrupos(usuario);
            stmt = conn.prepareStatement(sql);
            rs   = stmt.executeQuery();

            int idUsuario = usuario.getId();
            GrupoFactory grupoFactory = GrupoFactory.getInstance(curso);

            String sqlNumItens = geraSQLPortfoliosNumItensGrupos(usuario);
            PreparedStatement stmtItens = conn.prepareStatement(sqlNumItens);
            ResultSet         rsItens   = stmtItens.executeQuery();
            while(rsItens.next()){
                numItens.put(new Integer(rsItens.getInt("cod_grupo")),new Integer(rsItens.getInt("num_itens")));
            }

            String sqlNumComentados = geraSQLPortfoliosNumComentadosGrupo(usuario);
            PreparedStatement stmtComentados = conn.prepareStatement(sqlNumComentados);
            ResultSet         rsComentados   = stmtComentados.executeQuery();
            while(rsComentados.next()){
                numComentados.put(new Integer(rsComentados.getInt("cod_grupo")),new Integer(rsComentados.getInt("num_itens")));
            }

            String sqlNumAvaliados = geraSQLPortfoliosAvaliacaoGrupos(usuario);
            PreparedStatement stmtAvaliados = conn.prepareStatement(sqlNumAvaliados);
            ResultSet         rsAvaliados   = stmtAvaliados.executeQuery();
            while(rsAvaliados.next()){
                numAvaliados.put(new Integer(rsAvaliados.getInt("cod_grupo")),new Integer(rsAvaliados.getInt("num_itens")));
            }

            while (rs.next()) {
                Portfolio p = new Portfolio();
                int id = rs.getInt("cod_topico");
                Integer i = new Integer(id);

                p.setGrupo();
                p.setId(id);
                p.setData(rs.getLong("data"));
                /*
                 * Como esta  a raiz do portfolio de algum usuario, o titulo
                 * desta pasta deve ser #U11, ou outro numero
                 */
                p.setTitulo(rs.getString("topico"));

                raizes.put(i, p);

                int idGrp = rs.getInt("cod_grupo");
                Grupo g = grupoFactory.getGrupo(idGrp);
                Integer itens = (Integer) numItens.get(new Integer(idGrp));
                Integer comentario = (Integer) numComentados.get(new Integer(idGrp));
                Integer avaliados = (Integer) numAvaliados.get(new Integer(idGrp));
                if (itens!=null) {
                    p.setNumItens(itens.intValue());
                }
                if (comentario!=null) {
                    p.setNumNComentados(p.getNumItens()-comentario.intValue());
                } else {
                    p.setNumNComentados(p.getNumItens());
                }
                if (avaliados!=null) {
                    p.setNumNAvaliados(avaliados.intValue());
                }
                // Grupo g = GrupoFactory.getInstance(curso).getGrupo(idGrp);
                if (g.isApagado()) {
                    gruposApagados.add(p);
                    p.setStatus("apagado");
                } else if (g.contemUsuario(idUsuario, curso)) {
                    // se o usuario pertence a um ou mais grupos, os portfolios desses grupos aparecem primeiro na lista
                    gruposUsuario.add(p);
                    p.setStatus("dono");
                } else {
                    outrosGrupos.add(p);
                    p.setStatus("outros");
                }
                // marcar este portfolio como portfolio de grupo
                p.setGrupo();
                p.setIdProprietario(idGrp);
            }

            retorno.addAll(gruposUsuario);
            retorno.addAll(outrosGrupos);
            retorno.addAll(gruposApagados);
        } finally {
            if (rs != null) {
                try { rs.close(); } catch (SQLException ex) { /* ignore */ }
            }
            if (stmt != null) {
                try { stmt.close(); } catch (SQLException ex) { /* ignore */ }
            }
        }

        return retorno;
    }

    /**
     * Retorna os Portfolios Individuais dos usurios, ordenados da seguinte forma:
     * <ul>
     *  <li>o portfolio do usuario vem em primeiro</li>
     *  <li>em seguida, os portfolios dos outros usuarios ordenados pelo nome do usuario</li>
     *  <li>por ultimo, portfolios de ex-alunos do curso</li>
     * </ul>
     *
     * @param conn Conexo sql. O mtodo pede como parmetro para no precisar abrir uma nova.
     * @param curso Curso do qual extrair os portflios individuais. Este parmetro  necessrio para encontrarmos o BD do curso.
     * @param usuario O usuario para o qual estamos extraindo o portfolio
     * @param portfolios Parametro de sada. Neste Map so mapeados os portfolios de cada usuario.
     * @return Lista com os portfolios individuais dos usuarios.
     * @throws SQLException
     * @throws ExtractionException
     */
    private static List portfoliosIndividuais(Connection conn, Curso curso, Usuario usuario, Map raizes)
        throws SQLException, ExtractionException {
        List retorno = new ArrayList();
        Map numItens = new HashMap();
        Map numComentados = new HashMap();
        Map numAvaliados = new HashMap();
        //      1. Buscar as raizes dos portfolios de cada usuario
        String            sql  = geraSQLPortfoliosIndividuais(usuario);
        PreparedStatement stmt = conn.prepareStatement(sql);
        ResultSet         rs   = stmt.executeQuery();
        try {

            String sqlNumItens = geraSQLPortfoliosNumItensIndividual(usuario);
            PreparedStatement stmtItens = conn.prepareStatement(sqlNumItens);
            ResultSet         rsItens   = stmtItens.executeQuery();
            while(rsItens.next()){
                numItens.put(new Integer(rsItens.getInt("cod_usuario")),new Integer(rsItens.getInt("num_itens")));
            }

            String sqlNumComentados = geraSQLPortfoliosNumComentadosIndividual(usuario);
            PreparedStatement stmtComentados = conn.prepareStatement(sqlNumComentados);
            ResultSet         rsComentados   = stmtComentados.executeQuery();
            while(rsComentados.next()){
                numComentados.put(new Integer(rsComentados.getInt("cod_usuario")),new Integer(rsComentados.getInt("num_itens")));
            }

            String sqlNumAvaliacao = geraSQLPortfoliosAvaliacaoIndividual(usuario);
            PreparedStatement stmtAvaliacao = conn.prepareStatement(sqlNumAvaliacao);
            ResultSet         rsAvaliacao   = stmtAvaliacao.executeQuery();
            while(rsAvaliacao.next()){
                numAvaliados.put(new Integer(rsAvaliacao.getInt("cod_usuario")),new Integer(rsAvaliacao.getInt("num_itens")));
            }

            int idUsuario = usuario.getId();
            while (rs.next()) {
                Portfolio p = new Portfolio();
                int id = rs.getInt("cod_topico");
                Integer i = new Integer(id);

                p.setIndividual();
                p.setId(id);
                p.setData(rs.getLong("data"));
                /*
                 * Como esta  a raiz do portfolio de algum usuario, o titulo
                 * desta pasta deve ser #U11, ou outro numero
                 */
                p.setTitulo(rs.getString("topico"));

                raizes.put(i, p);

                /*
                 * TODO - Se o usuario for ex-aluno ou ex-formador, deve aparecer no fim da lista
                 */
                int idUsr = rs.getInt("cod_usuario");
                Integer itens = (Integer) numItens.get(new Integer(idUsr));
                Integer comentario = (Integer) numComentados.get(new Integer(idUsr));
                Integer avaliados = (Integer) numAvaliados.get(new Integer(idUsr));
                if (itens!=null) {
                    p.setNumItens(itens.intValue());
                }
                if (comentario!=null) {
                    p.setNumNComentados(p.getNumItens()-comentario.intValue());
                } else {
                    p.setNumNComentados(p.getNumItens());
                }
                if(avaliados!=null) {
                    p.setNumNAvaliados(avaliados.intValue());
                }
                if (idUsr == idUsuario) {
                    // o portfolio de um usuario  o primeiro que aparece para
                    // ele na lista
                    retorno.add(0, p);
                    p.setStatus("dono");
                } else {
                    retorno.add(p);
                    Usuario usr;
                    try {
                        usr = new Usuario(curso, idUsr);
                        if (usr.isExAluno() || usr.isExFormador()) {
                            p.setStatus("apagado");
                        } else {
                            p.setStatus("outros");
                        }
                    } catch (DBException e) {
                        e.printStackTrace();
                        p.setStatus("outros");
                    } catch (IOException e) {
                        e.printStackTrace();
                        p.setStatus("outros");
                    } catch (SQLException e) {
                        e.printStackTrace();
                        p.setStatus("outros");
                    }
                }
                p.setIndividual();
                p.setIdProprietario(idUsr);
            }
        } finally {
            if (rs != null) {
                try { rs.close(); } catch (SQLException ex) { /* ignore */ }
            }
            if (stmt != null) {
                try { stmt.close(); } catch (SQLException ex) { /* ignore */ }
            }
        }

        return retorno;
    }

    // ------------------------------------------------------------------------

    /**
     * Gera SQL com os comentarios dos itens
     *
     * @param usuario
     * @return SQL com os comentarios dos itens. Consulta as seguintes colunas da tabela:
     * <ul>
     * <li><b>cod_comentario</b> - Codigo do comentario</li>
     * <li><b>cod_comentarista</b> - Codigo do usuario que escreveu o comentario</li>
     * <li><b>data</b> - Data do comentario, em UnixTime (segundos)</li>
     * <li><b>cod_item</b> - Codigo do item que contm este comentario</li>
     * </ul>
     */
    private static String geraSQLComentarios(Usuario usuario) {
        /*
         * Veja na funcao geraSQLItensPortfoliosIndividuais a explicao de porque
         * o codigo do topico no deve ser 0, 1, 2, 3 ou 4
         */
        String sql = null;
        if (usuario.isFormador()) {
            sql = "select PIC.cod_comentario, PIC.cod_comentarista, PIC.data, " +
                    "PIC.comentario, PIC.cod_item from Portfolio_itens PI " +
                    "right join Portfolio_itens_comentarios as PIC on " +
                    "PI.cod_item=PIC.cod_item where PI.cod_topico " +
                    "not between 0 and 4  and (PI.tipo_compartilhamento != 'P' " +
                    "or PI.cod_usuario=1) and PIC.status!='X' and PIC.comentario!=''";

        } else if (usuario.isAluno()) {
            sql = "select PIC.cod_comentario, PIC.cod_comentarista, PIC.data, PIC.comentario, PIC.cod_item" + " " +
                  "from Portfolio_itens PI left join Portfolio_itens_comentarios as PIC" + " " +
                  "on PI.cod_item=PIC.cod_item" + " " +
                  "where PI.cod_topico not between 0 and 4" + " " +
                  "and (tipo_compartilhamento='T' or cod_usuario=" + usuario.getId() + ")" +
                  " and PIC.status!='X' and PIC.comentario!=''";
        } else {
            assert false : "Usuario no  aluno nem formador";
        }
        return sql;
    }

    /**
     * Retorna SQL para buscar os itens da base de dados.
     *
     * @param idGrupo array com os id's dos grupos aos quais o usuario pertence
     * @param usuario
     * @return SQL com as seguintes colunas do BD:
     * <ul>
     * <li><b>cod_item</b> - cdigo do item</li>
     * <li><b>cod_topico</b> - cdigo da pasta a que este item pertence</li>
     * <li><b>titulo</b> - ttulo do item</li>
     * <li><b>texto</b> - texto do item</li>
     * <li><b>data</b> - data de criao do item</li>
     * <li><b>posicao_item</b> - posio do item para exibio</li>
     * <li><b>tipo_compartilhamento</b> - compartilhamento</li>
     * </ul>
     */
    private static String geraSQLItensPortfoliosGrupo(int[] idGrupo, Usuario usuario) {
        String sql = null;

        if (idGrupo == null) {
            throw new NullPointerException("sem grupos para retornar");
        }

        StringBuffer grupos = new StringBuffer(idGrupo.length * 3);
        int i = 0;
        for (; i < idGrupo.length - 1; ++i) {
            grupos.append(idGrupo[i]);
            grupos.append(", ");
        }
        grupos.append(idGrupo[i]);

        if (usuario.isFormador()) {
            /*
             * Retornar os itens que so compartilhados com todos ou com formadores,
             * ou os que pertencerem ao usuario, independente de compartilhamto.
             * Equivalente a (comp = t or comp = f or cod_usu = u)
             * que por sua vez equivale a
             * (comp != p or cod_usu = u)
             */

            sql = "select cod_item, cod_topico, titulo, texto, data, posicao_item, tipo_compartilhamento" + " " +
                  "from Portfolio_itens" + " " +
                  "where cod_topico not between 0 and 4" + " " +
                  "and cod_grupo IS NOT NULL" + " " +
                  "and (" +
                      "tipo_compartilhamento != 'P'" + " " +
                      "or cod_grupo in (" + grupos.toString() + "))";
        } else if (usuario.isAluno()) {
            /*
             * Retornar os itens que so compartilhados com todos ou, se pertencem
             * ao usuario, independente de compartilhamto
             */
            sql = "select cod_item, cod_topico, titulo, texto, data, posicao_item, tipo_compartilhamento" + " " +
                  "from Portfolio_itens" + " " +
                  "where cod_topico not between 0 and 4" + " " +
                  "and cod_grupo IS NOT NULL" + " " +
                  "and (" +
                      "tipo_compartilhamento='T'" + " " +
                      "or cod_grupo in (" + grupos.toString() + "))";
        } else {
            assert false : "Usuario no  formador nem aluno";
        }
        return sql;
    }

    private static String geraSQLItensPortfoliosOutrosGrupo(Usuario usuario) {
        String sql = null;

        if (usuario.isFormador()) {
            /*
             * Retornar os itens que so compartilhados com todos ou com formadores,
             * ou os que pertencerem ao usuario, independente de compartilhamto.
             * Equivalente a (comp = t or comp = f or cod_usu = u)
             * que por sua vez equivale a
             * (comp != p or cod_usu = u)
             */

            sql = "select cod_item, cod_topico, titulo, texto, data, posicao_item, tipo_compartilhamento" + " " +
                  "from Portfolio_itens" + " " +
                  "where cod_topico not between 0 and 4" + " " +
                  "and cod_grupo IS NOT NULL" + " " +
                  "and tipo_compartilhamento != 'P'";
        } else if (usuario.isAluno()) {
            /*
             * Retornar os itens que so compartilhados com todos ou, se pertencem
             * ao usuario, independente de compartilhamto
             */
            sql = "select cod_item, cod_topico, titulo, texto, data, posicao_item, tipo_compartilhamento" + " " +
                  "from Portfolio_itens" + " " +
                  "where cod_topico not between 0 and 4" + " " +
                  "and cod_grupo IS NOT NULL" + " " +
                  "and tipo_compartilhamento='T'";
        } else {
            assert false : "Usuario no  formador nem aluno";
        }
        return sql;
    }

    /**
     * Retorna SQL para buscar os itens da base de dados.
     *
     * @param usuario
     * @return SQL com as seguintes colunas do BD:
     * <ul>
     * <li><b>cod_item</b> - cdigo do item</li>
     * <li><b>cod_topico</b> - cdigo da pasta a que este item pertence</li>
     * <li><b>titulo</b> - ttulo do item</li>
     * <li><b>texto</b> - texto do item</li>
     * <li><b>data</b> - data de criao do item</li>
     * <li><b>posicao_item</b> - posio do item para exibio</li>
     * <li><b>tipo_compartilhamento</b> - compartilhamento do item</li>
     * </ul>
     */
    private static String geraSQLItensPortfoliosIndividuais(Usuario usuario) {
        /*
         * Se o item est no topico de codigo:
         * 0 - Item excluido
         * 1 - Raiz de todos os portfolios. No deveria haver itens neste topico,
         *  apenas as pastas de codigo 3 e 4
         * 2 - Item est na lixeira
         * 3 - Raiz dos portfolios individuais. No deveria haver itens aqui,
         *  apenas pastas que so raizes dos portfolios individuais
         * 4 - Raiz dos portfolios de grupos.  No deveria haver itens aqui,
         *  apenas pastas que so raizes dos portfolios individuais
         */
        String sql = null;
        if (usuario.isFormador()) {
            /*
             * Retornar os itens que so compartilhados com todos ou com formadores,
             * ou os que pertencerem ao usuario, independente de compartilhamto.
             * Equivalente a (comp = t or comp = f or cod_usu = u)
             * que por sua vez equivale a
             * (comp != p or cod_usu = u)
             */
            sql = "select cod_item, cod_topico, titulo, texto, data, posicao_item, tipo_compartilhamento" + " " +
                  "from Portfolio_itens" + " " +
                  "where cod_topico not between 0 and 4" + " " +
                  "and cod_grupo IS NULL" + " " +
                  "and (" +
                      "tipo_compartilhamento != 'P'" + " " +
                      "or cod_usuario=" + usuario.getId() + ")";
        } else if (usuario.isAluno()) {
            /*
             * Retornar os itens que so compartilhados com todos ou, se pertencem
             * ao usuario, independente de compartilhamto
             */
            sql = "select cod_item, cod_topico, titulo, texto, data, posicao_item, tipo_compartilhamento" + " " +
                  "from Portfolio_itens" + " " +
                  "where cod_topico not between 0 and 4" + " " +
                  "and cod_grupo IS NULL" + " " +
                  "and (" +
                      "tipo_compartilhamento='T'" + " " +
                      "or cod_usuario=" + usuario.getId() + ")" + " ";
        } else {
            assert false : "Usuario no  formador nem aluno";
        }
        return sql;
    }

    /**
     * @param usuario
     * @return SQL para buscar portfolios individuais do BD.
     * Este SQL retorna os campos:
     * <ul>
     * <li><b>cod_topico</b> - Codigo de pasta. Internamente, o portfolio 
     *  visto como uma pasta, este  o cdigo dele.</li>
     * <li><b>data</b> - Data de ltima atualizao do portfolio.</li>
     * <li><b>topico</b> - Titulo da pasta.</li>
     * <li><b>cod_usuario</b> - Codigo do usuario ao qual este portfolio pertence</li>
     * </ul>
     */
    private static String geraSQLPortfoliosIndividuais(Usuario usuario) {
        /*
         * As raizes dos portfolios dos usuarios so os tpicos filhos do topico 3
         *
         * O join da SQL com a tabela Usuario serve para ordenar pelo nome do usuario
         */
        return "select PT.cod_topico, PT.topico, PT.data, PT.cod_usuario" + " " +
               "from Portfolio_topicos as PT left join Usuario as U" + " " +
               "on PT.cod_usuario=U.cod_usuario" + " " +
               "where cod_topico_pai=3" + " " +
               "order by U.nome";
    }

    /**
     * @param usuario
     * @return SQL para buscar portfolios de grupo do BD.
     * Este SQL retorna os campos:
     * <ul>
     * <li><b>cod_topico</b> - Codigo de pasta. Internamente, o portfolio 
     *  visto como uma pasta, este  o cdigo dele.</li>
     * <li><b>data</b> - Data de ltima atualizao do portfolio.</li>
     * <li><b>topico</b> - Titulo da pasta.</li>
     * <li><b>cod_grupo</b> - Codigo do grupo ao qual este portflio pertence</li>
     * </ul>
     */
    private static String geraSQLPortfoliosGrupos(Usuario usuario) {
        /*
         * As raizes dos portfolios de grupos so os tpicos filhos do topico 4
         *
         * O join da SQL com a tabela Grupos serve para ordenar pelo nome do grupo
         */
        return "select PT.cod_topico, PT.topico, PT.data, PT.cod_grupo" + " " +
               "from Portfolio_topicos as PT left join Grupos as G" + " " +
               "on PT.cod_grupo=G.cod_grupo" + " " +
               "where cod_topico_pai=4" + " " +
               "order by G.nome";
    }

    /**
     * SQL para buscar pastas de portflios de grupo. No retorna as pastas razes (portflios).
     * Retorna somente as pastas e portflios com os quais o usurio tem compartilhamento.
     *
     * @param usuario Usurio para o qual estamos realizando a extrao
     * @return String sql para buscar pastas de portflio de grupo. Retorna as colunas:
     * <ul>
     * <li><b>cod_topico</b> - Cdigo da pasta</li>
     * <li><b>cod_topico_pai</b> - Cdigo da pasta pai</li>
     * <li><b>topico</b> - Ttulo da pasta</li>
     * <li><b>data</b> - Data de criao da pasta em UnixTime (segundos)</li>
     * </ul>
     */
    private static String geraSQLPastasPortfoliosGrupo(Usuario usuario) {
        /*
         * Retornar todos as pastas compartilhadas com todos ou comp com formadores
         * ou pertencentes ao usuario
         * Evitar retornar topicos de codigo:
         * 0 - Pasta dos itens excluidos
         * 1 - Raiz de todos os portfolios
         * 2 - Lixeira
         * 3 - Raiz dos portfolios individuais
         * 4 - Raiz dos portfolios de grupo
         *
         */
        String sql = null;
        if (usuario.isFormador()) {
            /*
             * Retornar as pastas (tpicos) de portfolio baseado no compartilhamento:
             * 'T'odos ou 'F'ormadores ou pertencentes ao usuario
             */
            sql = "select cod_topico, cod_topico_pai, topico, data, posicao_topico" + " " +
                  "from Portfolio_topicos" + " " +
                  "where cod_topico not between 0 and 4" + " " +
                  " and cod_topico_pai != 4" + " " +
                  " and cod_grupo IS NOT NULL" + " " +
                  " and (cod_usuario=" + usuario.getId() + " " +
                  "or tipo_compartilhamento != 'P')";
        } else if (usuario.isAluno()) {
            /*
             * retornar as pastas compartilhadas com todos ou pertencentes ao usuario
             */
            sql = "select cod_topico, cod_topico_pai, topico, data, posicao_topico" + " " +
                  "from Portfolio_topicos" + " " +
                  "where cod_topico not between 0 and 4" + " " +
                  " and cod_topico_pai != 4" + " " +
                  " and cod_grupo IS NOT NULL" + " " +
                  " and (cod_usuario=" + usuario.getId() + " " +
                  "or tipo_compartilhamento = 'T')";
        } else {
            assert false : "Usuario no  formador nem aluno";
        }
        return sql;
    }

    /**
     * Gera SQL para buscar Pastas de portflios individuais. No retorna as pastas raizes (portflios).
     * Retorna somente as pastas nas quais o usurio tem compartilhamento.
     *
     * @param usuario Usurio para o qual estamos realizando a extrao.
     * @return String SQL com as colunas:
     * <ul>
     * <li><b>cod_topico</b> - Cdigo da pasta</li>
     * <li><b>cod_topico_pai</b> - Cdigo da pasta pai desta pasta</li>
     * <li><b>topico</b> - Titulo da pasta</li>
     * <li><b>data</b> - Data de criao da pasta</li>
     * </ul>
     */
    private static String geraSQLPastasPortfoliosIndividuais(Usuario usuario) {
        /*
         * Retornar todos as pastas compartilhadas com todos ou comp com formadores
         * ou pertencentes ao usuario
         * Evitar retornar topicos de codigo:
         * 0 - Pasta dos itens excluidos
         * 1 - Raiz de todos os portfolios
         * 2 - Lixeira
         * 3 - Raiz dos portfolios individuais
         * 4 - Raiz dos portfolios de grupo
         *
         */
        String sql = null;
        if (usuario.isFormador()) {
            /*
             * Retornar as pastas (tpicos) de portfolio baseado no compartilhamento:
             * 'T'odos ou 'F'ormadores ou pertencentes ao usuario
             */
            sql = "select cod_topico, cod_topico_pai, topico, data, posicao_topico " + " " +
                  "from Portfolio_topicos" + " " +
                  "where cod_topico not between 0 and 4" + " " +
                  " and cod_topico_pai != 3" + " " +            // nao retornar os portflios (raizes)
                  " and cod_grupo IS NULL" + " " +              // nao retornar pastas de portflios de grupo
                  " and (cod_usuario=" + usuario.getId() + " " +
                  "or tipo_compartilhamento != 'P')";
        } else if (usuario.isAluno()) {
            /*
             * retornar as pastas compartilhadas com todos ou pertencentes ao usuario
             */
            sql = "select cod_topico, cod_topico_pai, topico, data, posicao_topico " + " " +
                  "from Portfolio_topicos" + " " +
                  "where cod_topico not between 0 and 4" + " " +
                  " and cod_topico_pai != 3" + " " +
                  " and cod_grupo IS NULL" + " " +
                  " and (cod_usuario=" + usuario.getId() + " " +
                  "or tipo_compartilhamento = 'T')";
        } else {
            assert false : "Usuario no  formador nem aluno";
        }
        return sql;
    }

    private static String geraSQLPortfoliosNumItensIndividual(Usuario usuario) {
        String sql="";
        if(usuario.isFormador())
        {
            sql ="select count(*) as num_itens,cod_usuario from " +
                    "Portfolio_itens where cod_topico!=2 and" +
                    "(tipo_compartilhamento!='P' or " +
                    "cod_usuario="+Integer.toString(usuario.getId())+") " +
                    "and cod_grupo is null group by cod_usuario";
        } else{
            sql ="select count(*) as num_itens,cod_usuario from " +
                    "Portfolio_itens where cod_topico!=2 and" +
                    "(tipo_compartilhamento='T' or " +
                    "cod_usuario="+Integer.toString(usuario.getId())+") " +
                    "and cod_grupo is null group by cod_usuario";
        }
        return sql;
    }

    private static String geraSQLPortfoliosNumItensGrupos(Usuario usuario) {
        String sql="";
        if(usuario.isFormador())
        {
            sql = "select count(distinct(P.cod_item)) as num_itens," +
                "P.cod_grupo from Portfolio_itens as P left join " +
                "Grupos_usuario as G on G.cod_grupo=P.cod_grupo " +
                "where P.cod_topico!=2 and " +
                "(P.tipo_compartilhamento!='P' or ((G.cod_grupo=P.cod_grupo) " +
                "and G.cod_usuario="+Integer.toString(usuario.getId())+"))" +
                " and P.cod_grupo is not null group by P.cod_grupo";
        }else {
            sql = "select count(distinct(P.cod_item)) as " +
                    "num_itens,P.cod_grupo  from " +
                    "Portfolio_itens as P left join " +
                    "Grupos_usuario as G on " +
                    "G.cod_grupo=P.cod_grupo where " +
                    "P.cod_topico!=2 and " +
                    "(P.tipo_compartilhamento='T' or  " +
                    "((G.cod_grupo=P.cod_grupo) and " +
                    "G.cod_usuario="+Integer.toString(usuario.getId())+")) and " +
                    "P.cod_grupo is not null group by " +
                    "P.cod_grupo";
        }
        return sql;
    }

    /*retorna o numero de itens comentados, para saber os nao comentados
     * use o numero de itens - numero de comentados*/
    private static String geraSQLPortfoliosNumComentadosIndividual(Usuario usuario) {
        String sql="";
        if(usuario.isFormador())
        {
            sql = "select count(distinct(P.cod_item)) as num_itens,P.cod_usuario " +
                "from Portfolio_itens as P right join " +
                "Portfolio_itens_comentarios as C on " +
                "P.cod_item=C.cod_item where C.status='A' and P.cod_topico!=2 and " +
                "(P.tipo_compartilhamento!='P' or P.cod_usuario="+Integer.toString(usuario.getId())+")" +
                " and P.cod_grupo is null group by cod_usuario";
        } else {
            sql = "select count(distinct(P.cod_item)) as num_itens,P.cod_usuario " +
            "from Portfolio_itens as P right join " +
            "Portfolio_itens_comentarios as C on " +
            "P.cod_item=C.cod_item where C.status='A' and P.cod_topico!=2 and " +
            "(P.tipo_compartilhamento='T' or P.cod_usuario="+Integer.toString(usuario.getId())+")" +
            " and P.cod_grupo is null group by cod_usuario";
        }
        return sql;
    }

    /*retorna o numero de itens comentados, para saber os nao comentados
     * use o numero de itens - numero de comentados*/
    private static String geraSQLPortfoliosNumComentadosGrupo(Usuario usuario) {
        String sql="";
        if(usuario.isFormador()){
            sql = "select count(distinct(P.cod_item)) as " +
                    "num_itens, P.cod_grupo from " +
                    "Portfolio_itens as P right join " +
                    "Portfolio_itens_comentarios as C on " +
                    "P.cod_item=C.cod_item left join " +
                    "Grupos_usuario as G on " +
                    "G.cod_grupo=P.cod_grupo where " +
                    "C.status='A' and P.cod_topico!=2 and " +
                    "(P.tipo_compartilhamento!='P' or " +
                    "((G.cod_grupo=P.cod_grupo) and " +
                    "G.cod_usuario=1)) and P.cod_grupo " +
                    "is not null group by P.cod_grupo";
        } else{
            sql = "select count(distinct(P.cod_item)) as " +
                    "num_itens, P.cod_grupo from " +
                    "Portfolio_itens as P right join " +
                    "Portfolio_itens_comentarios as C on " +
                    "P.cod_item=C.cod_item left join " +
                    "Grupos_usuario as G on " +
                    "G.cod_grupo=P.cod_grupo where " +
                    "C.status='A' and P.cod_topico!=2 and " +
                    "(P.tipo_compartilhamento='T' or " +
                    "((G.cod_grupo=P.cod_grupo) and " +
                    "G.cod_usuario=1)) and P.cod_grupo " +
                    "is not null group by P.cod_grupo";
        }
        return sql;
    }

    private static String geraSQLPortfoliosAvaliacaoIndividual(Usuario usuario) {
        String sql="";
        if(usuario.isFormador()){
            sql = "select count(*) as num_itens,P.cod_usuario from Portfolio_itens as P," +
                    " Portfolio_itens_avaliacao PIA, Avaliacao A" +
                    " where P.cod_item=PIA.cod_item and PIA.status='N'" +
                    " and A.cod_avaliacao=PIA.cod_avaliacao and" +
                    " (A.status='F' or A.status='E') and P.cod_grupo" +
                    " is null and (P.tipo_compartilhamento!='P' or " +
                    "P.cod_usuario=1) group by cod_usuario";
        } else {
            sql = "select count(*) as num_itens,P.cod_usuario from Portfolio_itens as P," +
                    " Portfolio_itens_avaliacao PIA, Avaliacao A" +
                    " where P.cod_item=PIA.cod_item and PIA.status='N'" +
                    " and A.cod_avaliacao=PIA.cod_avaliacao and " +
                    "(A.status='F' or A.status='E') and P.cod_grupo" +
                    " is null and (P.tipo_compartilhamento='T' or" +
                    " P.cod_usuario=1) group by cod_usuario";
        }
        return sql;
    }

    private static String geraSQLPortfoliosAvaliacaoGrupos(Usuario usuario) {
        String sql="";
        if(usuario.isFormador()){
            sql = "select count(*) as num_itens,P.cod_grupo from Portfolio_itens as P," +
                    " Portfolio_itens_avaliacao PIA, Avaliacao A" +
                    " where P.cod_item=PIA.cod_item and PIA.status='N'" +
                    " and A.cod_avaliacao=PIA.cod_avaliacao and" +
                    " (A.status='F' or A.status='E') and P.cod_grupo" +
                    " is not null and (P.tipo_compartilhamento!='P' or " +
                    "P.cod_usuario=1) group by cod_grupo";
        } else {
            sql = "select count(*) as num_itens,P.cod_grupo from Portfolio_itens as P," +
                    " Portfolio_itens_avaliacao PIA, Avaliacao A" +
                    " where P.cod_item=PIA.cod_item and PIA.status='N'" +
                    " and A.cod_avaliacao=PIA.cod_avaliacao and " +
                    "(A.status='F' or A.status='E') and P.cod_grupo" +
                    " is not null and (P.tipo_compartilhamento='T' or" +
                    " P.cod_usuario=1) group by cod_grupo";
        }
        return sql;
    }

    private static String geraSQLEnderecosWeb(int id) {
        String sql = "";
        sql = "select * from Portfolio_itens_enderecos where cod_item = " + Integer.toString(id);

        return sql;
    }

    private static String geraSQLAvaliacao(int id) {
        String sql = "";
        sql = "select PIA.cod_item, PIA.cod_avaliacao, A.cod_atividade, AI.titulo" +
                " from Portfolio_itens_avaliacao as PIA" +
                " left join Avaliacao as A on PIA.cod_avaliacao = A.cod_avaliacao" +
                " left join Atividade_itens as AI on A.cod_atividade = AI.cod_item" +
                " where PIA.cod_item = " + Integer.toString(id) + " and A.status = 'F'";

        return sql;
    }

}
