/*
 * Created on Oct 15, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.extrator.usuario;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;

import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.curso.ExtractionException;
import br.unicamp.nied.teleduc.extrator.database.ConnectionFactory;
import br.unicamp.nied.teleduc.extrator.database.DBException;
import br.unicamp.nied.teleduc.extrator.ferramentas.perfil.Perfil;

/**
 * @author leonel
 *
 * Mapeia a tabela Usuario do bd em uma classe.
 * Todos os campos da tabela estao incluidos aqui, exceto os campos:
 * login - nao necessario para extracao de curso
 * senha - nao necessario para extracao de curso
 * cod_escolaridade - Foi modificado para a String escolaridade;
 * opcoes - nao necessario para extracao, somente para uso interno do TelEduc
 * cod_lingua - idem
 * Contem tambem um atributo perfil, tirado da tabela Perfil.
 */
public class Usuario implements Comparable {
    private int     id;
    private String  nome;
    private String  rg;
    private String  email;
    private String  telefone;
    private String  endereco;
    private String  cidade;
    private String  estado;
    private String  pais;
    private Date    dataNasc;
    private char    sexo;
    private String  localTrab;
    private String  profissao;
    private String  escolaridade;
    private String  informacoes;
    private char    tipoUsuario;
    private int     lingua;
    private Date    dataInscricao;

    private Curso   curso;

    private boolean isFormador    = false;
    private boolean isAluno       = false;
    private boolean isConvidado   = false;
    private boolean isVisitante   = false;
    private boolean isExAluno     = false;
    private boolean isExFormador  = false;
    private boolean isCoordenador = false;

    private Perfil  perfil;

    public int getLingua() {
        return lingua;
    }

    public void setLingua(int lingua) {
        this.lingua = lingua;
    }


    /**
     *
     * @param curso
     * @return
     * @throws ExtractionException
     */
//    public static Collection usuarios(Curso curso) throws ExtractionException {
    protected static Collection usuarios(Curso curso) throws ExtractionException {
        int idCoordenador = verificaCoordenador(curso);

        Collection usuarios = new ArrayList();

        PreparedStatement ps = null;
        ResultSet         rs = null;
        try {
            ConnectionFactory conFac;
            conFac = ConnectionFactory.getConnectionFactory();
            Connection con = conFac.getConnection(curso.getBaseCurso());
            String sql = "select cod_usuario, nome, rg, email, telefone,"
                + " endereco, cidade, estado, pais, data_nasc, sexo,"
                + " local_trab, profissao, cod_escolaridade, informacoes,"
                + " tipo_usuario, opcoes, data_inscricao"
                + " from Usuario where cod_usuario <> -1";
            ps = con.prepareStatement(sql);
            rs = ps.executeQuery();
            while (rs.next()) {
                Usuario usuario = new Usuario();
                usuario.setCurso(curso);

                usuario.setId(rs.getInt("cod_usuario"));
                usuario.setNome(rs.getString("nome"));
                usuario.setRg(rs.getString("rg") != null
                        ? rs.getString("rg")
                        : "");
                usuario.setEmail(rs.getString("email"));
                usuario.setTelefone(rs.getString("telefone") != null
                        ? rs.getString("telefone")
                        : "");
                usuario.setEndereco(rs.getString("endereco") != null
                        ? rs.getString("endereco")
                        : "");
                usuario.setCidade(rs.getString("cidade") != null
                        ? rs.getString("cidade")
                        : "");
                usuario.setEstado(rs.getString("estado") != null
                        ? rs.getString("estado")
                        : "");
                usuario.setPais(rs.getString("pais") != null
                        ? rs.getString("pais")
                        : "");
                usuario.setDataNasc(new Date(rs.getLong("data_nasc") * 1000L));
                String sexo = rs.getString("sexo");
                if (sexo != null) {
                    usuario.setSexo(rs.getString("sexo").charAt(0));
                } else {
                    usuario.setSexo('\0');
                }
                usuario.setLocalTrab(rs.getString("local_trab") != null
                        ? rs.getString("local_trab")
                        : "");
                usuario.setProfissao(rs.getString("profissao") != null
                        ? rs.getString("profissao")
                        : "");
                usuario.setEscolaridade(rs.getString("cod_escolaridade") != null
                        ? rs.getString("cod_escolaridade")
                        : "");
                usuario.setInformacoes(rs.getString("informacoes") != null
                        ? rs.getString("informacoes")
                        : "");
                usuario.setTipoUsuario(rs.getString("tipo_usuario").charAt(0));
                usuario.setDataInscricao(
                        new Date(rs.getLong("data_inscricao") * 1000L));
                usuario.isCoordenador = (usuario.id == idCoordenador);
                usuarios.add(usuario);
            }
        } catch (IOException ioex) {
            ioex.printStackTrace();
            throw new ExtractionException("Erro ao buscar usurios", ioex);
        } catch (SQLException sqlex) {
            sqlex.printStackTrace();
            throw new ExtractionException("Erro ao buscar usurios", sqlex);
        } catch (DBException dbex) {
            dbex.printStackTrace();
            throw new ExtractionException("Erro ao buscar usurios", dbex);
        } finally {
            if (rs != null) {
                try {
                    rs.close();
                } catch (SQLException ex) {
                    ex.printStackTrace();
                    // ignore
                }
            }
            if (ps != null) {
                try {
                    ps.close();
                } catch (SQLException ex) {
                    ex.printStackTrace();
                    // ignore
                }
            }
        }

        return usuarios;
    }

    /**
     *
     * @param curso
     * @return
     * @throws SQLException
     * @throws DBException
     * @throws IOException
     *
     * @deprecated Utilize <code>UsuarioFactory.getInstance(curso)</code>
     */
    public static Collection idsNomesUsuarios(Curso curso) throws SQLException,
            DBException, IOException {
        Collection usuarios = new ArrayList();

        ConnectionFactory conFac;
        conFac = ConnectionFactory.getConnectionFactory();
        Connection con = conFac.getConnection(curso.getBaseCurso());
        String sql = "select cod_usuario, nome, "
                + "tipo_usuario from Usuario " + "where cod_usuario <> -1";

        PreparedStatement ps = con.prepareStatement(sql);
        ResultSet rs = ps.executeQuery();

        while (rs.next()) {
            Usuario usuario = new Usuario();
            usuario.setId(rs.getInt("cod_usuario"));
            usuario.setNome(rs.getString("nome"));
            usuario.setTipoUsuario(rs.getString("tipo_usuario").charAt(0));
            usuarios.add(usuario);
        }

        return usuarios;

    }

    /**
     * @return Returns the cidade.
     */
    public String getCidade() {
        return cidade;
    }

    /**
     * @param cidade
     *            The cidade to set.
     */
    public void setCidade(String cidade) {
        this.cidade = cidade;
    }

    /**
     * @return Returns the dataInscricao.
     */
    public Date getDataInscricao() {
        return dataInscricao;
    }

    /**
     * @param dataInscricao
     *            The dataInscricao to set.
     */
    public void setDataInscricao(Date dataInscricao) {
        this.dataInscricao = dataInscricao;
    }

    /**
     * @return Returns the dataNasc.
     */
    public Date getDataNasc() {
        return dataNasc;
    }

    /**
     * @param dataNasc
     *            The dataNasc to set.
     */
    public void setDataNasc(Date dataNasc) {
        this.dataNasc = dataNasc;
    }

    /**
     * @return Returns the email.
     */
    public String getEmail() {
        return email;
    }

    /**
     * @param email
     *            The email to set.
     */
    public void setEmail(String email) {
        this.email = email;
    }

    /**
     * @return Returns the endereco.
     */
    public String getEndereco() {
        return endereco;
    }

    /**
     * @param endereco
     *            The endereco to set.
     */
    public void setEndereco(String endereco) {
        this.endereco = endereco;
    }

    /**
     * @return Returns the escolaridade.
     */
    public String getEscolaridade() {
        return escolaridade;
    }

    /**
     * @param escolaridade
     *            The escolaridade to set.
     */
    public void setEscolaridade(String escolaridade) {
        this.escolaridade = escolaridade;
    }

    /**
     * @return Returns the estado.
     */
    public String getEstado() {
        return estado;
    }

    /**
     * @param estado
     *            The estado to set.
     */
    public void setEstado(String estado) {
        this.estado = estado;
    }

    /**
     * @return Returns the id.
     */
    public int getId() {
        return id;
    }

    /**
     * @param id
     *            The id to set.
     */
    public void setId(int id) {
        this.id = id;
    }

    /**
     * @return Returns the informacoes.
     */
    public String getInformacoes() {
        return informacoes;
    }

    /**
     * @param informacoes
     *            The informacoes to set.
     */
    public void setInformacoes(String informacoes) {
        this.informacoes = informacoes;
    }

    /**
     * @return Returns the localTrab.
     */
    public String getLocalTrab() {
        return localTrab;
    }

    /**
     * @param localTrab
     *            The localTrab to set.
     */
    public void setLocalTrab(String localTrab) {
        this.localTrab = localTrab;
    }

    /**
     * @return Returns the nome.
     */
    public String getNome() {
        return nome;
    }

    /**
     * @param nome
     *            The nome to set.
     */
    public void setNome(String nome) {
        this.nome = nome;
    }

    /**
     * @return Returns the pais.
     */
    public String getPais() {
        return pais;
    }

    /**
     * @param pais
     *            The pais to set.
     */
    public void setPais(String pais) {
        this.pais = pais;
    }

    /**
     * @return Returns the perfil.
     */
    public Perfil getPerfil() {
        return perfil;
    }

    /**
     * @param perfil
     *            The perfil to set.
     */
    public void setPerfil(Perfil perfil) {
        this.perfil = perfil;
    }

    /**
     * @return Returns the profissao.
     */
    public String getProfissao() {
        return profissao;
    }

    /**
     * @param profissao
     *            The profissao to set.
     */
    public void setProfissao(String profissao) {
        this.profissao = profissao;
    }

    /**
     * @return Returns the rg.
     */
    public String getRg() {
        return rg;
    }

    /**
     * @param rg
     *            The rg to set.
     */
    public void setRg(String rg) {
        this.rg = rg;
    }

    /**
     * @return Returns the sexo.
     */
    public char getSexo() {
        return sexo;
    }

    /**
     * @param sexo
     *            The sexo to set.
     */
    public void setSexo(char sexo) {
        this.sexo = sexo;
    }

    /**
     * @return Returns the telefone.
     */
    public String getTelefone() {
        return telefone;
    }

    /**
     * @param telefone
     *            The telefone to set.
     */
    public void setTelefone(String telefone) {
        this.telefone = telefone;
    }

    /**
     * @return Returns the tipoUsuario.
     */
    public char getTipoUsuario() {
        return tipoUsuario;
    }

    /**
     * @return Retorna se o usurio foi apagado dentro do curso
     */
    public boolean isApagado() {
        return (tipoUsuario == 'r');
    }

    /**
     * @param tipoUsuario
     *            The tipoUsuario to set.
     */
    public void setTipoUsuario(char tipoUsuario) {
        this.tipoUsuario = tipoUsuario;

        this.isFormador = false;
        this.isAluno = false;
        this.isConvidado = false;
        this.isVisitante = false;
        this.isExAluno = false;
        this.isExFormador = false;
        this.isCoordenador = false;

        switch (tipoUsuario) {
        case 'A':
            this.isAluno = true;
            break;
        case 'a':
            // aluno cuja inscrio ainda no foi aceita; No implementado.
            break;
        case 'r':
            this.isExAluno = true;
            break;
        case 'F':
            this.isFormador = true;
            break;
        case 'f':
            // formador que foi desligado do curso.
            this.isExFormador = true;
            break;
        case 'Z':
        case 'z':
            this.isConvidado = true;
            break;
        case 'V':
            this.isVisitante = true;
            break;
        }
    }

    /**
     *
     */
    private Usuario() {
        super();
    }

    /**
     * @param usuarioId
     * @throws SQLException
     * @throws DBException
     * @throws IOException
     * @throws SQLException
     * @throws ExtractionException
     */
    public Usuario(Curso curso, int usuarioId) throws DBException, IOException,
            SQLException, ExtractionException {
        this();
        inicializa(curso, usuarioId);
    }

    /**
     * @param curso
     * @param usuarioId
     * @throws IOException
     * @throws DBException
     * @throws SQLException
     * @throws ExtractionException
     */
    public void inicializa(Curso curso, int usuarioId) throws DBException,
            IOException, SQLException, ExtractionException {
        this.curso = curso;

        ConnectionFactory conFac = ConnectionFactory.getConnectionFactory();
        Connection con = conFac.getConnection(curso.getBaseCurso());
        String sql = "select cod_usuario, nome, rg, email, telefone, endereco, "
                + "cidade, estado, pais, data_nasc, sexo, local_trab, profissao, "
                + "cod_escolaridade, informacoes, tipo_usuario, opcoes, "
                + "data_inscricao, cod_lingua "
                + "from Usuario where cod_usuario = " + usuarioId;
        PreparedStatement ps = con.prepareStatement(sql);
        ResultSet rs = ps.executeQuery();

        if (!rs.next()) {
            throw new ExtractionException("Usuario de id " + usuarioId
                    + "no existe");
        } else {
            this.setId(usuarioId);
            this.setNome(rs.getString("nome"));
            this.setRg(rs.getString("rg") != null ? rs.getString("rg") : "");
            this.setEmail(rs.getString("email"));
            this.setTelefone(rs.getString("telefone") != null ? rs
                    .getString("telefone") : "");
            this.setEndereco(rs.getString("endereco") != null ? rs
                    .getString("endereco") : "");
            this.setCidade(rs.getString("cidade") != null ? rs
                    .getString("cidade") : "");
            this.setEstado(rs.getString("estado") != null ? rs
                    .getString("estado") : "");
            this.setPais(rs.getString("pais") != null ? rs.getString("pais")
                    : "");
            this.setDataNasc(new Date(rs.getLong("data_nasc") * 1000L));
            String sexo = rs.getString("sexo");
            if (sexo != null)
                this.setSexo(rs.getString("sexo").charAt(0));
            else
                this.setSexo('\0');
            this.setLocalTrab(rs.getString("local_trab") != null ? rs
                    .getString("local_trab") : "");
            this.setProfissao(rs.getString("profissao") != null ? rs
                    .getString("profissao") : "");
            this.setEscolaridade(rs.getString("cod_escolaridade") != null ? rs
                    .getString("cod_escolaridade") : "");
            this.setInformacoes(rs.getString("informacoes") != null ? rs
                    .getString("informacoes") : "");
            this.setTipoUsuario(rs.getString("tipo_usuario").charAt(0));
            this.setDataInscricao(new Date(
                            rs.getLong("data_inscricao") * 1000L));
            this.setLingua(rs.getInt("cod_lingua"));
            this.verificaCoordenador();

        }

    }

    public void atualiza() {
    }

    /**
     * @throws ExtractionException
     *
     */
    private void verificaCoordenador() throws ExtractionException {
        this.isCoordenador = (this.id == verificaCoordenador(this.curso));
    }

    /**
     * Verifica se este usurio  o coordenador do curso
     *
     * @throws ExtractionException
     *
     */
    private static int verificaCoordenador(Curso curso) throws ExtractionException {
        PreparedStatement stmt = null;
        ResultSet         rs   = null;
        try {
            String sql = "select cod_coordenador from Cursos where cod_curso = "
                    + curso.getCodCurso();
            Connection conn = ConnectionFactory.getConnectionFactory()
                    .getConnection(curso.getBaseGeral());
            stmt = conn.prepareStatement(sql);
            rs = stmt.executeQuery();

            if (!rs.next()) {
                throw new ExtractionException(
                        "Erro ao verificar coordenador do curso ["
                                + curso.getCodCurso() + "] "
                                + curso.getNomeCurso());
            } else {
                return rs.getInt("cod_coordenador");
            }
        } catch (IOException ioex) {
            ioex.printStackTrace();
            throw new ExtractionException(
                    "Erro ao verificar coordenador do curso ["
                            + curso.getCodCurso() + "] "
                            + curso.getNomeCurso(), ioex);
        } catch (DBException e) {
            e.printStackTrace();
            throw new ExtractionException(
                    "Erro ao verificar coordenador do curso ["
                            + curso.getCodCurso() + "] "
                            + curso.getNomeCurso(), e);

        } catch (SQLException e) {
            e.printStackTrace();
            throw new ExtractionException(
                    "Erro ao verificar coordenador do curso ["
                            + curso.getCodCurso() + "] "
                            + curso.getNomeCurso(), e);
        } finally {
            if (rs != null) {
                try {
                    rs.close();
                } catch (SQLException ex) {
                    // ignore
                    ex.printStackTrace();
                }
            }
            if (stmt != null) {
                try {
                    stmt.close();
                } catch (SQLException ex) {
                    // ignore
                    ex.printStackTrace();
                }
            }
        }
    }

    /**
     * @return
     */
    public boolean isFormador() {
        return this.isFormador;
    }

    public boolean isAluno() {
        return this.isAluno;
    }

    public boolean isConvidado() {
        return this.isConvidado;
    }

    public boolean isVisitante() {
        return this.isVisitante;
    }

    /**
     * @return Returns the isExAluno.
     */
    public boolean isExAluno() {
        return isExAluno;
    }

    /**
     * @return Returns the isExFormador.
     */
    public boolean isExFormador() {
        return isExFormador;
    }

    public boolean isCoordenador() {
        return isCoordenador;
    }

    public int hashCode() {
        return this.id;
    }

    public boolean equals(Object obj) {
        if (obj instanceof Usuario) {
            Usuario usr = (Usuario) obj;
            return this.id == usr.id;
        }
        return false;
    }

    /**
     * Mtodo da interface Comparable. Compara dois usurios por seus nomes,
     * sem diferenciar maisculas de minsculas.
     *
     * @param Object Usuario com o qual se deseja comparar.
     * @throws ClassCastException se o parmetro no for da classe Usuario
     * @return positivo, zero ou negativo, se o nome do usurio parmetro vier
     * depois, junto ou antes deste usurio na ordem alfabtica.
     */
    public int compareTo(Object obj) {
        Usuario usr = (Usuario) obj;
        return this.nome.compareToIgnoreCase(usr.nome);
    }

    /**
     * @return Returns the curso.
     */
    public Curso getCurso() {
        return curso;
    }
    /**
     * @param curso The curso to set.
     */
    public void setCurso(Curso curso) {
        this.curso = curso;
    }
}