/*
 * Created on Aug 17, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.unicamp.nied.teleduc.transformador;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.apache.velocity.tools.generic.DateTool;

import br.unicamp.nied.teleduc.extrator.config.Config;
import br.unicamp.nied.teleduc.extrator.curso.Curso;
import br.unicamp.nied.teleduc.extrator.ferramentas.ArquivoTool;
import br.unicamp.nied.teleduc.extrator.ferramentas.HTMLTool;
import br.unicamp.nied.teleduc.extrator.usuario.Usuario;

/**
 * @author leonel
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
abstract public class Transform {
    protected Curso curso;
    protected Usuario usuario;
    protected String dirExtracao;

    public Transform(Curso curso, Usuario usuario, String nomeFerramenta) throws IOException {
        this.curso       = curso;
        this.usuario     = usuario;
        this.dirExtracao = montaCaminhoHTML(nomeFerramenta);
    }

    abstract public void geraArquivosHTML() throws Exception;

    protected String montaCaminho(Curso curso, Usuario usuario, String ferramenta)
            throws IOException {
        throw new UnsupportedOperationException("Transform em montaCaminho()");
//        String caminho = ArquivoTool.montaCaminhoDestino(curso, usuario);
//        caminho += "/html/" + ferramenta;
//        return caminho;
    }

    protected VelocityEngine createVelocityEngine() throws IOException, Exception {
        VelocityEngine ve = new VelocityEngine();
        ve.init(Config.getConfig().getProperties());
        return ve;
    }

    /**
     * @return
     */
    protected VelocityContext createVelocityContext() {
        VelocityContext context = new VelocityContext();
        context.put("curso", this.curso);
        context.put("usuario", this.usuario);
        context.put("datetool", new DateTool());
        context.put("htmltool", new HTMLTool());
        return context;
    }

    protected String montaCaminhoHTML(String ferramenta) throws IOException {
        String caminho = montaCaminho();
        String caminhoHTML = caminho + "/html/" + ferramenta;
        File f = new File(caminhoHTML);
        if (! f.exists()) {
            f.mkdirs();
        }
        return caminhoHTML;
    }

    /**
     * @param fileName
     * @return
     * @throws IOException
     */
    protected Writer createWriter(String fileName) throws IOException {
        File f = createFile(fileName);
        Writer writer = new BufferedWriter(new FileWriter(f));
        return writer;
    }

    // -------------------------------------------------------------------------

    protected String montaCaminho() throws IOException {
//        Config config = Config.getConfig();
//        String dirExtracao = (String) config.getProperties().get("extract.outputPath");
//        String caminho =
//            dirExtracao + "/" +
//            // evitar nome de curso vazio: na falta de nome, coloque um sublinhado '_'
//            (this.curso.getNomeCurso().equals("") ? "_" : this.curso.getNomeCurso().replace('/', '_'))
//            + "/" +
//            // evitar nome de usuario vazio
//            (this.usuario.getNome().equals("") ? "_" : this.usuario.getNome().replace('/', '_'));

        String caminho = ArquivoTool.montaCaminhoDestino(this.curso, this.usuario);
        return caminho;
    }

    /**
     * @param string
     * @return
     * @throws IOException
     */
    private File createFile(String filename) throws IOException {
        File f = new File(filename);
        if (f.exists()) {
            f.delete();
        }
        f.createNewFile();
        return f;
    }

    protected void mergeTemplate(Template template, VelocityContext context,
            Writer writer) throws IOException, ResourceNotFoundException,
            ParseErrorException, MethodInvocationException, Exception {
        try {
            template.merge(context, writer);
        } finally {
            try {
                writer.flush();
                writer.close();
            } catch (IOException ioex) {
                ioex.printStackTrace();
            }
        }
    }
}
