#!/bin/bash

# Script para zipar o curso extraido ja com todas as figuras e bibliotecas necessarias do teleduc
# Obs: As figuras e bibliotecas devem estar no diretorio padrao de instalacao

# Parametros:
# $1 - Caminho do Teleduc
# $2 - Caminho do Curso Extraido

# $nome_curso - Nome do curso extraido
ls $2 > /tmp/diretorio
nome_curso=`head -1 /tmp/diretorio`

# $nome_usuario - Nome do usuario para o qual o curso foi extraido
ls $2/$nome_curso > /tmp/diretorio
nome_usuario=`head -1 /tmp/diretorio`

rm /tmp/diretorio

# Estamos copiando a pagina de estrutura estatica do teleduc para o curso extraido
mkdir $2/$nome_curso/$nome_usuario/html/estrutura/

cp $1/cursos/aplic/extracao/estrutura/index.html $2/$nome_curso/$nome_usuario/html/estrutura/

cp $1/cursos/aplic/extracao/estrutura/gpl.txt $2/$nome_curso/$nome_usuario/html/estrutura/

# Copiamos o arquivo de ajuda do extrator
cp $1/cursos/aplic/extracao/LEIAME.txt $2/$nome_curso/

# Deve-se notar que as figuras do teleduc estao todas em diretorios diferentes. Portanto
# copiaremos cada figura do teleduc uma a uma
mkdir $2/$nome_curso/$nome_usuario/figuras/

cp $1/cursos/aplic/figuras/* $2/$nome_curso/$nome_usuario/figuras/

cp $1/cursos/aplic/*.gif $2/$nome_curso/$nome_usuario/figuras/

cp $1/cursos/aplic/portfolio/figuras/* $2/$nome_curso/$nome_usuario/figuras/

cp $1/cursos/aplic/administracao/*.gif $2/$nome_curso/$nome_usuario/figuras/

# Agora copiamos as bibliotecas que serao usadas no curso extraido
mkdir $2/$nome_curso/$nome_usuario/bibliotecas/

cp $1/cursos/aplic/bibliotecas/dhtmllib.js $2/$nome_curso/$nome_usuario/bibliotecas/

# Movemos o index para ser de facil acesso para o usuario
mv $2/$nome_curso/$nome_usuario/html/menu/index.html $2/$nome_curso/$nome_usuario/html/

# Estamos zipando o curso para ser feito download
cd $2

zip -r /tmp/teleduc_extracao-$3-$4 *

exit
